      SUBROUTINE DSPTXT(CTXT,NTEXT)
C     ******************************************************************
C     This routine displays text in the current window
C     ******************************************************************
      USE WINTERACTER
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) CTXT(NTEXT)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CTXT  - Text to be added to screen
C     NTEXT - Number of strings in CTXT
C     ------------------------------------------------------------------
C
C  Determine line spacing in Winteracter units
      IH=WInfoFont(FontHeight)
C  Start first line one line down
      IY=IH*2
      DO 10 I=1,NTEXT
      CALL WINDOWOUTSTRING(500,IY,CTXT(I))
      IY=IY+IH
10    CONTINUE
C
C
      RETURN
      END
      SUBROUTINE TXTLOG(CTXT,NTEXT)
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C     ******************************************************************
C     This routine displays text in a popup window
C     ******************************************************************
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) CTXT(NTEXT)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CTXT  - Text to be added to screen
C     NTEXT - Number of strings in CTXT
C
      CHARACTER*20000 TEXT
      TYPE(WIN_MESSAGE)   :: MESSAGE
C     ------------------------------------------------------------------
      CALL WDialogLoad(TXTLOG_DIALOG)
      NC=1
      DO 20 I=1,NTEXT
      DO 10 J=1,IActualLength(CTXT(I))
      IF(NC.LE.20000) THEN
         TEXT(NC:NC)=CTXT(I)(J:J)
         NC=NC+1
      END IF
10    CONTINUE
      IF(NC.LE.19999) THEN
         TEXT(NC:NC+1)=CHAR(13)//CHAR(10)
         NC=NC+2
      END IF
20    CONTINUE
C
      NC=NC-1
      CALL WDialogPut String(TXTLOG_DIALOG_STRING,TEXT(1:NC))
      CALL WDialogShow(-1,50,0,Modal)
      CALL WDialogUnload(TXTLOG_DIALOG)
C
      RETURN
      END
      SUBROUTINE U3DIN(LABEL,ARRNAM,NCC,NR,IUPACK,NL)
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C     ******************************************************************
C     Prompt user for a 3-D array
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      CHARACTER*(*) LABEL
      CHARACTER*(*) ARRNAM
      CHARACTER*78 CLINE
      CHARACTER*67 FNAME
      CHARACTER*20 FMT
      CHARACTER*4 CLAY(200)
C     ------------------------------------------------------------------
      NC=NCC
      IF(NCC.LT.0) NC=-NCC
      IREAL=1
      IF(ARRNAM(1:1).EQ.'I') IREAL=0
C
C  Load the 3D-array dialog
      CALL WDialogLoad(ARRAY_DIALOG)
      CALL WMessageEnable(FieldChanged,Enabled)
C
C  Initialize values
C  Label the array being edited.
      CLINE='Defining values for array '//LABEL
      CALL WDialogPutString(ARRAY_NAME,CLINE)
C  Make a list of layer numbers.
      DO 20 K=1,NL
      WRITE(CLAY(K),'(I4)') K
20    CONTINUE
      K=1
      CALL WDialogPutMenu(ARRAY_LAYER,CLAY,NL,K)
C  
C  Find array -- create if it doesn't already exist
25    CALL VALGET(ARRNAM,K,0,NAR,V)
      IF(NAR.LE.0) THEN
         CALL ARRMAK(ARRNAM,K,0,NC,NR)
         NAR=NARRAY
         IF(IREAL.EQ.0) IARRDA(5,NAR)=4
      END IF
C  Define defaults
      IATYPE=1
      CON1=0.
      CON2=1.
      CON3=1.
      FMT='(10F8.0)'
      IF(IREAL.EQ.0) FMT='(20I4)'
      FNAME=' '
      IFTYP=1   ! 1=File Name, 2=OPEN/CLOSE
      IPRN=0
      IF(IREAL.EQ.0) IPRN=4
      LOCAT=IARRDA(1,NAR)
      IF(LOCAT.EQ.0) THEN
         IF(IREAL.EQ.0) THEN
            ITMP=ARRCON(NAR)
            IF(ITMP.NE.IMISS) CON1=ARRCON(NAR)
         ELSE
            IF(ARRCON(NAR) .NE. RMISS) CON1=ARRCON(NAR)
         END IF
         CON2=1.
         CON3=CON2
      ELSE IF(LOCAT.EQ.-1) THEN
         IATYPE=2
         CON2=ARRCON(NAR)
         CON1=CON2
         CON3=CON2
      ELSE IF(LOCAT.GT.0) THEN
         IATYPE=3
         CON3=ARRCON(NAR)
         CON1=CON3
         CON2=CON3
         FMT=ARRFMT(NAR)
         FNAME=FILNAM(LOCAT)
         IPRN=IARRDA(5,NAR)
         IF(FILTYP(LOCAT)(1:10).EQ.'OPEN/CLOSE') IFTYP=2
      END IF
C
C  Set current values for array
30    IF(IATYPE.EQ.1) THEN
         CALL WDialogPutRadioButton(ARRAY_TYPE_CONSTANT)
         CALL WDialogFieldState(ARRAY_CONSTANT,Enabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER,Disabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER2,Disabled)
         CALL WDialogFieldState(ARRAY_IPRN,Disabled)
         CALL WDialogFieldState(ARRAY_FORMAT,Disabled)
         CALL WDialogFieldState(ARRAY_FILE,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(ARRAY_FILE_TYPE,Disabled)
         CALL WDialogFieldState(ARRAY_SPREADSHEET,Disabled)
         CALL WDialogFieldState(ARRAY_GRID,Disabled)
      ELSE IF(IATYPE.EQ.2) THEN
         CALL WDialogPutRadioButton(ARRAY_TYPE_PACKAGE)
         CALL WDialogFieldState(ARRAY_CONSTANT,Disabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER,Enabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER2,Disabled)
         CALL WDialogFieldState(ARRAY_IPRN,Disabled)
         CALL WDialogFieldState(ARRAY_FORMAT,Disabled)
         CALL WDialogFieldState(ARRAY_FILE,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(ARRAY_FILE_TYPE,Disabled)
         CALL WDialogFieldState(ARRAY_SPREADSHEET,Enabled)
         IF(NC.GT.100 .OR. NR.GT.100) THEN
            CALL WDialogFieldState(ARRAY_GRID,Disabled)
         ELSE
            CALL WDialogFieldState(ARRAY_GRID,Enabled)
         END IF
      ELSE
         CALL WDialogPutRadioButton(ARRAY_TYPE_SEPARATE)
         CALL WDialogFieldState(ARRAY_CONSTANT,Disabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER,Disabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER2,Enabled)
         CALL WDialogFieldState(ARRAY_IPRN,Enabled)
         CALL WDialogFieldState(ARRAY_FORMAT,Enabled)
         CALL WDialogFieldState(ARRAY_FILE,Enabled)
         CALL WDialogFieldState(FILE_BROWSE,Enabled)
         CALL WDialogFieldState(ARRAY_FILE_TYPE,Enabled)
         CALL WDialogFieldState(ARRAY_SPREADSHEET,Disabled)
         CALL WDialogFieldState(ARRAY_GRID,Disabled)
      END IF
      CALL WDialogPutInteger(ARRAY_IPRN,IPRN)
      CALL WDialogPutReal(ARRAY_CONSTANT,CON1,'(1PG13.6)')
      CALL WDialogPutReal(ARRAY_MULTIPLIER,CON2,'(1PG13.6)')
      CALL WDialogPutReal(ARRAY_MULTIPLIER2,CON3,'(1PG13.6)')
      CALL WDialogPutString(ARRAY_FORMAT,FMT)
      CALL WDialogPutString(ARRAY_FILE,FNAME)
      CALL WDialogPutOption(ARRAY_FILE_TYPE,IFTYP)
C
C  Make Array Dialog visible
      CALL WDialogShow(-1,50,0,SemiModeless)
50    CALL WMessage(ITYPE,MESSAGE)
C
C  Act upon field changes
      IF(ITYPE.EQ.FieldChanged) THEN
C
C  Check for layer change
         CALL WDialogGetMenu(ARRAY_LAYER,KNEW)
         IF(KNEW.NE.K) THEN
            CALL U3DINGET(NAR,IUPACK,IERR)
            CALL WDialogSelect(ARRAY_DIALOG)
            IF(IERR.NE.0) GO TO 25
            K=KNEW
            GO TO 25
         END IF
C
C  Check for array type change
         CALL WDialogGetRadioButton(ARRAY_TYPE_CONSTANT,IATNEW)
         IF(IATNEW.NE.IATYPE) THEN
            IATYPE=IATNEW
            IF(IATYPE.EQ.2 .AND. IARRDA(2,NAR).EQ.0) THEN
               CALL ARRALO(IARRDA(2,NAR),IARRDA(3,NAR),IARRDA(4,NAR))
               LOC=IARRDA(2,NAR)
               IF(IREAL.NE.0) THEN
                  CALL ZIPR(NC*NR,0.,X(LOC))
C                  IF(NCC.GT.0) CALL SS2DR(X(LOC),NC,NR,ARRNAM,
C     1                               ARRAY_DIALOG)
               ELSE
                  CALL ZIPI(NC*NR,1,IX(LOC))
C                  IF(NCC.GT.0) CALL SS2DI(IX(LOC),NC,NR,ARRNAM,
C     1                               ARRAY_DIALOG)
               END IF
               CALL WMessageEnable(FieldChanged,Enabled)
               CALL WDialogSelect(ARRAY_DIALOG)
            END IF
            GO TO 30
         END IF
C
C  Check for push buttons
      ELSE IF(ITYPE.EQ.PushButton) THEN
C
C  Check for ARRAY_SPREADSHEET
         IF(MESSAGE%VALUE1.EQ.ARRAY_SPREADSHEET) THEN
            IF(NCC.GT.0) THEN
               LOC=IARRDA(2,NAR)
               IF(IREAL.NE.0) CALL SS2DR(X(LOC),NC,NR,ARRNAM,
     1                     ARRAY_DIALOG)
               IF(IREAL.EQ.0) CALL SS2DI(IX(LOC),NC,NR,ARRNAM,
     1                     ARRAY_DIALOG)
               CALL WMessageEnable(FieldChanged,Enabled)
               CALL WDialogSelect(ARRAY_DIALOG)
            END IF
C
C  Check for ARRAY_GRID
         ELSE IF(MESSAGE%VALUE1.EQ.ARRAY_GRID) THEN
            IF(NCC.GT.0 .AND. NC.LE.100 .AND. NR.LE.100) THEN
               LOC=IARRDA(2,NAR)
               IF(IREAL.NE.0) CALL SS2DRG(X(LOC),NC,NR,ARRNAM,
     1                     ARRAY_DIALOG)
               IF(IREAL.EQ.0) CALL SS2DIG(IX(LOC),NC,NR,ARRNAM,
     1                     ARRAY_DIALOG)
               CALL WMessageEnable(FieldChanged,Enabled)
               CALL WDialogSelect(ARRAY_DIALOG)
            END IF
C
C  Check for Browse
         ELSE IF(MESSAGE%VALUE1.EQ.FILE_BROWSE) THEN
            CALL BROWSE(FNAME)
            CALL WDialogSelect(ARRAY_DIALOG)
            GO TO 30
C
C  Check for OK
         ELSE IF(MESSAGE%VALUE1.EQ.ARRAY_DIALOG_IDOK) THEN
            CALL U3DINGET(NAR,IUPACK,IERR)
            CALL WDialogSelect(ARRAY_DIALOG)
            IF(IERR.NE.0) GO TO 50
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(ARRAY_DIALOG)
            RETURN
C
C  Check for CANCEL
         ELSE IF(MESSAGE%VALUE1.EQ.IDCANCEL) THEN
C  Exit without storing values
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(ARRAY_DIALOG)
            RETURN
         END IF
C
C  Ignore all other types of message
      END IF
      GO TO 50
C
      END
      SUBROUTINE U3DINGET(NAR,IUPACK,IERR)
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C     ******************************************************************
C     Retrieve and store values for a 3-D array
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      CHARACTER*67 FNAME
      CHARACTER*20 FMT
C     ------------------------------------------------------------------
      IERR=0
      CALL WDialogGetRadioButton(ARRAY_TYPE_CONSTANT,IATNEW)
      IF(IATNEW.EQ.1) THEN
         IARRDA(1,NAR)=0
         CALL WDialogGetReal(ARRAY_CONSTANT,CON1)
         ARRCON(NAR)=CON1
      ELSE IF(IATNEW.EQ.2) THEN
         IARRDA(1,NAR)=-1
         CALL WDialogGetReal(ARRAY_MULTIPLIER,CON2)
         ARRCON(NAR)=CON2
      ELSE IF(IATNEW.EQ.3) THEN
         CALL WDialogGetString(ARRAY_FILE,FNAME)
         CALL USTLFT(FNAME,67)
         IF(IUCASE.NE.0) CALL USTRUC(FNAME,67)
         CALL WDialogGetMenu(ARRAY_FILE_TYPE,IFTYP)
         CALL WDialogGetString(ARRAY_FORMAT,FMT)
         CALL FMTCHK(FMT,IERR)
         IF(IERR.NE.0) RETURN
         ARRFMT(NAR)=FMT
         IF(FMT.EQ.'(BINARY)') THEN
            CALL FNMSV2(FNAME,IU,0,IUPACK,NAR,IFTYP)
         ELSE
            CALL FNMSV2(FNAME,IU,1,IUPACK,NAR,IFTYP)
         END IF
         IF(IU.LE.0) THEN
            IERR=1
            RETURN
         END IF
         IARRDA(1,NAR)=IU
         CALL WDialogGetReal(ARRAY_MULTIPLIER2,CON3)
         ARRCON(NAR)=CON3
         CALL WDialogGetInteger(ARRAY_IPRN,IPRN)
         IARRDA(5,NAR)=IPRN
      END IF
C
      RETURN
      END
      SUBROUTINE U2DIN(LABEL,ARRNAM,NCC,NR,IUPACK,MLAY,MPER)
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C     ******************************************************************
C     Prompt user for a 2-D array
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      CHARACTER*(*) LABEL
      CHARACTER*(*) ARRNAM
      CHARACTER*90 CLINE
      CHARACTER*67 FNAME
      CHARACTER*20 FMT
      CHARACTER*4 CLAY(200)
C     ------------------------------------------------------------------
      NC=NCC
      IF(NCC.LT.0) NC=-NCC
      IREAL=1
      IF(ARRNAM(1:1).EQ.'I') IREAL=0
C
C  Load the 2D-array dialog
      CALL WDialogLoad(ARRAY2D_DIALOG)
      CALL WMessageEnable(FieldChanged,Enabled)
C
C  Initialize values
C  Label the array being edited.
      CLINE='Defining values for array '//LABEL
      CALL WDialogPutString(ARRAY2D_NAME,CLINE)
C  
C  Find array -- create if it doesn't already exist
      CALL VALGET(ARRNAM,MLAY,MPER,NAR,V)
      IF(NAR.LE.0) THEN
         CALL ARRMAK(ARRNAM,MLAY,MPER,NC,NR)
         NAR=NARRAY
         IF(IREAL.EQ.0) IARRDA(5,NAR)=4
      END IF
C  Define defaults
      IATYPE=1
      CON1=0.
      CON2=1.
      CON3=1.
      FMT='(10F8.0)'
      IF(IREAL.EQ.0) FMT='(20I4)'
      FNAME=' '
      IFTYP=1   ! 1=File Name, 2=OPEN/CLOSE
      IPRN=0
      IF(IREAL.EQ.0) IPRN=4
      LOCAT=IARRDA(1,NAR)
      IF(LOCAT.EQ.0) THEN
         IF(IREAL.EQ.0) THEN
            ITMP=ARRCON(NAR)
            IF(ITMP.NE.IMISS) CON1=ARRCON(NAR)
         ELSE
            IF(ARRCON(NAR) .NE. RMISS) CON1=ARRCON(NAR)
         END IF
         CON2=1.
         CON3=CON2
      ELSE IF(LOCAT.EQ.-1) THEN
         IATYPE=2
         CON2=ARRCON(NAR)
         CON1=CON2
         CON3=CON2
      ELSE IF(LOCAT.GT.0) THEN
         IATYPE=3
         CON3=ARRCON(NAR)
         CON1=CON3
         CON2=CON3
         FMT=ARRFMT(NAR)
         FNAME=FILNAM(LOCAT)
         IPRN=IARRDA(5,NAR)
         IF(FILTYP(LOCAT)(1:10).EQ.'OPEN/CLOSE') IFTYP=2
      END IF
C
C  Set current values for array
30    IF(IATYPE.EQ.1) THEN
         CALL WDialogPutRadioButton(ARRAY2D_TYPE_CONSTANT)
         CALL WDialogFieldState(ARRAY2D_CONSTANT,Enabled)
         CALL WDialogFieldState(ARRAY2D_MULTIPLIER,Disabled)
         CALL WDialogFieldState(ARRAY2D_MULTIPLIER2,Disabled)
         CALL WDialogFieldState(ARRAY2D_IPRN,Disabled)
         CALL WDialogFieldState(ARRAY2D_FORMAT,Disabled)
         CALL WDialogFieldState(ARRAY2D_FILE,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(ARRAY2D_FILE_TYPE,Disabled)
         CALL WDialogFieldState(ARRAY2D_SPREADSHEET,Disabled)
         CALL WDialogFieldState(ARRAY2D_GRID,Disabled)
      ELSE IF(IATYPE.EQ.2) THEN
         CALL WDialogPutRadioButton(ARRAY2D_TYPE_PACKAGE)
         CALL WDialogFieldState(ARRAY2D_CONSTANT,Disabled)
         CALL WDialogFieldState(ARRAY2D_MULTIPLIER,Enabled)
         CALL WDialogFieldState(ARRAY2D_MULTIPLIER2,Disabled)
         CALL WDialogFieldState(ARRAY2D_IPRN,Disabled)
         CALL WDialogFieldState(ARRAY2D_FORMAT,Disabled)
         CALL WDialogFieldState(ARRAY2D_FILE,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(ARRAY2D_FILE_TYPE,Disabled)
         CALL WDialogFieldState(ARRAY2D_SPREADSHEET,Enabled)
         IF(NC.GT.100 .OR. NR.GT.100) THEN
            CALL WDialogFieldState(ARRAY2D_GRID,Disabled)
         ELSE
            CALL WDialogFieldState(ARRAY2D_GRID,Enabled)
         END IF
      ELSE
         CALL WDialogPutRadioButton(ARRAY2D_TYPE_SEPARATE)
         CALL WDialogFieldState(ARRAY2D_CONSTANT,Disabled)
         CALL WDialogFieldState(ARRAY2D_MULTIPLIER,Disabled)
         CALL WDialogFieldState(ARRAY2D_MULTIPLIER2,Enabled)
         CALL WDialogFieldState(ARRAY2D_IPRN,Enabled)
         CALL WDialogFieldState(ARRAY2D_FORMAT,Enabled)
         CALL WDialogFieldState(ARRAY2D_FILE,Enabled)
         CALL WDialogFieldState(FILE_BROWSE,Enabled)
         CALL WDialogFieldState(ARRAY2D_FILE_TYPE,Enabled)
         CALL WDialogFieldState(ARRAY2D_SPREADSHEET,Disabled)
         CALL WDialogFieldState(ARRAY2D_GRID,Disabled)
      END IF
      CALL WDialogPutInteger(ARRAY2D_IPRN,IPRN)
      CALL WDialogPutReal(ARRAY2D_CONSTANT,CON1,'(1PG13.6)')
      CALL WDialogPutReal(ARRAY2D_MULTIPLIER,CON2,'(1PG13.6)')
      CALL WDialogPutReal(ARRAY2D_MULTIPLIER2,CON3,'(1PG13.6)')
      CALL WDialogPutString(ARRAY2D_FORMAT,FMT)
      CALL WDialogPutString(ARRAY2D_FILE,FNAME)
      CALL WDialogPutOption(ARRAY2D_FILE_TYPE,IFTYP)
C
C  Make Array Dialog visible
      CALL WDialogShow(-1,50,0,SemiModeless)
50    CALL WMessage(ITYPE,MESSAGE)
C  Act upon field changes
      IF(ITYPE.EQ.FieldChanged) THEN
C
C  Check for array type change
         CALL WDialogGetRadioButton(ARRAY2D_TYPE_CONSTANT,IATNEW)
         IF(IATNEW.NE.IATYPE) THEN
            IATYPE=IATNEW
            IF(IATYPE.EQ.2 .AND. IARRDA(2,NAR).EQ.0) THEN
               CALL ARRALO(IARRDA(2,NAR),IARRDA(3,NAR),IARRDA(4,NAR))
               LOC=IARRDA(2,NAR)
               IF(IREAL.NE.0) THEN
                  CALL ZIPR(NC*NR,0.,X(LOC))
C                  IF(NCC.GT.0) CALL SS2DR(X(LOC),NC,NR,ARRNAM,
C     1                     ARRAY2D_DIALOG)
               ELSE
                  CALL ZIPI(NC*NR,1,IX(LOC))
C                  IF(NCC.GT.0) CALL SS2DI(IX(LOC),NC,NR,ARRNAM,
C     1                     ARRAY2D_DIALOG)
               END IF
               CALL WMessageEnable(FieldChanged,Enabled)
               CALL WDialogSelect(ARRAY2D_DIALOG)
            END IF
            GO TO 30
         END IF
C
C  Check for push buttons
      ELSE IF(ITYPE.EQ.PushButton) THEN
C
C  Check for ARRAY2D_SPREADSHEET
         IF(MESSAGE%VALUE1.EQ.ARRAY2D_SPREADSHEET) THEN
            IF(NCC.GT.0) THEN
               LOC=IARRDA(2,NAR)
               IF(IREAL.NE.0) CALL SS2DR(X(LOC),NC,NR,ARRNAM,
     1                  ARRAY2D_DIALOG)
               IF(IREAL.EQ.0) CALL SS2DI(IX(LOC),NC,NR,ARRNAM,
     1                  ARRAY2D_DIALOG)
               CALL WMessageEnable(FieldChanged,Enabled)
               CALL WDialogSelect(ARRAY2D_DIALOG)
            END IF
C
C  Check for ARRAY2D_GRID
         ELSE IF(MESSAGE%VALUE1.EQ.ARRAY2D_GRID) THEN
            IF(NCC.GT.0 .AND. NC.LE.100 .AND. NR.LE.100) THEN
               LOC=IARRDA(2,NAR)
               IF(IREAL.NE.0) CALL SS2DRG(X(LOC),NC,NR,ARRNAM,
     1                  ARRAY2D_DIALOG)
               IF(IREAL.EQ.0) CALL SS2DIG(IX(LOC),NC,NR,ARRNAM,
     1                  ARRAY2D_DIALOG)
               CALL WMessageEnable(FieldChanged,Enabled)
               CALL WDialogSelect(ARRAY2D_DIALOG)
            END IF
C
C  Check for Browse
         ELSE IF(MESSAGE%VALUE1.EQ.FILE_BROWSE) THEN
            CALL BROWSE(FNAME)
            CALL WDialogSelect(ARRAY2D_DIALOG)
            GO TO 30
C
C  Check for OK
         ELSE IF(MESSAGE%VALUE1.EQ.IDOK) THEN
            CALL WDialogGetRadioButton(ARRAY2D_TYPE_CONSTANT,IATNEW)
            IF(IATNEW.EQ.1) THEN
               IARRDA(1,NAR)=0
               CALL WDialogGetReal(ARRAY2D_CONSTANT,CON1)
               ARRCON(NAR)=CON1
            ELSE IF(IATNEW.EQ.2) THEN
               IARRDA(1,NAR)=-1
               CALL WDialogGetReal(ARRAY2D_MULTIPLIER,CON2)
               ARRCON(NAR)=CON2
            ELSE IF(IATNEW.EQ.3) THEN
               CALL WDialogGetString(ARRAY2D_FILE,FNAME)
               CALL USTLFT(FNAME,67)
               IF(IUCASE.NE.0) CALL USTRUC(FNAME,67)
               CALL WDialogGetMenu(ARRAY2D_FILE_TYPE,IFTYP)
               CALL WDialogGetString(ARRAY2D_FORMAT,FMT)
               CALL FMTCHK(FMT,IERR)
               IF(IERR.NE.0) GO TO 50
               ARRFMT(NAR)=FMT
               IF(FMT.EQ.'(BINARY)') THEN
                  CALL FNMSV2(FNAME,IU,0,IUPACK,NAR,IFTYP)
               ELSE
                  CALL FNMSV2(FNAME,IU,1,IUPACK,NAR,IFTYP)
               END IF
               IF(IU.LE.0) THEN
                  GO TO 50
                  RETURN
               END IF
               IARRDA(1,NAR)=IU
               CALL WDialogGetReal(ARRAY2D_MULTIPLIER2,CON3)
               ARRCON(NAR)=CON3
               CALL WDialogGetInteger(ARRAY2D_IPRN,IPRN)
               IARRDA(5,NAR)=IPRN
            END IF
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(ARRAY2D_DIALOG)
            RETURN
C
C  Check for CANCEL
         ELSE IF(MESSAGE%VALUE1.EQ.IDCANCEL) THEN
C  Exit without storing values
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(ARRAY2D_DIALOG)
            RETURN
         END IF
C
C  Ignore all other types of message
      END IF
      GO TO 50
C
      END
      SUBROUTINE ULSTIN(LABEL,ARRNAM,NMFLOW,CAUX,NCAUX,IUPACK,CPACK,PT,
     1       IULOC,PLABL)
C     ******************************************************************
C     Interface for editing a list
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      CHARACTER*16 CAUX(NCAUX)
      CHARACTER*(*) LABEL(NMFLOW,2),PLABL(NMFLOW,2),CPACK,ARRNAM,PT
      CHARACTER*78 CLINE
      CHARACTER*4 CPER(MXPER)
      CHARACTER*20 LSTPAR(200)
      CHARACTER*10 CTMP,PN
      CHARACTER*67 FNAME
      CHARACTER*10 CLTYPE(1)
      CHARACTER*5 CNLST
C     ------------------------------------------------------------------
      LSTDIM=NMFLOW+NCAUX
      FNAME=' '
      IPSEL=1
C
C  Load the List dialog
      CALL WDialogLoad(LIST_DIALOG)
      CALL WMessageEnable(FieldChanged,Enabled)
C
C  Label the array being edited.
      CLINE='Defining values for '//CPACK
      CALL WDialogPutString(LIST_NAME,CLINE)
C
C  Make a list of stress period numbers.
      DO 20 K=1,NPER
      WRITE(CPER(K),'(I4)') K
20    CONTINUE
      KK=1
      CALL WDialogPutMenu(LIST_PERIOD,CPER,NPER,KK)
C  
C  Find list array -- create if it doesn't already exist
25    CALL IVLGET(ARRNAM,0,KK,NAR,NLIST)
      IFTYP=1
      IF(NAR.LE.0) THEN
         CALL LSTMAK(ARRNAM,0,KK,LSTDIM)
         NAR=NARRAY
         IARRDA(1,NAR)=-2
         ARRCON(NAR)=1.
         NLIST=0
         CALL IVLSAV(ARRNAM,0,KK,NLIST)
      END IF
C  Define method variable for dialog screen
      NLSEP=IARRDA(5,NAR)
      IF(IARRDA(1,NAR).GT.0) THEN
         INTLST=0
         IATYPE=4
         FNAME=FILNAM(IARRDA(1,NAR))
         IF(FILTYP(IARRDA(1,NAR)).EQ.'OPEN/CLOSE') IFTYP=2
      ELSE IF(NLIST.EQ.IMISS) THEN
         INTLST=0
         IATYPE=3
      ELSE IF(NLIST.LT.0 .AND. KK.GT.1) THEN
         INTLST=0
         IATYPE=2
      ELSE IF(NLIST.EQ.0) THEN
         INTLST=0
         IATYPE=1
      ELSE
         INTLST=NLIST
         IATYPE=3
      END IF
C
C  Set current values for array
30    IF(KK.EQ.1) THEN
         CALL WDialogFieldState(LIST_PREVIOUS,Disabled)
      ELSE
         CALL WDialogFieldState(LIST_PREVIOUS,Enabled)
      END IF
      IF(IATYPE.EQ.1) THEN
         CALL WDialogPutRadioButton(LIST_NONE)
         CALL WDialogFieldState(LIST_SPREADSHEET,Disabled)
         CALL WDialogFieldState(LIST_GRID,Disabled)
         CALL WDialogFieldState(LIST_MULTIPLIER,Disabled)
         CALL WDialogFieldState(LIST_SEPARATE_NAME,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(SEPARATE_NLIST,Disabled)
         CALL WDialogFieldState(LIST_FILE_TYPE,Disabled)
      ELSE IF(IATYPE.EQ.2) THEN
         CALL WDialogPutRadioButton(LIST_PREVIOUS)
         CALL WDialogFieldState(LIST_SPREADSHEET,Disabled)
         CALL WDialogFieldState(LIST_GRID,Disabled)
         CALL WDialogFieldState(LIST_MULTIPLIER,Disabled)
         CALL WDialogFieldState(LIST_SEPARATE_NAME,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(SEPARATE_NLIST,Disabled)
         CALL WDialogFieldState(LIST_FILE_TYPE,Disabled)
      ELSE IF(IATYPE.EQ.3) THEN
         CALL WDialogPutRadioButton(LIST_PACKAGE)
         CALL WDialogFieldState(LIST_SPREADSHEET,Enabled)
         IF(NLIST.GT.100) THEN
            CALL WDialogFieldState(LIST_GRID,Disabled)
         ELSE
            CALL WDialogFieldState(LIST_GRID,Enabled)
         END IF
         CALL WDialogFieldState(LIST_MULTIPLIER,Enabled)
         CALL WDialogFieldState(LIST_SEPARATE_NAME,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(SEPARATE_NLIST,Disabled)
         CALL WDialogFieldState(LIST_FILE_TYPE,Disabled)
      ELSE
         CALL WDialogPutRadioButton(LIST_SEPARATE)
         CALL WDialogFieldState(LIST_SPREADSHEET,Disabled)
         CALL WDialogFieldState(LIST_GRID,Disabled)
         CALL WDialogFieldState(LIST_MULTIPLIER,Disabled)
         CALL WDialogFieldState(LIST_SEPARATE_NAME,Enabled)
         CALL WDialogFieldState(FILE_BROWSE,Enabled)
         CALL WDialogFieldState(SEPARATE_NLIST,Enabled)
         CALL WDialogFieldState(LIST_FILE_TYPE,Enabled)
      END IF
      CALL WDialogPutReal(LIST_MULTIPLIER,ARRCON(NAR),'(1PG13.6)')
      CALL WDialogPutInteger(LIST_INTERNAL_NLIST,INTLST)
      CALL WDialogPutString(LIST_SEPARATE_NAME,FNAME)
      Call WDialogPutOption(LIST_FILE_TYPE,IFTYP)
      CALL WDialogPutInteger(SEPARATE_NLIST,NLSEP)
C
C  Make the list of parameters
2     NP=0
      IF(IPSUM.GT.0) THEN
         DO 5 I=1,IPSUM
         IF(PARTYP(I).EQ.PT) THEN
C  Find number of list entries
            CTMP=PARNAM(I)
            CALL UPCASE(CTMP)
            CALL IVLGET(CTMP,-3,-3,NARP,NL)
            IF(IARRDA(1,NARP).GT.0) NL=IARRDA(5,NARP)
            WRITE(CNLST,'(I5)') NL
            NP=NP+1
            LSTPAR(NP)=PARNAM(I)//CHAR(9)//'NO  '//CNLST
            DO 45 J=1,MXPERPAR
            IF(PERPARNAM(J).EQ.PARNAM(I).AND.
     1       IPERPARPER(J).EQ.KK)
     2          LSTPAR(NP)(11:20)=CHAR(9)//'YES '//CNLST
45          CONTINUE
         END IF
5        CONTINUE
      END IF
C
      CALL WDialogFieldState(PARAMETER_ADD,Enabled)
      IF(NP.GT.0) THEN
         CALL WDialogFieldState(LIST_PARAMETERS,Enabled)
         CALL WDialogPutMenu(LIST_PARAMETERS,LSTPAR,NP,IPSEL)
         CALL WDialogFieldState(PARAMETER_MODIFY,Enabled)
         CALL WDialogFieldState(PARAMETER_DELETE,Enabled)
         CALL WDialogFieldState(LIST_DEACTIVATE,Enabled)
         CALL WDialogFieldState(LIST_ACTIVATE,Enabled)
      ELSE
         LSTPAR(1)='(None)'
         CALL WDialogPutMenu(LIST_PARAMETERS,LSTPAR,1,1)
         CALL WDialogFieldState(LIST_PARAMETERS,Disabled)
         CALL WDialogFieldState(PARAMETER_MODIFY,Disabled)
         CALL WDialogFieldState(PARAMETER_DELETE,Disabled)
         CALL WDialogFieldState(LIST_DEACTIVATE,Disabled)
         CALL WDialogFieldState(LIST_ACTIVATE,Disabled)
      END IF
C
C  Make List Dialog visible
      CALL WDialogShow(-1,50,0,SemiModeless)
50    CALL WMessage(ITYPE,MESSAGE)
C
C  Act upon field changes
      IF(ITYPE.EQ.FieldChanged) THEN
C
C  Check for stress period change
         CALL WDialogGetMenu(LIST_PERIOD,KNEW)
         IF(KNEW.NE.KK) THEN
            CALL LSTINGET(NAR,IUPACK,ARRNAM,KK,IERR)
            CALL WDialogSelect(LIST_DIALOG)
            IF(IERR.NE.0) GO TO 50
            KK=KNEW
            GO TO 25
         END IF
C
C  Check for list method change
         CALL WDialogGetRadioButton(LIST_NONE,IATNEW)
         IF(IATNEW.NE.IATYPE) THEN
            IATYPE=IATNEW
            GO TO 30
         END IF
C
C  Check for push buttons
      ELSE IF(ITYPE.EQ.PushButton) THEN
C
C  Check for LIST_SPREADSHEET
         IF(MESSAGE%VALUE1.EQ.LIST_SPREADSHEET) THEN
            LOC=IARRDA(2,NAR)
            CALL SSLST(IX(LOC),NLIST,LABEL,NMFLOW,NAR,CAUX,NCAUX,
     1              LIST_DIALOG)
            CALL IVLSAV(ARRNAM,0,KK,NLIST)
            CALL WDialogSelect(LIST_DIALOG)
            CALL WMessageEnable(FieldChanged,Enabled)
            GO TO 25
C
C  Check for LIST_GRID
         ELSE IF(MESSAGE%VALUE1.EQ.LIST_GRID) THEN
            IF(NLIST.GT.100) GO TO 25
            LOC=IARRDA(2,NAR)
            CALL SSLSTG(IX(LOC),NLIST,LABEL,NMFLOW,NAR,CAUX,NCAUX,
     1              LIST_DIALOG)
            CALL IVLSAV(ARRNAM,0,KK,NLIST)
            CALL WDialogSelect(LIST_DIALOG)
            CALL WMessageEnable(FieldChanged,Enabled)
            GO TO 25
C
C  Check for LIST_COMMENT
         ELSE IF(MESSAGE%VALUE1.EQ.LIST_COMMENT) THEN
            CALL COMNTIN(IULOC)
            CALL WDialogSelect(LIST_DIALOG)
            CALL WMessageEnable(FieldChanged,Enabled)
C
C  Check for LIST_ACTIVATE
         ELSE IF(MESSAGE%VALUE1.EQ.LIST_ACTIVATE) THEN
            CALL WDialogGetMenu(LIST_PARAMETERS,IPSEL)
            DO 60 J=1,MXPERPAR
            IF(PERPARNAM(J).EQ.LSTPAR(IPSEL)(1:10) .AND.
     1        IPERPARPER(J).EQ.KK) GO TO 50
60          CONTINUE
            DO 70 I=1,MXPERPAR
            IF(PERPARNAM(I).EQ.' ') THEN
               PERPARNAM(I)=LSTPAR(IPSEL)(1:10)
               IPERPARPER(I)=KK
               PERPARTYP(I)=PT
               GO TO 2
            END IF
70          CONTINUE
            WRITE(IOUT,*) ' MXPERPAR has been exceeded in ULSTIN'
            CALL MFISTP
C
C  Check for LIST_DEACTIVATE
         ELSE IF(MESSAGE%VALUE1.EQ.LIST_DEACTIVATE) THEN
            CALL WDialogGetMenu(LIST_ACTIVE,IPSEL)
            DO 80 I=1,MXPERPAR
            IF(PERPARNAM(I).EQ.LSTPAR(IPSEL)(1:10) .AND.
     1                         IPERPARPER(I).EQ.KK) THEN
               PERPARNAM(I)=' '
               IPERPARPER(I)=0
               PERPARTYP(I)=' '
               GO TO 2
            END IF
80          CONTINUE
C
C  Check for PARAMETER_MODIFY
         ELSE IF(MESSAGE%VALUE1.EQ.PARAMETER_MODIFY) THEN
            CALL WDialogGetMenu(LIST_PARAMETERS,IPSEL)
            CTMP=LSTPAR(IPSEL)(1:10)
            CALL LSTPARMOD(CTMP,IUPACK,CAUX,NCAUX,PLABL,NMFLOW)
            CALL WMessageEnable(FieldChanged,Enabled)
            CALL WDialogSelect(LIST_DIALOG)
            GO TO 2
C
C  Check for PARAMETER_DELETE
         ELSE IF(MESSAGE%VALUE1.EQ.PARAMETER_DELETE) THEN
            CALL WDialogGetMenu(LIST_PARAMETERS,IPSEL)
            CTMP=LSTPAR(IPSEL)(1:10)
            CALL LSTPARDEL(CTMP)
            NP=NP-1
            IF(IPSEL.GT.NP) IPSEL=NP
            CALL WMessageEnable(FieldChanged,Enabled)
            CALL WDialogSelect(LIST_DIALOG)
            GO TO 2
C
C  Check for PARAMETER_ADD
         ELSE IF(MESSAGE%VALUE1.EQ.PARAMETER_ADD) THEN
            CALL WMessageEnable(FieldChanged,Disabled)
            PN=' '
            PV=0.0
            NPT=1
            CLTYPE(1)=PT
90          CALL LSTPARGET(PN,CLTYPE,1,NPT,PV,IERR)
            IF(IERR.GT.0) THEN
               GO TO 90
            ELSE IF(IERR.EQ.0) THEN
               CALL LSTPARADD(PN,CLTYPE(1),PV,IERR)
               IF(IERR.NE.0) GO TO 90
               IWIDTH=NMFLOW+NCAUX
               CTMP=PN
               CALL UPCASE(CTMP)
               CALL LSTMAK2(CTMP,-3,-3,IWIDTH,0)
               CALL WMessageEnable(FieldChanged,Enabled)
               CALL WDialogSelect(LIST_DIALOG)
               NP=NP+1
               IPSEL=NP
               GO TO 2
            END IF
            CALL WMessageEnable(FieldChanged,Enabled)
            CALL WDialogSelect(LIST_DIALOG)
C
C  Check for Browse
         ELSE IF(MESSAGE%VALUE1.EQ.FILE_BROWSE) THEN
            CALL BROWSE(FNAME)
            CALL WDialogSelect(LIST_DIALOG)
            GO TO 30
C
C  Check for OK
         ELSE IF(MESSAGE%VALUE1.EQ.LIST_IDOK) THEN
            CALL LSTINGET(NAR,IUPACK,ARRNAM,KK,IERR)
            CALL WDialogSelect(LIST_DIALOG)
            IF(IERR.NE.0) GO TO 50
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(LIST_DIALOG)
            RETURN
C
C  Check for CANCEL
         ELSE IF(MESSAGE%VALUE1.EQ.IDCANCEL) THEN
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(LIST_DIALOG)
            RETURN
         END IF
C
C  Ignore all other types of message
      END IF
      GO TO 50
C
      END
      SUBROUTINE LSTINGET(NAR,IUPACK,ARRNAM,KK,IERR)
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C     ******************************************************************
C     Retrieve and store values for a list for a stress period
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      CHARACTER*(*) ARRNAM
      CHARACTER*67 FNAME
      CHARACTER*60 CTXT(1)
C     ------------------------------------------------------------------
      IERR=0
      CALL WDialogGetRadioButton(LIST_NONE,IATNEW)
      IF(IATNEW.EQ.1) THEN
         NLIST=0
         CALL IVLSAV(ARRNAM,0,KK,NLIST)
         IARRDA(1,NAR)=-2
      ELSE IF(IATNEW.EQ.2) THEN
         NLIST=-1
         CALL IVLSAV(ARRNAM,0,KK,NLIST)
         IARRDA(1,NAR)=-2
      ELSE IF(IATNEW.EQ.3) THEN
         CALL WDialogGetReal(LIST_MULTIPLIER,ARRCON(NAR))
C  MFI can read a zero-length internal list as long as ARRCON is 1.0,
C  BUt MF2K will stop if a zero-length list is found.
         CALL WDialogGetInteger(LIST_INTERNAL_NLIST,INTLST)
         IF(INTLST.LE.0) ARRCON(NAR)=1.0
         IARRDA(1,NAR)=-2
      ELSE
C  Separate list -- make sure list has at least 1 value
         CALL WDialogGetInteger(SEPARATE_NLIST,NLSEP)
         IF(NLSEP.LE.0) THEN
            CTXT(1)='"Number in List" must be greater than 0.'
            CALL TXTLOG(CTXT,1)
            IERR=1
            RETURN
         END IF
         Call WDialogGetMenu(LIST_FILE_TYPE,IFTYP)
         CALL WDialogGetString(LIST_SEPARATE_NAME,FNAME)
         CALL USTLFT(FNAME,67)
         IF(IUCASE.NE.0) CALL USTRUC(FNAME,67)
         CALL FNMSV2(FNAME,IU,1,IUPACK,NAR,IFTYP)
         IF(IU.LE.0) THEN
            IERR=1
            RETURN
         END IF
         IARRDA(1,NAR)=IU
         IARRDA(5,NAR)=NLSEP
      END IF
C
      RETURN
      END
      SUBROUTINE LSTPARDEL(PN)
C     ******************************************************************
C     Delete a list parameter
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      CHARACTER*(*) PN
      CHARACTER*10 CTMP
C     ------------------------------------------------------------------
      IF(IPSUM.LE.0) RETURN
C
      DO 100 I=1,IPSUM
      IF(PARNAM(I).EQ.PN) THEN
         IF(I.NE.IPSUM) THEN
C  Move the parameters that follow the parameter to be deleted up one
            DO 50 J=I+1,IPSUM
C  Move the various variables that define the parameter
            PARNAM(J-1)=PARNAM(J)
            PARTYP(J-1)=PARTYP(J)
            B(J-1)=B(J)
            B2(J-1)=B2(J)
            ISFILE(J-1)=ISFILE(J)
            ISENS(J-1)=ISENS(J)
            LN(J-1)=LN(J)
            BL(J-1)=BL(J)
            BU(J-1)=BU(J)
            IPLOC(1,J-1)=IPLOC(1,J)
            IPLOC(2,J-1)=IPLOC(2,J)
50          CONTINUE
         END IF
C  Delete last entry in the list
         PARNAM(IPSUM)=' '
         PARTYP(IPSUM)=' '
         IPSUM=IPSUM-1
C
C  Delete any entries in PARPER arrays
         DO 60 K=1,MXPERPAR
         IF(PERPARNAM(K).EQ.PN) THEN
            PERPARNAM(K)=' '
            PERPARTYP(K)=' '
            IPERPARPER(K)=0
         END IF
60       CONTINUE
C
C  Blank out the variable name if it has been made into an array
         CTMP=PN
         CALL UPCASE(CTMP)
         IF(NVAR.GT.0) THEN
            DO 70 J=1,NVAR
            IF(VARNAM(J).EQ.CTMP .AND. IVARDA(1,J).EQ.-3 .AND.
     1       IVARDA(2,J).EQ.-3) THEN
               VARNAM(J)=' '
               IVARDA(1,J)=0
               IVARDA(1,J)=0
               IVARDA(1,J)=0
               RETURN
            END IF
70          CONTINUE
         END IF
         RETURN
      END IF
100   CONTINUE
C         
      RETURN
      END
      SUBROUTINE LSTPARGET(PN,CTYPE,NTYPE,NPT,PV,IERR)
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C     ******************************************************************
C     Prompt user to enter list parameter
C     ******************************************************************
      CHARACTER*(*) PN,CTYPE(NTYPE)
C     ------------------------------------------------------------------
      IERR=0
      CALL WDialogLoad(LIST_PARAMETER_DIALOG)
      CALL WDialogPutString(PARAMETER_NAME,PN)
      CALL WDialogPutMenu(PARAMETER_TYPE,CTYPE,NTYPE,NPT)
      CALL WDialogPutReal(LISTPAR_VALUE,PV,'(1PG13.6)')
C
      CALL WDialogShow(-1,50,0,Modal)
C
      IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
         CALL WDialogGetString(PARAMETER_NAME,PN)
         CALL WDialogGetMenu(PARAMETER_TYPE,NPT)
         CALL WDialogGetReal(PARAMETER_VALUE,PV)
C
      ELSE
         IERR=-1
      END IF
      CALL WDialogUnload(LIST_PARAMETER_DIALOG)
C
      RETURN
      END
      SUBROUTINE LSTPARADD(PN,PT,PV,IERR)
C     ******************************************************************
C     Add a new list parameter specification to the parameter list
C     ******************************************************************
      INCLUDE 'mfi2kpar.inc'
      CHARACTER*(*) PN,PT
      CHARACTER*80 CTXT(4)
      CHARACTER*10 CTMP1,CTMP2
C     ------------------------------------------------------------------
      IERR=0
C
C  Too many parameters
      IF(IPSUM.GE.MXPAR) THEN
         CTXT(1)='The number of parameters has exceeded the maximum'
         CALL TXTLOG(CTXT,1)
         IERR=1
         RETURN
      END IF
C
      IF(PN.EQ.' ') THEN
         CTXT(1)='Parameter name must not be blank'
         CALL TXTLOG(CTXT,1)
         IERR=1
         RETURN
      END IF
C
C  Look for the parameter name in the parameter list
      IF(IPSUM.GT.0) THEN
         DO 10 NP=1,IPSUM
         CTMP1=PARNAM(NP)
         CALL UPCASE(CTMP1)
         CTMP2=PN
         CALL UPCASE(CTMP2)
         IF(CTMP1.EQ.CTMP2) THEN
C  Illegal duplicate
            CTXT(1)='Duplicate parameter name'
            CALL TXTLOG(CTXT,1)
            IERR=1
            RETURN
          END IF
10       CONTINUE
      END IF
C
C
C  Add the parameter to the list.
      IPSUM=IPSUM+1
      IPLOC(1,IPSUM)=1
      IPLOC(2,IPSUM)=1
C
C
      PARNAM(IPSUM)=PN
      PARTYP(IPSUM)=PT
      B(IPSUM)=PV
      B2(IPSUM)=PV
      ISFILE(IPSUM)=0
      ISENS(IPSUM)=0
      LN(IPSUM)=0
      BL(IPSUM)=0.
      BU(IPSUM)=0.
      BSCAL(IPSUM)=0.
C
      RETURN
      END
      SUBROUTINE LSTPARMOD(PN,IUPACK,CAUX,NCAUX,LABEL,NMFLOW)
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C     ******************************************************************
C     Modify list parameter
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      CHARACTER*(*) PN,LABEL(NMFLOW,2)
      CHARACTER*16 CAUX(NCAUX)
      CHARACTER*10 CTMP
      CHARACTER*67 FNAME
      CHARACTER*60 CTXT(1)
C     ------------------------------------------------------------------
      DO 10 NP=1,IPSUM
      IF(PARNAM(NP).EQ.PN) GO TO 20
10    CONTINUE
      WRITE(IOUT,*) ' Error in LSTPARMOD'
      CALL MFISTP
C   
20    CTMP=PN
      CALL UPCASE(CTMP)
      CALL WDialogLoad(LIST_PARAMETER_MODIFY)
      CALL WMessageEnable(FieldChanged,Enabled)
      CALL WDialogPutString(PARAMETER_NAME,PN)
      CALL WDialogPutString(PARAMETER_TYPE,PARTYP(NP))
      CALL WDialogPutReal(LISTPAR_VALUE,B(NP),'(1PG13.6)')
      FNAME=' '
      IFTYP=1
      CALL IVLGET(CTMP,-3,-3,NAR,NLIST)
      IF(IARRDA(1,NAR).GT.0) THEN
C  Setup screen for separate data
         INTLST=0
         IATYPE=2
         FNAME=FILNAM(IARRDA(1,NAR))
         CALL WDialogPutRadioButton(PARAMETER_SEPARATE)
         IF(FILTYP(IARRDA(1,NAR)).EQ.'OPEN/CLOSE') IFTYP=2
      ELSE
         INTLST=NLIST
         IATYPE=1
         CALL WDialogPutRadioButton(PARAMETER_PACKAGE)
      END IF
      NLSEP=IARRDA(5,NAR)
      CALL WDialogPutInteger(LIST_INTERNAL_NLIST,INTLST)
      CALL WDialogPutString(FILE_NAME,FNAME)
      CALL WDialogPutReal(LIST_MULTIPLIER,ARRCON(NAR),'(1PG13.6)')
      CALL WDialogPutInteger(LIST_NLIST,NLSEP)
      Call WDialogPutOption(LIST_FILETYPE,IFTYP)
C
C Reconfigure screen based on file type
30    IF(IATYPE.EQ.2) THEN
         CALL WDialogFieldState(LIST_MULTIPLIER,Disabled)
         CALL WDialogFieldState(PARAMETER_SPREADSHEET,Disabled)
         CALL WDialogFieldState(PARAMETER_GRID,Disabled)
         CALL WDialogFieldState(FILE_NAME,Enabled)
         CALL WDialogFieldState(FILE_BROWSE,Enabled)
         CALL WDialogFieldState(LIST_NLIST,Enabled)
         CALL WDialogFieldState(LIST_FILETYPE,Enabled)
      ELSE
C  Setup screen for package data
         CALL WDialogFieldState(LIST_MULTIPLIER,Enabled)
         CALL WDialogFieldState(PARAMETER_SPREADSHEET,Enabled)
         IF(NLIST.GT.100) THEN
            CALL WDialogFieldState(PARAMETER_GRID,Disabled)
         ELSE
            CALL WDialogFieldState(PARAMETER_GRID,Enabled)
         END IF
         CALL WDialogFieldState(FILE_NAME,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(LIST_NLIST,Disabled)
         CALL WDialogFieldState(LIST_FILETYPE,Disabled)
      END IF
C
      CALL WDialogShow(-1,50,0,SemiModeless)
50    CALL WMessage(ITYPE,MESSAGE)
C
C  Check for list method change
         CALL WDialogGetRadioButton(PARAMETER_PACKAGE,IATNEW)
         IF(IATNEW.NE.IATYPE) THEN
            IATYPE=IATNEW
            GO TO 30
         END IF
C
C  Check for push buttons
      IF(ITYPE.EQ.PushButton) THEN
C
         IF(MESSAGE%VALUE1.EQ.PARAMETER_SPREADSHEET) THEN
            LOC=IARRDA(2,NAR)
            CALL SSLST(IX(LOC),NLIST,LABEL,NMFLOW,NAR,CAUX,NCAUX,
     1               LIST_PARAMETER_MODIFY)
            CALL WDialogSelect(LIST_PARAMETER_MODIFY)
            CALL IVLSAV(CTMP,-3,-3,NLIST)
            CALL WMessageEnable(FieldChanged,Enabled)
            GO TO 20
C
         ELSE IF(MESSAGE%VALUE1.EQ.PARAMETER_GRID) THEN
            IF(NLIST.GT.100) GO TO 20
            LOC=IARRDA(2,NAR)
            CALL SSLSTG(IX(LOC),NLIST,LABEL,NMFLOW,NAR,CAUX,NCAUX,
     1               LIST_PARAMETER_MODIFY)
            CALL WDialogSelect(LIST_PARAMETER_MODIFY)
            CALL IVLSAV(CTMP,-3,-3,NLIST)
            CALL WMessageEnable(FieldChanged,Enabled)
            GO TO 20
C
C  Check for Browse
         ELSE IF(MESSAGE%VALUE1.EQ.FILE_BROWSE) THEN
            CALL BROWSE(FNAME)
            CALL WDialogSelect(LIST_PARAMETER_MODIFY)
            GO TO 30
C
         ELSE IF(MESSAGE%VALUE1.EQ.IDOK) THEN
C  OK -- process the data that the user may have changed
            IF(IATYPE.EQ.2) THEN
               CALL WDialogGetInteger(LIST_NLIST,NLSEP)
               IF(NLSEP.LE.0) THEN
                  CTXT(1)='"Number in List" must be greater than 0.'
                  CALL TXTLOG(CTXT,1)
                  CALL WDialogSelect(LIST_PARAMETER_MODIFY)
                  GO TO 50
               END IF
               CALL WDialogGetString(FILE_NAME,FNAME)
               Call WDialogGetMenu(LIST_FILETYPE,IFTYP)
               CALL USTLFT(FNAME,67)
               IF(IUCASE.NE.0) CALL USTRUC(FNAME,67)
               CALL FNMSV2(FNAME,IU,1,IUPACK,NAR,IFTYP)
               IF(IU.LE.0) THEN
                  CALL WDialogSelect(LIST_PARAMETER_MODIFY)
                  GO TO 50
               END IF
               IARRDA(1,NAR)=IU
               IARRDA(5,NAR)=NLSEP
            ELSE
               CALL WDialogGetReal(LIST_MULTIPLIER,ARRCON(NAR))
               IARRDA(1,NAR)=-2
            END IF
C
            CALL WDialogGetReal(LISTPAR_VALUE,B(NP))
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(LIST_PARAMETER_MODIFY)
            RETURN
C
         ELSE IF(MESSAGE%VALUE1.EQ.IDCANCEL) THEN
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(LIST_PARAMETER_MODIFY)
            RETURN
         END IF
      END IF
C
      GO TO 50
C
      RETURN
      END
      SUBROUTINE U2DPERINGET(NAR,IUPACK,IOPT,COPVAR,IERR)
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C     ******************************************************************
C     Retrieve and store values for a 2-D array for a stress period
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      CHARACTER*(*) COPVAR
      CHARACTER*67 FNAME
      CHARACTER*20 FMT
C     ------------------------------------------------------------------
      IERR=0
      CALL WDialogGetRadioButton(ARRAY_PERIODS_RADIO_CONSTANT,IATNEW)
      IF(IATNEW.EQ.2) THEN
         IARRDA(1,NAR)=0
         CALL WDialogGetReal(ARRAY_PERIODS_CONSTANT,CON1)
         ARRCON(NAR)=CON1
      ELSE IF(IATNEW.EQ.3) THEN
         IARRDA(1,NAR)=-1
         CALL WDialogGetReal(ARRAY_PERIODS_MULTIPLIER,CON2)
         ARRCON(NAR)=CON2
      ELSE IF(IATNEW.EQ.4) THEN
         CALL WDialogGetString(ARRAY_PERIODS_FILE,FNAME)
         CALL USTLFT(FNAME,67)
         IF(IUCASE.NE.0) CALL USTRUC(FNAME,67)
         CALL WDialogGetMenu(ARRAY_PERIODS_FILE_TYPE,IFTYP)
         CALL WDialogGetString(ARRAY_PERIODS_FORMAT,FMT)
         CALL FMTCHK(FMT,IERR)
         IF(IERR.NE.0) RETURN
         ARRFMT(NAR)=FMT
         IF(FMT.EQ.'(BINARY)') THEN
            CALL FNMSV2(FNAME,IU,0,IUPACK,NAR,IFTYP)
         ELSE
            CALL FNMSV2(FNAME,IU,1,IUPACK,NAR,IFTYP)
         END IF
         IF(IU.LE.0) THEN
            IERR=1
            RETURN
         END IF
         IARRDA(1,NAR)=IU
         CALL WDialogGetReal(ARRAY_PERIODS_MULTIPLIER2,CON3)
         ARRCON(NAR)=CON3
         CALL WDialogGetInteger(ARRAY_PERIODS_IPRN,IPRN)
         IARRDA(5,NAR)=IPRN
      ELSE
         IARRDA(1,NAR)=-3
      END IF
C
C  Save the layer location option
      IF(IOPT.GT.0) CALL IVLSAV(COPVAR,0,0,IOPT)
C
      RETURN
      END
      SUBROUTINE GETSTRING(LABEL,STRING,IERR,L)
C     ******************************************************************
C     Use a dialog box to get a string
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      CHARACTER*(*) STRING,LABEL
C     ------------------------------------------------------------------
      IERR=1
C
      CALL WDialogLoad(STRING_DIALOG)
C  Initialize values
      CALL WDialogPutString(STRING_LABEL,LABEL)
C  Make Dialog visible
      CALL WDialogShow(-1,50,0,MODAL)
C  Get and store values if "OK" was pushed
      IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
         CALL WDialogGetString(STRING_STRING,STRING)
         LTOT=LEN(STRING)
         L=LENSTR(LTOT,STRING)
         IF(STRING.NE. ' ') IERR=0
      END IF
      CALL WDialogUnload(STRING_DIALOG)
C
      RETURN
      END
      SUBROUTINE ARRPARDEL(PN)
C     ******************************************************************
C     Delete an array parameter
C     ******************************************************************
      INCLUDE 'mfi2kpar.inc'
      CHARACTER*(*) PN
C     ------------------------------------------------------------------
      IF(IPSUM.LT.1) RETURN
      DO 100 I=1,IPSUM
      IF(PARNAM(I).EQ.PN) THEN
         NCL=IPLOC(2,I)-IPLOC(1,I)+1
         IPCL2=IPLOC(2,I)
         IF(I.NE.IPSUM) THEN
C  Move the parameters that follow the parameter to be deleted up one
            DO 50 J=I+1,IPSUM
C  Adjust the pointers to clusters if the parameter being moved is an array
C  parameter
            IF(PARTYP(J).EQ.'HK' .OR. PARTYP(J).EQ.'VK' .OR.
     1       PARTYP(J).EQ.'VKCB' .OR. PARTYP(J).EQ.'SS' .OR.
     2       PARTYP(J).EQ.'SY'   .OR. PARTYP(J).EQ.'RCH' .OR.
     3       PARTYP(J).EQ.'EVT'  .OR. PARTYP(J).EQ.'VANI' .OR.
     4       PARTYP(J).EQ.'HANI' ) THEN
               IPLOC(1,J)=IPLOC(1,J)-NCL
               IPLOC(2,J)=IPLOC(2,J)-NCL
            END IF
C  Move the various variables that define the parameter
            PARNAM(J-1)=PARNAM(J)
            PARTYP(J-1)=PARTYP(J)
            B(J-1)=B(J)
            B2(J-1)=B2(J)
            ISFILE(J-1)=ISFILE(J)
            ISENS(J-1)=ISENS(J)
            LN(J-1)=LN(J)
            BL(J-1)=BL(J)
            BU(J-1)=BU(J)
            BSCAL(J-1)=BSCAL(J)
            IPLOC(1,J-1)=IPLOC(1,J)
            IPLOC(2,J-1)=IPLOC(2,J)
50          CONTINUE
         END IF
C
C  Move the clusters for the paramers that came after the deleted
C  parameter.
         IF(IPCL2.NE.ICLSUM) THEN
            DO 60 JJ=IPCL2+1,ICLSUM
            CPCLST(1,JJ-NCL)=CPCLST(1,JJ)
            CPCLST(2,JJ-NCL)=CPCLST(2,JJ)
            DO 60 K=1,12
            IPCLST(K,JJ-NCL)=IPCLST(K,JJ)
60          CONTINUE
         END IF
C
C  Delete last entry in the list
         PARNAM(IPSUM)=' '
         PARTYP(IPSUM)=' '
         IPSUM=IPSUM-1
         ICLSUM=ICLSUM-NCL
         RETURN
      END IF
100   CONTINUE
      RETURN
      END
      SUBROUTINE ARRPARADD(PN,PT,PV,MN,ZN,LAY,IZN,IERR,ILFLG,
     1         ISF,ISE,LNS,B2S,BLS,BUS,BSS)
C     ******************************************************************
C     Add a new array parameter specification to the parameter list
C     ******************************************************************
      INCLUDE 'mfi2kpar.inc'
      CHARACTER*(*) PN,PT,MN(200),ZN(200)
      DIMENSION IZN(200,10),LAY(200)
      CHARACTER*80 CTXT(4)
      CHARACTER*10 CTMP1,CTMP2
C     ------------------------------------------------------------------
      IERR=0
C
C  Too many parameters
      IF(IPSUM.GE.MXPAR) THEN
         CTXT(1)='The number of parameters has exceeded the maximum'
         CALL TXTLOG(CTXT,1)
         IERR=1
         RETURN
      END IF
C
      IF(PN.EQ.' ') THEN
         CTXT(1)='Parameter name must not be blank'
         CALL TXTLOG(CTXT,1)
         IERR=1
         RETURN
      END IF
C
C  Look for the parameter name in the parameter list
      IF(IPSUM.GT.0) THEN
         DO 10 NP=1,IPSUM
         CTMP1=PARNAM(NP)
         CALL UPCASE(CTMP1)
         CTMP2=PN
         CALL UPCASE(CTMP2)
         IF(CTMP1.EQ.CTMP2) THEN
C  Illegal duplicate
            CTXT(1)='Duplicate parameter name'
            CALL TXTLOG(CTXT,1)
            IERR=1
            RETURN
         END IF
10       CONTINUE
      END IF
C
C  Check the rest of the parameter definition.
      NP=IPSUM+1
      NCLU=0
      DO 110 I=1,200
         IF(MN(I).EQ.' ' .OR. ZN(I).EQ.' ') GO TO 110
         IF(ILFLG.NE.0 .AND. LAY(I).LE.0) GO TO 110
         NCLU=NCLU+1
110   CONTINUE
      IF(NCLU.LE.0) THEN
         CTXT(1)='No clusters were defined'
         CALL TXTLOG(CTXT,1)
         IERR=1
         RETURN
      END IF
      IPLOC(1,NP)=ICLSUM+1
      IPLOC(2,NP)=ICLSUM+NCLU
C
      IF(IPLOC(2,NP).GT.MXCLST) THEN
          WRITE(CTXT(1),117) IPLOC(2,NP),MXCLST
  117     FORMAT(1X,I5,
     1 ' CLUSTERS WERE SPECIFIED, BUT THERE IS SPACE FOR ONLY',I5)
           WRITE(CTXT(2),*) NP,NCLU
           WRITE(CTXT(3),'(A)') PN
           WRITE(CTXT(4),'(2I10)') IPLOC(1,NP),IPLOC(2,NP)
         CALL TXTLOG(CTXT,4)
         IERR=1
         RETURN
      END IF
C
C  Process clusters
      NCLU=0
      DO 200 I=1,200
         IF(MN(I).EQ.' ' .OR. ZN(I).EQ.' ') GO TO 200
         IF(ILFLG.NE.0 .AND. LAY(I).LE.0) GO TO 200
         NCLU=NCLU+1
         ILOC=IPLOC(1,NP)+NCLU-1
         IPCLST(1,ILOC)=LAY(I)
         DO 30 J=3,12
         IPCLST(J,ILOC)=IZN(I,J-2)
         IF(IPCLST(J,ILOC).EQ.0) THEN
            IPCLST(2,ILOC)=J-1
            GO TO 32
         END IF
   30   CONTINUE
        IPCLST(2,ILOC)=12
C
C  Find the multiplier array
32       CTMP1=MN(I)
         CALL UPCASE(CTMP1)
         IF(CTMP1.EQ.'NONE') THEN
            CPCLST(1,ILOC)='NONE'
         ELSE
            DO 40 J=1,MXMLT
            CTMP2=MLTNAM(J)
            CALL UPCASE(CTMP2)
            IF(CTMP1.EQ.CTMP2) GO TO 45
            CTMP2=MLTFNM(J)
            CALL UPCASE(CTMP2)
            IF(CTMP1.EQ.CTMP2) GO TO 45
   40       CONTINUE
            CTXT(1)=MN(I)//' multiplier array has not been defined'
            CALL TXTLOG(CTXT,1)
            IERR=1
            RETURN
   45       CPCLST(1,ILOC)=MN(I)
         END IF
C
C  Find the zone array
         CTMP1=ZN(I)
         CALL UPCASE(CTMP1)
         IF(CTMP1.EQ.'ALL') THEN
            CPCLST(2,ILOC)='ALL'
         ELSE
            IF(IPCLST(2,ILOC).EQ.2) THEN
               CTXT(1)=
     1        'There were no zone values specified in the cluster'
               CTXT(2)='At least one zone must be specified'
               CALL TXTLOG(CTXT,2)
               IERR=1
               RETURN
            END IF
            DO 50 J=1,MXZON
            CTMP2=ZONNAM(J)
            CALL UPCASE(CTMP2)
            IF(CTMP1.EQ.CTMP2) GO TO 55
   50       CONTINUE
            CTXT(1)=ZN(I)//' zone array has not been defined'
            CALL TXTLOG(CTXT,1)
            IERR=1
            RETURN
   55       CPCLST(2,ILOC)=ZN(I)
         END IF
C
  200 CONTINUE
C
      PARNAM(NP)=PN
      PARTYP(NP)=PT
      B(NP)=PV
      B2(NP)=B2S
      ISFILE(NP)=ISF
      ISENS(NP)=ISE
      LN(NP)=LNS
      BL(NP)=BLS
      BU(NP)=BUS
      BSCAL(NP)=BSS
      IPSUM=NP
      ICLSUM=ICLSUM+NCLU
C
      RETURN
      END
      SUBROUTINE ARRPARGET(PN,CTYPE,NTYPE,NPT,PV,MN,ZN,LAY,IZN,ILFLG,
     1         IERR,INMFLG)
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C     ******************************************************************
C     Prompt user to enter array parameter
C     ******************************************************************
      CHARACTER*(*) PN,MN(200),ZN(200),CTYPE(NTYPE)
      DIMENSION IZN(200,10),LAY(200)
      DIMENSION ICOLS(12)
      DATA ICOLS/2,3,4,5,6,7,8,9,10,11,12,13/
C     ------------------------------------------------------------------
      IERR=0
      NL=200
      CALL WDialogLoad(ARRAY_PARAMETER_DIALOG)
      NADJ=0
      IF(ILFLG.EQ.0) THEN
         NADJ=-1
         CALL WGridColumns(PARAMETER_CLUSTERS,12,ICOLS)
         CALL WGridLabelColumn(PARAMETER_CLUSTERS,1,'Multiplier Array')
         CALL WGridLabelColumn(PARAMETER_CLUSTERS,2,'Zone Array')
         CALL WGridLabelColumn(PARAMETER_CLUSTERS,3,'Z1')
         CALL WGridLabelColumn(PARAMETER_CLUSTERS,4,'Z2')
         CALL WGridLabelColumn(PARAMETER_CLUSTERS,5,'Z3')
         CALL WGridLabelColumn(PARAMETER_CLUSTERS,6,'Z4')
         CALL WGridLabelColumn(PARAMETER_CLUSTERS,7,'Z5')
         CALL WGridLabelColumn(PARAMETER_CLUSTERS,8,'Z6')
         CALL WGridLabelColumn(PARAMETER_CLUSTERS,9,'Z7')
         CALL WGridLabelColumn(PARAMETER_CLUSTERS,10,'Z8')
         CALL WGridLabelColumn(PARAMETER_CLUSTERS,11,'Z9')
         CALL WGridLabelColumn(PARAMETER_CLUSTERS,12,'Z10')
      END IF
      CALL WDialogPutString(PARAMETER_NAME,PN)
      IF(INMFLG.NE.0) CALL WDialogFieldState(PARAMETER_NAME,Disabled)
      CALL WDialogPutMenu(PARAMETER_TYPE,CTYPE,NTYPE,NPT)
      IF(INMFLG.NE.0) CALL WDialogFieldState(PARAMETER_TYPE,Disabled)
      CALL WDialogPutReal(PARAMETER_VALUE,PV,'(1PG13.6)')
      IF(ILFLG.NE.0) CALL WGridPutInteger(PARAMETER_CLUSTERS,1,LAY,NL)
      CALL WGridPutString(PARAMETER_CLUSTERS,2+NADJ,MN,NL)
      CALL WGridPutString(PARAMETER_CLUSTERS,3+NADJ,ZN,NL)
      CALL WGridPutInteger(PARAMETER_CLUSTERS,4+NADJ,IZN(1,1),NL)
      CALL WGridPutInteger(PARAMETER_CLUSTERS,5+NADJ,IZN(1,2),NL)
      CALL WGridPutInteger(PARAMETER_CLUSTERS,6+NADJ,IZN(1,3),NL)
      CALL WGridPutInteger(PARAMETER_CLUSTERS,7+NADJ,IZN(1,4),NL)
      CALL WGridPutInteger(PARAMETER_CLUSTERS,8+NADJ,IZN(1,5),NL)
      CALL WGridPutInteger(PARAMETER_CLUSTERS,9+NADJ,IZN(1,6),NL)
      CALL WGridPutInteger(PARAMETER_CLUSTERS,10+NADJ,IZN(1,7),NL)
      CALL WGridPutInteger(PARAMETER_CLUSTERS,11+NADJ,IZN(1,8),NL)
      CALL WGridPutInteger(PARAMETER_CLUSTERS,12+NADJ,IZN(1,9),NL)
      CALL WGridPutInteger(PARAMETER_CLUSTERS,13+NADJ,IZN(1,10),NL)
C
10     CALL WDialogShow(-1,50,0,Modal)
C
      IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
         CALL WDialogGetString(PARAMETER_NAME,PN)
         CALL WDialogGetMenu(PARAMETER_TYPE,NPT)
         CALL WDialogGetReal(PARAMETER_VALUE,PV)
         IF(ILFLG.NE.0)
     1      CALL WGridGetInteger(PARAMETER_CLUSTERS,1,LAY,NL)
         CALL WGridGetString(PARAMETER_CLUSTERS,2+NADJ,MN,NL)
         CALL WGridGetString(PARAMETER_CLUSTERS,3+NADJ,ZN,NL)
         CALL WGridGetInteger(PARAMETER_CLUSTERS,4+NADJ,IZN(1,1),NL)
         CALL WGridGetInteger(PARAMETER_CLUSTERS,5+NADJ,IZN(1,2),NL)
         CALL WGridGetInteger(PARAMETER_CLUSTERS,6+NADJ,IZN(1,3),NL)
         CALL WGridGetInteger(PARAMETER_CLUSTERS,7+NADJ,IZN(1,4),NL)
         CALL WGridGetInteger(PARAMETER_CLUSTERS,8+NADJ,IZN(1,5),NL)
         CALL WGridGetInteger(PARAMETER_CLUSTERS,9+NADJ,IZN(1,6),NL)
         CALL WGridGetInteger(PARAMETER_CLUSTERS,10+NADJ,IZN(1,7),NL)
         CALL WGridGetInteger(PARAMETER_CLUSTERS,11+NADJ,IZN(1,8),NL)
         CALL WGridGetInteger(PARAMETER_CLUSTERS,12+NADJ,IZN(1,9),NL)
         CALL WGridGetInteger(PARAMETER_CLUSTERS,13+NADJ,IZN(1,10),NL)
      ELSE IF(WInfoDialog(ExitButton).EQ.ARRPAR_MULT_BUT) THEN
         CALL MULTED
         CALL WDialogSelect(ARRAY_PARAMETER_DIALOG)
         GO TO 10
      ELSE IF(WInfoDialog(ExitButton).EQ.ARRPAR_ZONE_BUT) THEN
         CALL ZONEED
         CALL WDialogSelect(ARRAY_PARAMETER_DIALOG)
         GO TO 10
      ELSE
         IERR=-1
      END IF
      CALL WDialogUnload(ARRAY_PARAMETER_DIALOG)
C
      RETURN
      END
      SUBROUTINE U2DPERIN(LABEL,ARRNAM,IARN,NCC,NR,IUPACK,NOPT,COPVAR)
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C     ******************************************************************
C     Prompt user for an array that varies according to stress period
C     This does not include parameters -- use U2DPARPERIN if there
C     are parameters
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      CHARACTER*(*) LABEL
      CHARACTER*(*) ARRNAM(IARN)
      CHARACTER*(*) COPVAR
      CHARACTER*78 CLINE
      CHARACTER*67 FNAME
      CHARACTER*20 FMT
      CHARACTER*4 CPER(MXPER)
      CHARACTER*20 OPTION(3)
      DATA OPTION/'Top Layer','Specified Layers','Automatic Selection'/
C     ------------------------------------------------------------------
      NC=NCC
      IF(NCC.LT.0) NC=-NCC
C
C  Make a list of stress period numbers.
      DO 20 K=1,NPER
      WRITE(CPER(K),'(I4)') K
20    CONTINUE
C
C  Determine initial value of the option for where stress is applied
      CALL IVLGET(COPVAR,0,0,ITYPE,IOPT)
      IF(ITYPE.NE.0) IOPT=1
C
C  Define array defaults
      CON1=0.
      CON2=1.
      CON3=1.
      FNAME=' '
      IFTYP=1   ! 1=File Name, 2=OPEN/CLOSE
C
C  Load the 3D-array dialog
      CALL WDialogLoad(ARRAY_STRESS_PARAMETERS_DIALOG)
      CALL WMessageEnable(FieldChanged,Enabled)
C
C  Initialize values
C  Label the package being edited.
      CLINE='Defining values for '//LABEL
      CALL WDialogPutString(ARRAY_PERIODS_TITLE,CLINE)
      K=1
      CALL WDialogPutMenu(ARRAY_PERIODS_NUMBER,CPER,NPER,K)
      IAR=1
C
C  Display the options for specifying where stress is applied
      CALL WDialogPutMenu(ARRAY_PERIODS_OPTION,OPTION,NOPT,IOPT)
C
C  Find how many arrays are used for the selected option, and
C  display them
23    NN=IARN
      IF(IOPT.NE.2) NN=IARN-1
      IF(IAR.GT.NN) IAR=1
      CALL WDialogPutMenu(ARRAY_PER_NAME,ARRNAM,NN,IAR)
C  
C  Find current array -- create if it doesn't already exist
25    CALL VALGET(ARRNAM(IAR),0,K,NAR,V)
      IREAL=1
      IF(ARRNAM(IAR)(1:1).EQ.'I') IREAL=0
      IF(NAR.LE.0) THEN
         CALL ARRMAK(ARRNAM(IAR),0,K,NC,NR)
         NAR=NARRAY
         IF(IREAL.EQ.0) IARRDA(5,NAR)=4
      END IF
      IREAL=1
      FMT='(10F8.0)'
      IF(IREAL.EQ.0) FMT='(20I4)'
      IPRN=0
      IF(IREAL.EQ.0) IPRN=4
      LOCAT=IARRDA(1,NAR)
      IF(LOCAT.EQ.0) THEN
         IAMETH=2  ! Constant array
         IF(IREAL.EQ.0) THEN
            ITMP=ARRCON(NAR)
            IF(ITMP.NE.IMISS) CON1=ARRCON(NAR)
         ELSE
            IF(ARRCON(NAR) .NE. RMISS) CON1=ARRCON(NAR)
         END IF
         CON2=1.
         CON3=CON2
      ELSE IF(LOCAT.EQ.-1) THEN
         IAMETH=3   !  package array
         CON2=ARRCON(NAR)
         CON1=CON2
         CON3=CON2
      ELSE IF(LOCAT.GT.0) THEN
         IAMETH=4   ! Separate array
         CON3=ARRCON(NAR)
         CON1=CON3
         CON2=CON3
         FMT=ARRFMT(NAR)
         FNAME=FILNAM(LOCAT)
         IPRN=IARRDA(5,NAR)
         IF(FILTYP(LOCAT)(1:10).EQ.'OPEN/CLOSE') IFTYP=2
      ELSE IF(LOCAT.EQ.-3) THEN
         IAMETH=1  !  Previous array
         IF(K.EQ.1) IAMETH=2
      END IF
C
C  Set current values for array
30    IF(K.EQ.1) THEN
         CALL WDialogFieldState(ARRAY_PERIODS_PREVIOUS,Disabled)
      ELSE
         CALL WDialogFieldState(ARRAY_PERIODS_PREVIOUS,Enabled)
      END IF
      IF(IAMETH.EQ.2) THEN
         CALL WDialogPutRadioButton(ARRAY_PERIODS_RADIO_CONSTANT)
         CALL WDialogFieldState(ARRAY_PERIODS_CONSTANT,Enabled)
         CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER2,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_IPRN,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FORMAT,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FILE,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FILE_TYPE,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_SPREADSHEET,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_GRID,Disabled)
      ELSE IF(IAMETH.EQ.3) THEN
         CALL WDialogPutRadioButton(ARRAY_PERIODS_PACKAGE)
         CALL WDialogFieldState(ARRAY_PERIODS_CONSTANT,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER,Enabled)
         CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER2,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_IPRN,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FORMAT,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FILE,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FILE_TYPE,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_SPREADSHEET,Enabled)
         IF(NC.GT.100 .OR. NR.GT.100) THEN
            CALL WDialogFieldState(ARRAY_PERIODS_GRID,Disabled)
         ELSE
            CALL WDialogFieldState(ARRAY_PERIODS_GRID,Enabled)
         END IF
      ELSE IF(IAMETH.EQ.4) THEN
         CALL WDialogPutRadioButton(ARRAY_PERIODS_SEPARATE)
         CALL WDialogFieldState(ARRAY_PERIODS_CONSTANT,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER2,Enabled)
         CALL WDialogFieldState(ARRAY_PERIODS_IPRN,Enabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FORMAT,Enabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FILE,Enabled)
         CALL WDialogFieldState(FILE_BROWSE,Enabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FILE_TYPE,Enabled)
         CALL WDialogFieldState(ARRAY_PERIODS_SPREADSHEET,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_GRID,Disabled)
      ELSE
         CALL WDialogPutRadioButton(ARRAY_PERIODS_PREVIOUS)
         CALL WDialogFieldState(ARRAY_PERIODS_CONSTANT,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER2,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_IPRN,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FORMAT,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FILE,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FILE_TYPE,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_SPREADSHEET,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_GRID,Disabled)
      END IF
      CALL WDialogPutInteger(ARRAY_PERIODS_IPRN,IPRN)
      CALL WDialogPutReal(ARRAY_PERIODS_CONSTANT,CON1,'(1PG13.6)')
      CALL WDialogPutReal(ARRAY_PERIODS_MULTIPLIER,CON2,'(1PG13.6)')
      CALL WDialogPutReal(ARRAY_PERIODS_MULTIPLIER2,CON3,'(1PG13.6)')
      CALL WDialogPutString(ARRAY_PERIODS_FORMAT,FMT)
      CALL WDialogPutString(ARRAY_PERIODS_FILE,FNAME)
      CALL WDialogPutOption(ARRAY_PERIODS_FILE_TYPE,IFTYP)
C
C  Make Array Dialog visible
      CALL WDialogShow(-1,50,0,SemiModeless)
50    CALL WMessage(ITYPE,MESSAGE)
C
C  Act upon field changes
      IF(ITYPE.EQ.FieldChanged) THEN
C
C  Check for IOPT change
         CALL WDialogGetMenu(ARRAY_PERIODS_OPTION,IOPTNEW)
         IF(IOPTNEW.NE.IOPT) THEN
            IOPT=IOPTNEW
            GO TO 23
         END IF
C
C  Check for change of array name
         CALL WDialogGetMenu(ARRAY_PER_NAME,IARNEW)
         IF(IARNEW.NE.IAR) THEN
            CALL U2DPERINGET(NAR,IUPACK,IOPT,COPVAR,IERR)
            CALL WDialogSelect(ARRAY_STRESS_PARAMETERS_DIALOG)
            IF(IERR.NE.0) GO TO 25
            IAR=IARNEW
            GO TO 25
         END IF
C
C  Check for period change
         CALL WDialogGetMenu(ARRAY_PERIODS_NUMBER,KNEW)
         IF(KNEW.NE.K) THEN
            CALL U2DPERINGET(NAR,IUPACK,IOPT,COPVAR,IERR)
            CALL WDialogSelect(ARRAY_STRESS_PARAMETERS_DIALOG)
            IF(IERR.NE.0) GO TO 25
            K=KNEW
            GO TO 25
         END IF
C
C  Check for array Method change
         CALL WDialogGetRadioButton(ARRAY_PERIODS_RADIO_CONSTANT,IAMNEW)
         IF(IAMNEW.NE.IAMETH) THEN
            IAMETH=IAMNEW

            IF(IARRDA(2,NAR).EQ.0 .AND. IAMETH.EQ.3) THEN
             CALL ARRALO(IARRDA(2,NAR),IARRDA(3,NAR),IARRDA(4,NAR))
             LOC=IARRDA(2,NAR)
             IF(IREAL.NE.0) THEN
               CALL ZIPR(NC*NR,0.,X(LOC))
C               IF(NCC.GT.0) CALL SS2DR(X(LOC),NC,NR,ARRNAM(IAR),
C     1                        ARRAY_STRESS_PARAMETERS_DIALOG)
               CALL WMessageEnable(FieldChanged,Enabled)
             ELSE
               CALL ZIPI(NC*NR,1,IX(LOC))
C               IF(NCC.GT.0) CALL SS2DI(IX(LOC),NC,NR,ARRNAM(IAR),
C     1                        ARRAY_STRESS_PARAMETERS_DIALOG)
               CALL WMessageEnable(FieldChanged,Enabled)
             END IF
             CALL WDialogSelect(ARRAY_STRESS_PARAMETERS_DIALOG)
            END IF
            GO TO 30
         END IF
C
C  Check for push buttons
      ELSE IF(ITYPE.EQ.PushButton) THEN
C
C  Check for ARRAY_PERIODS_SPREADSHEET
         IF(MESSAGE%VALUE1.EQ.ARRAY_PERIODS_SPREADSHEET) THEN
            IF(NCC.GT.0) THEN
              LOC=IARRDA(2,NAR)
              I=1
              IF(IREAL.NE.0) CALL SS2DR(X(LOC),NC,NR,ARRNAM(IAR),
     1               ARRAY_STRESS_PARAMETERS_DIALOG)
              IF(IREAL.EQ.0) CALL SS2DI(IX(LOC),NC,NR,ARRNAM(IAR),
     1               ARRAY_STRESS_PARAMETERS_DIALOG)
              CALL WMessageEnable(FieldChanged,Enabled)
              CALL WDialogSelect(ARRAY_STRESS_PARAMETERS_DIALOG)
            END IF
C
C  Check for ARRAY_PERIODS_GRID
         ELSE IF(MESSAGE%VALUE1.EQ.ARRAY_PERIODS_GRID) THEN
            IF(NCC.GT.0 .AND. NC.LE.100 .AND. NR.LE.100) THEN
              LOC=IARRDA(2,NAR)
              I=1
              IF(IREAL.NE.0) CALL SS2DRG(X(LOC),NC,NR,ARRNAM(IAR),
     1               ARRAY_STRESS_PARAMETERS_DIALOG)
              IF(IREAL.EQ.0) CALL SS2DIG(IX(LOC),NC,NR,ARRNAM(IAR),
     1               ARRAY_STRESS_PARAMETERS_DIALOG)
              CALL WMessageEnable(FieldChanged,Enabled)
              CALL WDialogSelect(ARRAY_STRESS_PARAMETERS_DIALOG)
            END IF
C
C  Check for Browse
         ELSE IF(MESSAGE%VALUE1.EQ.FILE_BROWSE) THEN
            CALL BROWSE(FNAME)
            CALL WDialogSelect(ARRAY_STRESS_PARAMETERS_DIALOG)
            GO TO 30
C
C  Check for OK
         ELSE IF(MESSAGE%VALUE1.EQ.ARRAY_PERIODS_IDOK) THEN
            CALL U2DPERINGET(NAR,IUPACK,IOPT,COPVAR,IERR)
            CALL WDialogSelect(ARRAY_STRESS_PARAMETERS_DIALOG)
            IF(IERR.NE.0) GO TO 50
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(ARRAY_STRESS_PARAMETERS_DIALOG)
            RETURN
C
C  Check for CANCEL
         ELSE IF(MESSAGE%VALUE1.EQ.IDCANCEL) THEN
C  Exit without storing values
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(ARRAY_STRESS_PARAMETERS_DIALOG)
            RETURN
         END IF
C
C  Ignore all other types of message
      END IF
      GO TO 50
C
      END
      SUBROUTINE COMNTIN(IULOC)
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      CHARACTER*80 CBUF
C
      CALL WDialogLoad(LIST_COMMENT_DIALOG)
      CALL WMessageEnable(FieldChanged,Disabled)
      CALL WGridPutString(COMMENT_GRID,1,COMENT(1,IULOC),20)
      CALL WDialogShow(-1,50,0,MODAL)
C  Get and store values if "OK" was pushed
      IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
         N=20
         CALL WGridGetString(COMMENT_GRID,1,COMENT(1,IULOC),N)
         DO 55 NN=1,N
         IF(COMENT(NN,IULOC).NE.' ' .AND.
     1                COMENT(NN,IULOC)(1:1).NE.'#') THEN
            CBUF='#'//COMENT(NN,IULOC)(1:79)
            COMENT(NN,IULOC)=CBUF
         END IF
55       CONTINUE
      END IF
      CALL WDialogUnload(LIST_COMMENT_DIALOG)
C
      RETURN
      END
