      SUBROUTINE BASED
C     ******************************************************************
C     Input BAS Package data
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C
      INCLUDE 'mfi2k.inc'
C
      TYPE(WIN_MESSAGE)   :: MESSAGE
      DIMENSION IPER(MXPER)
      CHARACTER*80 CTMP
C     ------------------------------------------------------------------
      CALL IVLGET('IXSEC',0,0,ITYPE,IXSEC)
      IF(ITYPE.NE.0) IXSEC=0
C
      CALL WDialogLoad(BAS_DIALOG)
      CALL WDialogShow(-1,50,0,SemiModeless)
C
5     CALL WMessage(ITYPE,MESSAGE)
C
C  Check for push buttons
      IF(ITYPE.EQ.PushButton) THEN
         IF(MESSAGE%VALUE1.EQ.BAS_CHECK_BUT) THEN
            CALL BASSV(IUNDEF,-1)
         ELSE IF(MESSAGE%VALUE1.EQ.BAS_MISC_BUT) THEN
C  MISC BUTTON
            CALL WDialogLoad(BAS_MISC_DIALOG)
C  Initialize values
            CALL WGridPutString(BAS_MISC_COMMENT,1,COMENT(1,41),20)
            CALL VALGET('HNOFLO',0,0,ITYPE,HNOFLO)
            IF(ITYPE.NE.0) HNOFLO=999.99
            CALL WDialogPutReal(BAS_MISC_HNOFLO,HNOFLO,'(1PG13.6)')
            IF(MODOUT.EQ.0) THEN
               CALL WDialogPutRadioButton(BAS_MISC_FIXED)
            ELSE
               CALL WDialogPutRadioButton(BAS_MISC_FREE)
            END IF
C  Make Miscellaneous Dialog visible
            CALL WDialogShow(-1,50,0,MODAL)
C  Get and store values if "OK" was pushed
            IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
               N=20
               CALL WGridGetString(BAS_MISC_COMMENT,1,COMENT(1,41),N)
               DO 10 NN=1,N
               IF(COMENT(NN,41).NE.' ' .AND.
     1                COMENT(NN,41)(1:1).NE.'#') THEN
                  CTMP='#'//COMENT(NN,41)(1:79)
                  COMENT(NN,41)=CTMP
               END IF
10             CONTINUE
               CALL WDialogGetReal(BAS_MISC_HNOFLO,HNOFLO)
               CALL VALSAV('HNOFLO',0,0,HNOFLO)
               CALL WDialogGetRadioButton(BAS_MISC_FIXED,ISET)
               IF(ISET.EQ.1) THEN
                  MODOUT=0
               ELSE
                  MODOUT=1
               END IF
            END IF
            CALL WDialogUnload(BAS_MISC_DIALOG)
C
         ELSE IF(MESSAGE%VALUE1.EQ.BAS_IBOUND_BUT) THEN
C  IBOUND PUSHBUTTON
            IF(IXSEC.EQ.0) THEN
               CALL U3DIN('IBOUND','IBOUND',NCOL,NROW,INBAS,NLAY)
            ELSE
               CALL U2DIN('IBOUND for cross section','IBOUND',
     1                NCOL,NLAY,INBAS,0,0)
            END IF
C
         ELSE IF(MESSAGE%VALUE1.EQ.BAS_INITIAL_BUT) THEN
C  INITIAL PUSHBUTTON
            IF(IXSEC.EQ.0) THEN
               CALL U3DIN('Initial Head','SHEAD',NCOL,NROW,INBAS,NLAY)
            ELSE
               CALL U2DIN('Initial Head for cross section','SHEAD',
     1                NCOL,NLAY,INBAS,0,0)
            END IF
C
         ELSE IF(MESSAGE%VALUE1.EQ.IDCLOSE) THEN
C  CLOSE PUSHBUTTON -- done with BAS dialog
            CALL BASSV(IUNDEF,1)
            CALL WDialogUnload(BAS_DIALOG)
            RETURN
         END IF
         CALL WDialogSelect(BAS_DIALOG)
      END IF
      GO TO 5
C
      END
      SUBROUTINE PERED
C     ******************************************************************
C     Input Stress Period data
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C
      INCLUDE 'mfi2k.inc'
      COMMON /PERCOM/PERLEN(MXPER),NSTP(MXPER),TSMULT(MXPER),
     1               ISSFLG(MXPER)
C
      TYPE(WIN_MESSAGE)   :: MESSAGE
      DIMENSION IPER(MXPER),ISSMEN(MXPER)
C     ------------------------------------------------------------------
C
      CALL WDialogLoad(DIS_PERIODS_DIALOG)
      CALL WMessageEnable(FieldChanged,Enabled)
C
C  Initialize values
C  Make a list of period numbers.
      DO 25 K=1,MXPER
      IPER(K)=K
25    CONTINUE
C
C  Set current values for period table
      CALL WDialogPutInteger(PERIODS_NPER,NPER)
      CALL WGridRows(DIS_PERIODS_GRID,NPER)
      CALL WGridPutInteger(DIS_PERIODS_GRID,1,IPER,NPER)
      CALL WGridPutReal(DIS_PERIODS_GRID,2,PERLEN,NPER,'(1PG13.6)')
      CALL WGridPutInteger(DIS_PERIODS_GRID,3,NSTP,NPER)
      CALL WGridPutReal(DIS_PERIODS_GRID,4,TSMULT,NPER,'(1PG13.6)')
      DO 30 K=1,NPER
      ISSMEN(K)=1
      IF(ISSFLG(K).EQ.0) ISSMEN(K)=2
30    CONTINUE
      CALL WGridPutOption(DIS_PERIODS_GRID,5,ISSMEN,NPER)
C
C  Make Periods Dialog visible
      CALL WDialogShow(-1,50,0,SemiModeless)
50    CALL WMessage(ITYPE,MESSAGE)
C
C  Act upon field changes
      IF(ITYPE.EQ.FieldChanged) THEN
C
C  Check for NPER change
         CALL WDialogGetInteger(PERIODS_NPER,KNEW)
         IF(KNEW.NE.NPER) THEN
            CALL WGridGetReal(DIS_PERIODS_GRID,2,PERLEN,NPER)
            CALL WGridGetInteger(DIS_PERIODS_GRID,3,NSTP,NPER)
            CALL WGridGetReal(DIS_PERIODS_GRID,4,TSMULT,NPER)
            CALL WGridGetMenu(DIS_PERIODS_GRID,5,ISSMEN,NPER)
            DO 35 K=1,NPER
            ISSFLG(K)=1
            IF(ISSMEN(K).EQ.2) ISSFLG(K)=0
35          CONTINUE
            NPER=KNEW
            CALL WGridRows(DIS_PERIODS_GRID,NPER)
            CALL WGridPutInteger(DIS_PERIODS_GRID,1,IPER,NPER)
           CALL WGridPutReal(DIS_PERIODS_GRID,2,PERLEN,NPER,'(1PG13.6)')
            CALL WGridPutInteger(DIS_PERIODS_GRID,3,NSTP,NPER)
           CALL WGridPutReal(DIS_PERIODS_GRID,4,TSMULT,NPER,'(1PG13.6)')
            DO 40 K=1,NPER
            ISSMEN(K)=1
            IF(ISSFLG(K).EQ.0) ISSMEN(K)=2
40          CONTINUE
            CALL WGridPutOption(DIS_PERIODS_GRID,5,ISSMEN,NPER)
         END IF
C
C  Check for push buttons
      ELSE IF(ITYPE.EQ.PushButton) THEN
C
C  Check for OK
         IF(MESSAGE%VALUE1.EQ.PERIODS_IDOK) THEN
            CALL WDialogGetInteger(PERIODS_NPER,NPER)
            CALL WGridGetReal(DIS_PERIODS_GRID,2,PERLEN,NPER)
            CALL WGridGetInteger(DIS_PERIODS_GRID,3,NSTP,NPER)
            CALL WGridGetReal(DIS_PERIODS_GRID,4,TSMULT,NPER)
            CALL WGridGetMenu(DIS_PERIODS_GRID,5,ISSMEN,NPER)
            DO 65 K=1,NPER
            ISSFLG(K)=1
            IF(ISSMEN(K).EQ.2) ISSFLG(K)=0
65          CONTINUE
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(DIS_PERIODS_DIALOG)
            RETURN
C
         ELSE IF(MESSAGE%VALUE1.EQ.IDCANCEL) THEN
C  Cancel -- Exit without storing values
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(DIS_PERIODS_DIALOG)
            RETURN
         END IF
C
C  Ignore all other types of message from the PERIODS dialog
      END IF
      GO TO 50
C
      END
      SUBROUTINE SOLVED()
C     ******************************************************************
C     Edit data for all solvers
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      TYPE(WIN_MESSAGE)  :: MESSAGE
C     ------------------------------------------------------------------
C
C  Load SOLVER_DIALOG
      CALL WDialogLoad(SOLVER_DIALOG)
C
C  Define current values
C  Solver
      IF(IUNIT(13).NE.0) THEN
         ISOLVE=1
         CALL WDialogPutRadioButton(SOLVER_PCG)
      ELSE IF(IUNIT(9).NE.0) THEN
         ISOLVE=2
         CALL WDialogPutRadioButton(SOLVER_SIP)
      ELSE IF(IUNIT(11).NE.0) THEN
         ISOLVE=3
         CALL WDialogPutRadioButton(SOLVER_SOR)
      ELSE IF(IUNIT(10).NE.0) THEN
         ISOLVE=4
         CALL WDialogPutRadioButton(SOLVER_DE4)
      ELSE IF(IUNIT(14).NE.0) THEN
         ISOLVE=5
         CALL WDialogPutRadioButton(SOLVER_LMG)
      ELSE
         ISOLVE=1
         CALL WDialogPutRadioButton(SOLVER_PCG)
      END IF
C  PCG
      CALL IVLGET('MXIPCG',0,0,ITYPE,MXIPCG)
      IF(ITYPE.NE.0) MXIPCG=15
      Call WDialogPutInteger(PCG_MXIPCG,MXIPCG)
      CALL IVLGET('ITER1',0,0,ITYPE,ITER1)
      IF(ITYPE.NE.0) ITER1=20
      Call WDialogPutInteger(PCG_ITER1,ITER1)
      CALL IVLGET('IPRPCG',0,0,ITYPE,IPRPCG)
      IF(ITYPE.NE.0) IPRPCG=1
      Call WDialogPutInteger(PCG_IPRPCG,IPRPCG)
      CALL IVLGET('MUTPCG',0,0,ITYPE,MUTPCG)
      IF(ITYPE.NE.0) MUTPCG=0
      Call WDialogPutInteger(PCG_MUTPCG,MUTPCG)
      CALL VALGET('HCLPCG',0,0,ITYPE,HCLPCG)
      IF(ITYPE.NE.0) HCLPCG=.001
      Call WDialogPutReal(PCG_HCLPCG,HCLPCG)
      CALL VALGET('RCLOSE',0,0,ITYPE,RCLOSE)
      IF(ITYPE.NE.0) RCLOSE=1000.
      Call WDialogPutReal(PCG_RCLOSE,RCLOSE)
      CALL VALGET('RELAX',0,0,ITYPE,RELAX)
      IF(ITYPE.NE.0) RELAX=1.0
      Call WDialogPutReal(PCG_RELAX,RELAX)
      CALL VALGET('DAMP',0,0,ITYPE,DAMP)
      IF(ITYPE.NE.0) DAMP=1.0
      Call WDialogPutReal(PCG_DAMP,DAMP)
C  SIP
      CALL IVLGET('MXISIP',0,0,ITYPE,MXISIP)
      IF(ITYPE.NE.0) MXISIP=50
      Call WDialogPutInteger(SIP_MXISIP,MXISIP)
      CALL VALGET('HCLSIP',0,0,ITYPE,HCLSIP)
      IF(ITYPE.NE.0) HCLSIP=.001
      Call WDialogPutReal(SIP_HCLSIP,HCLSIP)
      CALL VALGET('ACLSIP',0,0,ITYPE,ACLSIP)
      IF(ITYPE.NE.0) ACLSIP=1.0
      Call WDialogPutReal(SIP_ACLSIP,ACLSIP)
      CALL VALGET('WSEED',0,0,ITYPE,WSEED)
      IF(ITYPE.NE.0) WSEED=0.0
      Call WDialogPutReal(SIP_WSEED,WSEED)
      CALL IVLGET('IPRSIP',0,0,ITYPE,IPRSIP)
      IF(ITYPE.NE.0) IPRSIP=1
      Call WDialogPutInteger(SIP_IPRSIP,IPRSIP)
C  SOR
      CALL IVLGET('MXISOR',0,0,ITYPE,MXISOR)
      IF(ITYPE.NE.0) MXISOR=50
      Call WDialogPutInteger(SOR_MXISOR,MXISOR)
      CALL VALGET('HCLSOR',0,0,ITYPE,HCLSOR)
      IF(ITYPE.NE.0) HCLSOR=.001
      Call WDialogPutReal(SOR_HCLSOR,HCLSOR)
      CALL VALGET('ACLSOR',0,0,ITYPE,ACLSOR)
      IF(ITYPE.NE.0) ACLSOR=1.0
      Call WDialogPutReal(SOR_ACLSOR,ACLSOR)
      CALL IVLGET('IPRSOR',0,0,ITYPE,IPRSOR)
      IF(ITYPE.NE.0) IPRSOR=1
      Call WDialogPutInteger(SOR_IPRSOR,IPRSOR)
C  DE4
      CALL IVLGET('IFREQ',0,0,ITYPE,IFREQ)
      IF(ITYPE.NE.0) IFREQ=3
      Call WDialogPutInteger(DE4_IFREQ,IFREQ)
      CALL IVLGET('ITMX',0,0,ITYPE,ITMX)
      IF(ITYPE.NE.0) THEN
         ITMX=1
         IF(IFREQ.EQ.3) ITMX=5
      END IF
      Call WDialogPutInteger(DE4_ITMX,ITMX)
      CALL VALGET('HCLDE4',0,0,ITYPE,HCLDE4)
      IF(ITYPE.NE.0) HCLDE4=.01
      Call WDialogPutReal(DE4_HCLDE4,HCLDE4)
      CALL VALGET('ACLDE4',0,0,ITYPE,ACLDE4)
      IF(ITYPE.NE.0) ACLDE4=1.0
      Call WDialogPutReal(DE4_ACLDE4,ACLDE4)
      CALL IVLGET('IPRD4',0,0,ITYPE,IPRD4)
      IF(ITYPE.NE.0) IPRD4=1
      Call WDialogPutInteger(DE4_IPRD4,IPRD4)
      CALL IVLGET('MXUP',0,0,ITYPE,MXUP)
      IF(ITYPE.NE.0) MXUP=0
      Call WDialogPutInteger(DE4_MXUP,MXUP)
      CALL IVLGET('MXLOW',0,0,ITYPE,MXLOW)
      IF(ITYPE.NE.0) MXLOW=0
      Call WDialogPutInteger(DE4_MXLOW,MXLOW)
      CALL IVLGET('MXBW',0,0,ITYPE,MXBW)
      IF(ITYPE.NE.0) MXBW=0
      Call WDialogPutInteger(DE4_MXBW,MXBW)
C  LMG
      CALL IVLGET('MXILMG',0,0,ITYPE,MXILMG)
      IF(ITYPE.NE.0) MXILMG=15
      Call WDialogPutInteger(LMG_MXILMG,MXILMG)
      CALL IVLGET('MXCYC',0,0,ITYPE,MXCYC)
      IF(ITYPE.NE.0) MXCYC=20
      Call WDialogPutInteger(LMG_MXCYC,MXCYC)
      CALL IVLGET('IOUTAMG',0,0,ITYPE,IOUTAMG)
      IF(ITYPE.NE.0) IOUTAMG=3
      Call WDialogPutInteger(LMG_IOUTAMG,IOUTAMG)
      CALL VALGET('BCLOSE',0,0,ITYPE,BCLOSE)
      IF(ITYPE.NE.0) BCLOSE=100.
      Call WDialogPutReal(LMG_BCLOSE,BCLOSE)
      CALL VALGET('DAMP_LMG',0,0,ITYPE,DAMP_LMG)
      IF(ITYPE.NE.0) DAMP_LMG=1.0
      Call WDialogPutReal(LMG_DAMP,DAMP_LMG)
      CALL VALGET('STOR1',0,0,ITYPE,STOR1)
      IF(ITYPE.NE.0) STOR1=3.0
      Call WDialogPutReal(LMG_STOR1,STOR1)
      CALL VALGET('STOR2',0,0,ITYPE,STOR2)
      IF(ITYPE.NE.0) STOR2=2.2
      Call WDialogPutReal(LMG_STOR2,STOR2)
      CALL VALGET('STOR3',0,0,ITYPE,STOR3)
      IF(ITYPE.NE.0) STOR3=5.4
      Call WDialogPutReal(LMG_STOR3,STOR3)
      CALL IVLGET('ICG',0,0,ITYPE,ICG)
      IF(ITYPE.NE.0) ICG=0
      IF(ICG.EQ.0) THEN
         CALL WDialogPutRadioButton(LMG_NOICG)
      ELSE
         CALL WDialogPutRadioButton(LMG_ICG)
      END IF
      CALL VALGET('DUP',0,0,ITYPE,DUP)
      IF(ITYPE.NE.0) DUP=1.0
      Call WDialogPutReal(LMG_DUP,DUP)
      CALL VALGET('DLOW',0,0,ITYPE,DLOW)
      IF(ITYPE.NE.0) DLOW=0.2
      Call WDialogPutReal(LMG_DLOW,DLOW)
C
C  Show SOLVER_DIALOG
      CALL WDialogShow(-1,50,0,SemiModeless)
      CALL WMessageEnable(FieldChanged,Enabled)
C
C  Enable/disable fields depending on solver
20    IF(ISOLVE.EQ.1) THEN
         CALL WDialogFieldState(PCG_MXIPCG,Enabled)
         CALL WDialogFieldState(PCG_ITER1,Enabled)
         CALL WDialogFieldState(PCG_IPRPCG,Enabled)
         CALL WDialogFieldState(PCG_MUTPCG,Enabled)
         CALL WDialogFieldState(PCG_HCLPCG,Enabled)
         CALL WDialogFieldState(PCG_RCLOSE,Enabled)
         CALL WDialogFieldState(PCG_RELAX,Enabled)
         CALL WDialogFieldState(PCG_DAMP,Enabled)
         CALL WDialogFieldState(SIP_MXISIP,Disabled)
         CALL WDialogFieldState(SIP_HCLSIP,Disabled)
         CALL WDialogFieldState(SIP_ACLSIP,Disabled)
         CALL WDialogFieldState(SIP_WSEED,Disabled)
         CALL WDialogFieldState(SIP_IPRSIP,Disabled)
         CALL WDialogFieldState(SOR_MXISOR,Disabled)
         CALL WDialogFieldState(SOR_HCLSOR,Disabled)
         CALL WDialogFieldState(SOR_ACLSOR,Disabled)
         CALL WDialogFieldState(SOR_IPRSOR,Disabled)
         CALL WDialogFieldState(DE4_IFREQ,Disabled)
         CALL WDialogFieldState(DE4_ITMX,Disabled)
         CALL WDialogFieldState(DE4_HCLDE4,Disabled)
         CALL WDialogFieldState(DE4_ACLDE4,Disabled)
         CALL WDialogFieldState(DE4_IPRD4,Disabled)
         CALL WDialogFieldState(DE4_MUTD4,Disabled)
         CALL WDialogFieldState(DE4_MXUP,Disabled)
         CALL WDialogFieldState(DE4_MXLOW,Disabled)
         CALL WDialogFieldState(DE4_MXBW,Disabled)
         CALL WDialogFieldState(LMG_STOR1,Disabled)
         CALL WDialogFieldState(LMG_STOR2,Disabled)
         CALL WDialogFieldState(LMG_STOR3,Disabled)
         CALL WDialogFieldState(LMG_NOICG,Disabled)
         CALL WDialogFieldState(LMG_ICG,Disabled)
         CALL WDialogFieldState(LMG_MXILMG,Disabled)
         CALL WDialogFieldState(LMG_MXCYC,Disabled)
         CALL WDialogFieldState(LMG_BCLOSE,Disabled)
         CALL WDialogFieldState(LMG_DAMP,Disabled)
         CALL WDialogFieldState(LMG_IOUTAMG,Disabled)
         CALL WDialogFieldState(LMG_DUP,Disabled)
         CALL WDialogFieldState(LMG_DLOW,Disabled)
      ELSE IF(ISOLVE.EQ.2) THEN
         CALL WDialogFieldState(PCG_MXIPCG,Disabled)
         CALL WDialogFieldState(PCG_ITER1,Disabled)
         CALL WDialogFieldState(PCG_IPRPCG,Disabled)
         CALL WDialogFieldState(PCG_MUTPCG,Disabled)
         CALL WDialogFieldState(PCG_HCLPCG,Disabled)
         CALL WDialogFieldState(PCG_RCLOSE,Disabled)
         CALL WDialogFieldState(PCG_RELAX,Disabled)
         CALL WDialogFieldState(PCG_DAMP,Disabled)
         CALL WDialogFieldState(SIP_MXISIP,Enabled)
         CALL WDialogFieldState(SIP_HCLSIP,Enabled)
         CALL WDialogFieldState(SIP_ACLSIP,Enabled)
         CALL WDialogFieldState(SIP_WSEED,Enabled)
         CALL WDialogFieldState(SIP_IPRSIP,Enabled)
         CALL WDialogFieldState(SOR_MXISOR,Disabled)
         CALL WDialogFieldState(SOR_HCLSOR,Disabled)
         CALL WDialogFieldState(SOR_ACLSOR,Disabled)
         CALL WDialogFieldState(SOR_IPRSOR,Disabled)
         CALL WDialogFieldState(DE4_IFREQ,Disabled)
         CALL WDialogFieldState(DE4_ITMX,Disabled)
         CALL WDialogFieldState(DE4_HCLDE4,Disabled)
         CALL WDialogFieldState(DE4_ACLDE4,Disabled)
         CALL WDialogFieldState(DE4_IPRD4,Disabled)
         CALL WDialogFieldState(DE4_MUTD4,Disabled)
         CALL WDialogFieldState(DE4_MXUP,Disabled)
         CALL WDialogFieldState(DE4_MXLOW,Disabled)
         CALL WDialogFieldState(DE4_MXBW,Disabled)
         CALL WDialogFieldState(LMG_STOR1,Disabled)
         CALL WDialogFieldState(LMG_STOR2,Disabled)
         CALL WDialogFieldState(LMG_STOR3,Disabled)
         CALL WDialogFieldState(LMG_NOICG,Disabled)
         CALL WDialogFieldState(LMG_ICG,Disabled)
         CALL WDialogFieldState(LMG_MXILMG,Disabled)
         CALL WDialogFieldState(LMG_MXCYC,Disabled)
         CALL WDialogFieldState(LMG_BCLOSE,Disabled)
         CALL WDialogFieldState(LMG_DAMP,Disabled)
         CALL WDialogFieldState(LMG_IOUTAMG,Disabled)
         CALL WDialogFieldState(LMG_DUP,Disabled)
         CALL WDialogFieldState(LMG_DLOW,Disabled)
      ELSE IF(ISOLVE.EQ.3) THEN
         CALL WDialogFieldState(PCG_MXIPCG,Disabled)
         CALL WDialogFieldState(PCG_ITER1,Disabled)
         CALL WDialogFieldState(PCG_IPRPCG,Disabled)
         CALL WDialogFieldState(PCG_MUTPCG,Disabled)
         CALL WDialogFieldState(PCG_HCLPCG,Disabled)
         CALL WDialogFieldState(PCG_RCLOSE,Disabled)
         CALL WDialogFieldState(PCG_RELAX,Disabled)
         CALL WDialogFieldState(PCG_DAMP,Disabled)
         CALL WDialogFieldState(SIP_MXISIP,Disabled)
         CALL WDialogFieldState(SIP_HCLSIP,Disabled)
         CALL WDialogFieldState(SIP_ACLSIP,Disabled)
         CALL WDialogFieldState(SIP_WSEED,Disabled)
         CALL WDialogFieldState(SIP_IPRSIP,Disabled)
         CALL WDialogFieldState(SOR_MXISOR,Enabled)
         CALL WDialogFieldState(SOR_HCLSOR,Enabled)
         CALL WDialogFieldState(SOR_ACLSOR,Enabled)
         CALL WDialogFieldState(SOR_IPRSOR,Enabled)
         CALL WDialogFieldState(DE4_IFREQ,Disabled)
         CALL WDialogFieldState(DE4_ITMX,Disabled)
         CALL WDialogFieldState(DE4_HCLDE4,Disabled)
         CALL WDialogFieldState(DE4_ACLDE4,Disabled)
         CALL WDialogFieldState(DE4_IPRD4,Disabled)
         CALL WDialogFieldState(DE4_MUTD4,Disabled)
         CALL WDialogFieldState(DE4_MXUP,Disabled)
         CALL WDialogFieldState(DE4_MXLOW,Disabled)
         CALL WDialogFieldState(DE4_MXBW,Disabled)
         CALL WDialogFieldState(LMG_STOR1,Disabled)
         CALL WDialogFieldState(LMG_STOR2,Disabled)
         CALL WDialogFieldState(LMG_STOR3,Disabled)
         CALL WDialogFieldState(LMG_NOICG,Disabled)
         CALL WDialogFieldState(LMG_ICG,Disabled)
         CALL WDialogFieldState(LMG_MXILMG,Disabled)
         CALL WDialogFieldState(LMG_MXCYC,Disabled)
         CALL WDialogFieldState(LMG_BCLOSE,Disabled)
         CALL WDialogFieldState(LMG_DAMP,Disabled)
         CALL WDialogFieldState(LMG_IOUTAMG,Disabled)
         CALL WDialogFieldState(LMG_DUP,Disabled)
         CALL WDialogFieldState(LMG_DLOW,Disabled)
      ELSE IF(ISOLVE.EQ.4) THEN
         CALL WDialogFieldState(PCG_MXIPCG,Disabled)
         CALL WDialogFieldState(PCG_ITER1,Disabled)
         CALL WDialogFieldState(PCG_IPRPCG,Disabled)
         CALL WDialogFieldState(PCG_MUTPCG,Disabled)
         CALL WDialogFieldState(PCG_HCLPCG,Disabled)
         CALL WDialogFieldState(PCG_RCLOSE,Disabled)
         CALL WDialogFieldState(PCG_RELAX,Disabled)
         CALL WDialogFieldState(PCG_DAMP,Disabled)
         CALL WDialogFieldState(SIP_MXISIP,Disabled)
         CALL WDialogFieldState(SIP_HCLSIP,Disabled)
         CALL WDialogFieldState(SIP_ACLSIP,Disabled)
         CALL WDialogFieldState(SIP_WSEED,Disabled)
         CALL WDialogFieldState(SIP_IPRSIP,Disabled)
         CALL WDialogFieldState(SOR_MXISOR,Disabled)
         CALL WDialogFieldState(SOR_HCLSOR,Disabled)
         CALL WDialogFieldState(SOR_ACLSOR,Disabled)
         CALL WDialogFieldState(SOR_IPRSOR,Disabled)
         CALL WDialogFieldState(DE4_IFREQ,Enabled)
         CALL WDialogFieldState(DE4_ITMX,Enabled)
         CALL WDialogFieldState(DE4_HCLDE4,Enabled)
         CALL WDialogFieldState(DE4_ACLDE4,Enabled)
         CALL WDialogFieldState(DE4_IPRD4,Enabled)
         CALL WDialogFieldState(DE4_MUTD4,Enabled)
         CALL WDialogFieldState(DE4_MXUP,Enabled)
         CALL WDialogFieldState(DE4_MXLOW,Enabled)
         CALL WDialogFieldState(DE4_MXBW,Enabled)
         CALL WDialogFieldState(LMG_STOR1,Disabled)
         CALL WDialogFieldState(LMG_STOR2,Disabled)
         CALL WDialogFieldState(LMG_STOR3,Disabled)
         CALL WDialogFieldState(LMG_NOICG,Disabled)
         CALL WDialogFieldState(LMG_ICG,Disabled)
         CALL WDialogFieldState(LMG_MXILMG,Disabled)
         CALL WDialogFieldState(LMG_MXCYC,Disabled)
         CALL WDialogFieldState(LMG_BCLOSE,Disabled)
         CALL WDialogFieldState(LMG_DAMP,Disabled)
         CALL WDialogFieldState(LMG_IOUTAMG,Disabled)
         CALL WDialogFieldState(LMG_DUP,Disabled)
         CALL WDialogFieldState(LMG_DLOW,Disabled)
      ELSE
         CALL WDialogFieldState(LMG_STOR1,Enabled)
         CALL WDialogFieldState(LMG_STOR2,Enabled)
         CALL WDialogFieldState(LMG_STOR3,Enabled)
         CALL WDialogFieldState(LMG_NOICG,Enabled)
         CALL WDialogFieldState(LMG_ICG,Enabled)
         CALL WDialogFieldState(LMG_MXILMG,Enabled)
         CALL WDialogFieldState(LMG_MXCYC,Enabled)
         CALL WDialogFieldState(LMG_BCLOSE,Enabled)
         CALL WDialogFieldState(LMG_DAMP,Enabled)
         CALL WDialogFieldState(LMG_IOUTAMG,Enabled)
         CALL WDialogFieldState(LMG_DUP,Enabled)
         CALL WDialogFieldState(LMG_DLOW,Enabled)
         CALL WDialogFieldState(PCG_MXIPCG,Disabled)
         CALL WDialogFieldState(PCG_ITER1,Disabled)
         CALL WDialogFieldState(PCG_IPRPCG,Disabled)
         CALL WDialogFieldState(PCG_MUTPCG,Disabled)
         CALL WDialogFieldState(PCG_HCLPCG,Disabled)
         CALL WDialogFieldState(PCG_RCLOSE,Disabled)
         CALL WDialogFieldState(PCG_RELAX,Disabled)
         CALL WDialogFieldState(PCG_DAMP,Disabled)
         CALL WDialogFieldState(SIP_MXISIP,Disabled)
         CALL WDialogFieldState(SIP_HCLSIP,Disabled)
         CALL WDialogFieldState(SIP_ACLSIP,Disabled)
         CALL WDialogFieldState(SIP_WSEED,Disabled)
         CALL WDialogFieldState(SIP_IPRSIP,Disabled)
         CALL WDialogFieldState(SOR_MXISOR,Disabled)
         CALL WDialogFieldState(SOR_HCLSOR,Disabled)
         CALL WDialogFieldState(SOR_ACLSOR,Disabled)
         CALL WDialogFieldState(SOR_IPRSOR,Disabled)
         CALL WDialogFieldState(DE4_IFREQ,Disabled)
         CALL WDialogFieldState(DE4_ITMX,Disabled)
         CALL WDialogFieldState(DE4_HCLDE4,Disabled)
         CALL WDialogFieldState(DE4_ACLDE4,Disabled)
         CALL WDialogFieldState(DE4_IPRD4,Disabled)
         CALL WDialogFieldState(DE4_MUTD4,Disabled)
         CALL WDialogFieldState(DE4_MXUP,Disabled)
         CALL WDialogFieldState(DE4_MXLOW,Disabled)
         CALL WDialogFieldState(DE4_MXBW,Disabled)
      END IF
C
C  Message loop
50    CALL WMessage(ITYPE,MESSAGE)
C
      IF(ITYPE.EQ.FieldChanged) THEN
C
C  Get solver selection
         CALL WDialogGetRadioButton(SOLVER_PCG,INEW)
         IF(INEW.NE.ISOLVE) THEN
            ISOLVE=INEW
            GO TO 20
         END IF
C
C  Get and store values if "OK" was pushed
      ELSE IF(ITYPE.EQ.PushButton) THEN
         IF(MESSAGE%VALUE1.EQ.SOLVER_COMMENT) THEN
            IF(ISOLVE.EQ.1) IULOC=13
            IF(ISOLVE.EQ.2) IULOC=9
            IF(ISOLVE.EQ.3) IULOC=11
            IF(ISOLVE.EQ.4) IULOC=10
            IF(ISOLVE.EQ.4) IULOC=14
            CALL COMNTIN(IULOC)
            CALL WDialogSelect(SOLVER_DIALOG)
            CALL WMessageEnable(FieldChanged,Enabled)
C
         ELSE IF(MESSAGE%VALUE1.EQ.IDOK) THEN
C
C  If solver has changed from what was previously selected, open a
C  file for new solver, deselect previous solver, and remove unused
C  files.
            IF(ISOLVE.EQ.1) THEN
C  PCG
               IF(IUNIT(13).EQ.0) THEN
                  CALL FINDUN(23,IU,'PCG','PCG')
                  IUNIT(13)=IU
                  IF(IUNIT(9).NE.0) THEN
                     IFNUSE(IUNIT(9))=0
                     IUNIT(9)=0
                  END IF
                  IF(IUNIT(10).NE.0) THEN
                     IFNUSE(IUNIT(10))=0
                     IUNIT(10)=0
                  END IF
                  IF(IUNIT(11).NE.0) THEN
                     IFNUSE(IUNIT(11))=0
                     IUNIT(11)=0
                  END IF
                  IF(IUNIT(14).NE.0) THEN
                     IFNUSE(IUNIT(14))=0
                     IUNIT(14)=0
                  END IF
                  CALL FNMRMV
               END IF
            ELSE IF(ISOLVE.EQ.2) THEN
C  SIP
               IF(IUNIT(9).EQ.0) THEN
                  CALL FINDUN(19,IU,'SIP','SIP')
                  IUNIT(9)=IU
                  IF(IUNIT(13).NE.0) THEN
                     IFNUSE(IUNIT(13))=0
                     IUNIT(13)=0
                  END IF
                  IF(IUNIT(10).NE.0) THEN
                     IFNUSE(IUNIT(10))=0
                     IUNIT(10)=0
                  END IF
                  IF(IUNIT(11).NE.0) THEN
                     IFNUSE(IUNIT(11))=0
                     IUNIT(11)=0
                  END IF
                  IF(IUNIT(14).NE.0) THEN
                     IFNUSE(IUNIT(14))=0
                     IUNIT(14)=0
                  END IF
                  CALL FNMRMV
               END IF
            ELSE IF(ISOLVE.EQ.3) THEN
C  SOR
               IF(IUNIT(11).EQ.0) THEN
                  CALL FINDUN(21,IU,'SOR','SOR')
                  IUNIT(11)=IU
                  IF(IUNIT(13).NE.0) THEN
                     IFNUSE(IUNIT(13))=0
                     IUNIT(13)=0
                  END IF
                  IF(IUNIT(10).NE.0) THEN
                     IFNUSE(IUNIT(10))=0
                     IUNIT(10)=0
                  END IF
                  IF(IUNIT(9).NE.0) THEN
                     IFNUSE(IUNIT(9))=0
                     IUNIT(9)=0
                  END IF
                  IF(IUNIT(14).NE.0) THEN
                     IFNUSE(IUNIT(14))=0
                     IUNIT(14)=0
                  END IF
                  CALL FNMRMV
               END IF
            ELSE IF(ISOLVE.EQ.4) THEN
C  DE4
               IF(IUNIT(10).EQ.0) THEN
                  CALL FINDUN(20,IU,'DE4','DE4')
                  IUNIT(10)=IU
                  IF(IUNIT(13).NE.0) THEN
                     IFNUSE(IUNIT(13))=0
                     IUNIT(13)=0
                  END IF
                  IF(IUNIT(11).NE.0) THEN
                     IFNUSE(IUNIT(11))=0
                     IUNIT(11)=0
                  END IF
                  IF(IUNIT(9).NE.0) THEN
                     IFNUSE(IUNIT(9))=0
                     IUNIT(9)=0
                  END IF
                  IF(IUNIT(14).NE.0) THEN
                     IFNUSE(IUNIT(14))=0
                     IUNIT(14)=0
                  END IF
                  CALL FNMRMV
               END IF
            ELSE
C  LMG
               IF(IUNIT(14).EQ.0) THEN
                  CALL FINDUN(20,IU,'LMG','LMG')
                  IUNIT(14)=IU
                  IF(IUNIT(13).NE.0) THEN
                     IFNUSE(IUNIT(13))=0
                     IUNIT(13)=0
                  END IF
                  IF(IUNIT(11).NE.0) THEN
                     IFNUSE(IUNIT(11))=0
                     IUNIT(11)=0
                  END IF
                  IF(IUNIT(9).NE.0) THEN
                     IFNUSE(IUNIT(9))=0
                     IUNIT(9)=0
                  END IF
                  IF(IUNIT(10).NE.0) THEN
                     IFNUSE(IUNIT(10))=0
                     IUNIT(10)=0
                  END IF
                  CALL FNMRMV
               END IF
            END IF
C  Get data for all solvers -- even the unselected solvers
C  Get PCG data
            Call WDialogGetInteger(PCG_MXIPCG,MXIPCG)
            CALL IVLSAV('MXIPCG',0,0,MXIPCG)
            Call WDialogGetInteger(PCG_ITER1,ITER1)
            CALL IVLSAV('ITER1',0,0,ITER1)
            Call WDialogGetInteger(PCG_IPRPCG,IPRPCG)
            CALL IVLSAV('IPRPCG',0,0,IPRPCG)
            Call WDialogGetInteger(PCG_MUTPCG,MUTPCG)
            CALL IVLSAV('MUTPCG',0,0,MUTPCG)
            Call WDialogGetReal(PCG_HCLPCG,HCLPCG)
            CALL VALSAV('HCLPCG',0,0,HCLPCG)
            Call WDialogGetReal(PCG_RCLOSE,RCLOSE)
            CALL VALSAV('RCLOSE',0,0,RCLOSE)
            Call WDialogGetReal(PCG_RELAX,RELAX)
            CALL VALSAV('RELAX',0,0,RELAX)
            Call WDialogGetReal(PCG_DAMP,DAMP)
            CALL VALSAV('DAMP',0,0,DAMP)
C  Get SIP data
            Call WDialogGetInteger(SIP_MXISIP,MXISIP)
            CALL IVLSAV('MXISIP',0,0,MXISIP)
            Call WDialogGetReal(SIP_HCLSIP,HCLSIP)
            CALL VALSAV('HCLSIP',0,0,HCLSIP)
            Call WDialogGetReal(SIP_ACLSIP,ACLSIP)
            CALL VALSAV('ACLSIP',0,0,ACLSIP)
            Call WDialogGetReal(SIP_WSEED,WSEED)
            CALL VALSAV('WSEED',0,0,WSEED)
            Call WDialogGetInteger(SIP_IPRSIP,IPRSIP)
            CALL IVLSAV('IPRSIP',0,0,IPRSIP)
C  Get SOR data
            Call WDialogGetInteger(SOR_MXISOR,MXISOR)
            CALL IVLSAV('MXISOR',0,0,MXISOR)
            Call WDialogGetReal(SOR_HCLSOR,HCLSOR)
            CALL VALSAV('HCLSOR',0,0,HCLSOR)
            Call WDialogGetReal(SOR_ACLSOR,ACLSOR)
            CALL VALSAV('ACLSOR',0,0,ACLSOR)
            Call WDialogGetInteger(SOR_IPRSOR,IPRSOR)
            CALL IVLSAV('IPRSOR',0,0,IPRSOR)
C  Get DE4 data
            Call WDialogGetInteger(DE4_ITMX,ITMX)
            CALL IVLSAV('ITMX',0,0,ITMX)
            Call WDialogGetInteger(DE4_IFREQ,IFREQ)
            CALL IVLSAV('IFREQ',0,0,IFREQ)
            Call WDialogGetReal(DE4_HCLDE4,HCLDE4)
            CALL VALSAV('HCLDE4',0,0,HCLDE4)
            Call WDialogGetReal(DE4_ACLDE4,ACLDE4)
            CALL VALSAV('ACLDE4',0,0,ACLDE4)
            Call WDialogGetInteger(DE4_IPRD4,IPRD4)
            CALL IVLSAV('IPRD4',0,0,IPRD4)
            Call WDialogGetInteger(DE4_MUTD4,MUTD4)
            CALL IVLSAV('MUTD4',0,0,MUTD4)
            Call WDialogGetInteger(DE4_MXUP,MXUP)
            CALL IVLSAV('MXUP',0,0,MXUP)
            Call WDialogGetInteger(DE4_MXLOW,MXLOW)
            CALL IVLSAV('MXLOW',0,0,MXLOW)
            Call WDialogGetInteger(DE4_MXBW,MXBW)
            CALL IVLSAV('MXBW',0,0,MXBW)
C  Get LMG data
            Call WDialogGetInteger(LMG_MXILMG,MXILMG)
            CALL IVLSAV('MXILMG',0,0,MXILMG)
            Call WDialogGetInteger(LMG_MXCYC,MXCYC)
            CALL IVLSAV('MXCYC',0,0,MXCYC)
            Call WDialogGetInteger(LMG_IOUTAMG,IOUTAMG)
            CALL IVLSAV('IOUTAMG',0,0,IOUTAMG)
            Call WDialogGetReal(LMG_BCLOSE,BCLOSE)
            CALL VALSAV('BCLOSE',0,0,BCLOSE)
            Call WDialogGetReal(LMG_DAMP,DAMP_LMG)
            CALL VALSAV('DAMP_LMG',0,0,DAMP_LMG)
            Call WDialogGetReal(LMG_STOR1,STOR1)
            CALL VALSAV('STOR1',0,0,STOR1)
            Call WDialogGetReal(LMG_STOR2,STOR2)
            CALL VALSAV('STOR2',0,0,STOR2)
            Call WDialogGetReal(LMG_STOR3,STOR3)
            CALL VALSAV('STOR3',0,0,STOR3)
            CALL WDialogGetRadioButton(LMG_NOICG,ICG)
            CALL IVLSAV('ICG',0,0,ICG-1)
            Call WDialogGetReal(LMG_DUP,DUP)
            CALL VALSAV('DUP',0,0,DUP)
            Call WDialogGetReal(LMG_DLOW,DLOW)
            CALL VALSAV('DLOW',0,0,DLOW)
C  Done retrieving all solver data
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload
            RETURN
         ELSE
C  Assume IDCANCEL, which is the only other pushbutton
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload
            RETURN
         END IF
      END IF
      GO TO 50
C
      END
      SUBROUTINE RIVED
C     ******************************************************************
C     Edit RIV data
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
C  Common block for RIV Package
      COMMON /RIVCOM/RIVAUX(3)
      CHARACTER*16 RIVAUX
      PARAMETER (NUMIN=6)
      CHARACTER*12 LABEL(NUMIN,2),PLABL(NUMIN,2)
      DATA LABEL/ 'RIV Package',' ',' ',' ',' ',' ',
     1            'Layer','Row','Column','Stage','Cond','Rbot'/
      DATA PLABL/ 'RIV Package',' ',' ',' ',' ',' ',
     1            'Layer','Row','Column','Stage','Condfact','Rbot'/
C     ------------------------------------------------------------------
      IULOC=4
      IU=IUNIT(IULOC)
C
C  Set IUNIT if not already set
      IF(IU.EQ.0) THEN
         CALL FINDUN(IULOC+10,IU,'RIV','RIV')
         IUNIT(IULOC)=IU
         IUNIT2(IULOC)=0
      END IF
C
C  Activate IFACE as an AUX field if MODPATH is active
      IF(IUNIT(40).GT.0) THEN
         IF(RIVAUX(1).NE.'IFACE' .AND. RIVAUX(2).NE.'IFACE'
     1       .AND. RIVAUX(3).NE.'IFACE') THEN
            IF(RIVAUX(1).EQ.' ') THEN
               RIVAUX(1)='IFACE'
            ELSE IF(RIVAUX(2).EQ.' ') THEN
               RIVAUX(2)='IFACE'
            ELSE IF(RIVAUX(3).EQ.' ') THEN
               RIVAUX(3)='IFACE'
            END IF
         END IF
      END IF
C
C  Activate CONC as an AUX field if MOC is active
      IF(IUNIT(15).GT.0) THEN
         IF(RIVAUX(1).NE.'CONC' .AND. RIVAUX(1).NE.'CONCENTRATION'
     1   .AND. RIVAUX(2).NE.'CONC' .AND. RIVAUX(2).NE.'CONCENTRATION'
     2   .AND. RIVAUX(3).NE.'CONC' .AND. RIVAUX(3).NE.'CONCENTRATION')
     3         THEN
            IF(RIVAUX(1).EQ.' ') THEN
               RIVAUX(1)='CONC'
            ELSE IF(RIVAUX(2).EQ.' ') THEN
               RIVAUX(2)='CONC'
            ELSE IF(RIVAUX(3).EQ.' ') THEN
               RIVAUX(3)='CONC'
            END IF
         END IF
      END IF
      CALL ULSTIN(LABEL,'RIVR',NUMIN,RIVAUX,3,IU,'RIV Package','RIV',
     1          IULOC,PLABL)
C
C  End of RIV data input
      CALL RIVSV(IUNDEF,1)
      RETURN
C
      END
      SUBROUTINE DRNED
C     ******************************************************************
C     Edit DRN data
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
C  Common block for DRN Package
      COMMON /DRNCOM/DRNAUX(3)
      CHARACTER*16 DRNAUX
      PARAMETER (NUMIN=5)
      CHARACTER*12 LABEL(NUMIN,2),PLABL(NUMIN,2)
      DATA LABEL/'DRN Package',' ',' ',' ',' ',
     1           'Layer','Row','Column','Elev.','Cond'/
      DATA PLABL/'DRN Package',' ',' ',' ',' ',
     1           'Layer','Row','Column','Elev.','Condfact'/
C     ------------------------------------------------------------------
      IULOC=3
      IU=IUNIT(IULOC)
C
C  Set IUNIT if not already set
      IF(IU.EQ.0) THEN
         CALL FINDUN(IULOC+10,IU,'DRN','DRN')
         IUNIT(IULOC)=IU
         IUNIT2(IULOC)=0
      END IF
C
C  Activate IFACE as an AUX field if MODPATH is active
      IF(IUNIT(40).GT.0) THEN
         IF(DRNAUX(1).NE.'IFACE' .AND. DRNAUX(2).NE.'IFACE'
     1       .AND. DRNAUX(3).NE.'IFACE') THEN
            IF(DRNAUX(1).EQ.' ') THEN
               DRNAUX(1)='IFACE'
            ELSE IF(DRNAUX(2).EQ.' ') THEN
               DRNAUX(2)='IFACE'
            ELSE IF(DRNAUX(3).EQ.' ') THEN
               DRNAUX(3)='IFACE'
            END IF
         END IF
      END IF
      CALL ULSTIN(LABEL,'DRAI',NUMIN,DRNAUX,3,IU,'DRN Package','DRN',
     1       IULOC,PLABL)
C
C  End of DRN data input
      CALL DRNSV(IUNDEF,1)
      RETURN
C
      END
      SUBROUTINE WELED
C     ******************************************************************
C     Edit WELL data
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
C  Common block for WEL Package
      COMMON /WELCOM/WELAUX(3)
      CHARACTER*16 WELAUX
      PARAMETER (NUMIN=4)
      CHARACTER*12 LABEL(NUMIN,2),PLABL(NUMIN,2)
      DATA LABEL/'WEL Package',' ',' ',' ',
     1           'Layer','Row','Column','Q'/
      DATA PLABL/'WEL Package',' ',' ',' ',
     1           'Layer','Row','Column','Qfact'/
C     ------------------------------------------------------------------
      IULOC=2
      IU=IUNIT(IULOC)
C
C  Set IUNIT if not already set
      IF(IU.EQ.0) THEN
         CALL FINDUN(IULOC+10,IU,'WEL','WEL')
         IUNIT(IULOC)=IU
         IUNIT2(IULOC)=0
      END IF
C
C  Activate IFACE as an AUX field if MODPATH is active
      IF(IUNIT(40).GT.0) THEN
         IF(WELAUX(1).NE.'IFACE' .AND. WELAUX(2).NE.'IFACE'
     1       .AND. WELAUX(3).NE.'IFACE') THEN
            IF(WELAUX(1).EQ.' ') THEN
               WELAUX(1)='IFACE'
            ELSE IF(WELAUX(2).EQ.' ') THEN
               WELAUX(2)='IFACE'
            ELSE IF(WELAUX(3).EQ.' ') THEN
               WELAUX(3)='IFACE'
            END IF
         END IF
      END IF
C
C  Activate CONC as an AUX field if MOC is active
      IF(IUNIT(15).GT.0) THEN
         IF(WELAUX(1).NE.'CONC' .AND. WELAUX(1).NE.'CONCENTRATION'
     1   .AND. WELAUX(2).NE.'CONC' .AND. WELAUX(2).NE.'CONCENTRATION'
     2   .AND. WELAUX(3).NE.'CONC' .AND. WELAUX(3).NE.'CONCENTRATION')
     3         THEN
            IF(WELAUX(1).EQ.' ') THEN
               WELAUX(1)='CONC'
            ELSE IF(WELAUX(2).EQ.' ') THEN
               WELAUX(2)='CONC'
            ELSE IF(WELAUX(3).EQ.' ') THEN
               WELAUX(3)='CONC'
            END IF
         END IF
      END IF
      CALL ULSTIN(LABEL,'WELL',NUMIN,WELAUX,3,IU,'WEL Package','Q',
     1        IULOC,PLABL)
C
C  End of WELL data input
      CALL WELSV(IUNDEF,1)
      RETURN
C
      END
      SUBROUTINE GHBED
C     ******************************************************************
C     Edit GHB data
C     ******************************************************************
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
C  Common block for GHB Package
      COMMON /GHBCOM/GHBAUX(3)
      CHARACTER*16 GHBAUX
      PARAMETER (NUMIN=5)
      CHARACTER*12 LABEL(NUMIN,2),PLABL(NUMIN,2)
      DATA LABEL/'GHB Package',' ',' ',' ',' ',
     1           'Layer','Row','Column','Bhead','Cond'/
      DATA PLABL/'GHB Package',' ',' ',' ',' ',
     1           'Layer','Row','Column','Bhead','Confact'/
C     ------------------------------------------------------------------
      IULOC=7
      IU=IUNIT(IULOC)
C
C  Set IUNIT if not already set
      IF(IU.EQ.0) THEN
         CALL FINDUN(IULOC+10,IU,'GHB','GHB')
         IUNIT(IULOC)=IU
         IUNIT2(IULOC)=0
      END IF
C
C  Activate IFACE as an AUX field if MODPATH is active
      IF(IUNIT(40).GT.0) THEN
         IF(GHBAUX(1).NE.'IFACE' .AND. GHBAUX(2).NE.'IFACE'
     1       .AND. GHBAUX(3).NE.'IFACE') THEN
            IF(GHBAUX(1).EQ.' ') THEN
               GHBAUX(1)='IFACE'
            ELSE IF(GHBAUX(2).EQ.' ') THEN
               GHBAUX(2)='IFACE'
            ELSE IF(GHBAUX(3).EQ.' ') THEN
               GHBAUX(3)='IFACE'
            END IF
         END IF
      END IF
C
C  Activate CONC as an AUX field if MOC is active
      IF(IUNIT(15).GT.0) THEN
         IF(GHBAUX(1).NE.'CONC' .AND. GHBAUX(1).NE.'CONCENTRATION'
     1   .AND. GHBAUX(2).NE.'CONC' .AND. GHBAUX(2).NE.'CONCENTRATION'
     2   .AND. GHBAUX(3).NE.'CONC' .AND. GHBAUX(3).NE.'CONCENTRATION')
     3         THEN
            IF(GHBAUX(1).EQ.' ') THEN
               GHBAUX(1)='CONC'
            ELSE IF(GHBAUX(2).EQ.' ') THEN
               GHBAUX(2)='CONC'
            ELSE IF(GHBAUX(3).EQ.' ') THEN
               GHBAUX(3)='CONC'
            END IF
         END IF
      END IF
      CALL ULSTIN(LABEL,'BNDS',NUMIN,GHBAUX,3,IU,'GHB Package','GHB',
     1        IULOC,PLABL)
C
C  End of GHB data input
      CALL GHBSV(IUNDEF,1)
      RETURN
C
      END
      SUBROUTINE RCHED
C     ******************************************************************
C     Input RCH Package data
C     ******************************************************************
C
      INCLUDE 'mfi2k.inc'
      CHARACTER*8 ARRNAM(2)
      DATA ARRNAM/'RECH','IRCH'/
C  ---------------------------------------------------------------------
      IULOC=8
C
      IF(IUNIT(IULOC).EQ.0) THEN
         CALL FINDUN(18,IU,'RCH','RCH')
         IUNIT(IULOC)=IU
         IUNIT2(IULOC)=0
      END IF
C
      IUPACK=IUNIT(IULOC)
      CALL U2DPARPERIN('RCH Package',ARRNAM,2,NCOL,NROW,IUPACK,3,
     1     'NRCHOP','RCH',IULOC)
      CALL RCHSV(IUNDEF,1)
      RETURN
C
      END
      SUBROUTINE EVTED
C  *********************************************************************
C  Input EVT Package data
C  *********************************************************************
C
      INCLUDE 'mfi2k.inc'
      CHARACTER*8 ARRNAM(4)
      DATA ARRNAM/'EVTR','SURF','EXDP','IEVT'/
C  ---------------------------------------------------------------------
      IULOC=5
C
      IF(IUNIT(IULOC).EQ.0) THEN
         CALL FINDUN(15,IU,'EVT','EVT')
         IUNIT(IULOC)=IU
         IUNIT2(IULOC)=0
      END IF
C
      IUPACK=IUNIT(IULOC)
      CALL U2DPARPERIN('EVT Package',ARRNAM,4,NCOL,NROW,IUPACK,2,
     1            'NEVTOP','EVT',IULOC)
      CALL EVTSV(IUNDEF,1)
      RETURN
C
      END
      SUBROUTINE DISED(INDIS)
C     ******************************************************************
C     Input DIS Option Data
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C
      INCLUDE 'mfi2k.inc'
      COMMON /DISCOM/LBOTM(200),LAYCBD(200)
      COMMON /PERCOM/PERLEN(MXPER),NSTP(MXPER),TSMULT(MXPER),
     1               ISSFLG(MXPER)
C
      TYPE(WIN_MESSAGE)   :: MESSAGE
      DIMENSION IPER(MXPER),LAY(200),LAYSET(200)
      CHARACTER*6 ARRNAM(400)
      CHARACTER*40 CLAY(400)
      DIMENSION LAYER(400)
C     ------------------------------------------------------------------
      IULOC=24
C
      CALL WDialogLoad(DIS_DIALOG)
      CALL WDialogShow(-1,50,0,SemiModeless)
C
5     CALL WMessage(ITYPE,MESSAGE)
C
C  Check for push buttons
      IF(ITYPE.EQ.PushButton) THEN
         IF(MESSAGE%VALUE1.EQ.DIS_CHECK_BUT) THEN
            CALL DISSV(IUNDEF,-1)
         ELSE IF(MESSAGE%VALUE1.EQ.DIS_UNITS_BUT) THEN
C  Units BUTTON
            CALL WDialogLoad(DIS_UNITS_DIALOG)
C  Initialize values
            CALL IVLGET('ITMUNI',0,0,ITYPE,ITMUNI)
            IF(ITYPE.NE.0) ITMUNI=0
            CALL WDialogPutOption(TIME_UNITS,ITMUNI+1)
            CALL IVLGET('LENUNI',0,0,ITYPE,LENUNI)
            IF(ITYPE.NE.0) LENUNI=0
            CALL WDialogPutOption(LENGTH_UNITS,LENUNI+1)
C  Make Units Dialog visible
            CALL WDialogShow(-1,50,0,MODAL)
C  Get and store values if "OK" was pushed
            IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
               CALL WDialogGetMenu(TIME_UNITS,ITMUNI)
               ITMUNI=ITMUNI-1
               CALL IVLSAV('ITMUNI',0,0,ITMUNI)
               CALL WDialogGetMenu(Length_UNITS,LENUNI)
               LENUNI=LENUNI-1
               CALL IVLSAV('LENUNI',0,0,LENUNI)
            END IF
            CALL WDialogUnload(DIS_UNITS_DIALOG)
C
         ELSE IF(MESSAGE%VALUE1.EQ.DIS_DELR_BUT) THEN
C  DELR PUSHBUTTON
            CALL U2DIN('DELR','DELR',NCOL,1,IUNIT(IULOC),0,0)
C
         ELSE IF(MESSAGE%VALUE1.EQ.DIS_DELC_BUT) THEN
C  DELC PUSHBUTTON
            CALL U2DIN('DELC','DELC',1,NROW,IUNIT(IULOC),0,0)
C
         ELSE IF(MESSAGE%VALUE1.EQ.DIS_LAYCBD_BUT) THEN
C  LAYCBD PUSHBUTTON
            CALL WDialogLoad(DIS_LAYCBD_DIALOG)
C  Initialize values
               DO 50 K=1,NLAY
               LAY(K)=K
               LAYSET(K)=1
               IF(LAYCBD(K).NE.0) LAYSET(K)=2
50             CONTINUE
               CALL WGridRows(LAYCBD_GRID,NLAY)
               CALL WGridPutInteger(LAYCBD_GRID,1,LAY,NLAY)
               CALL WGridPutOption(LAYCBD_GRID,2,LAYSET,NLAY)
               CALL WGridStateCell(LAYCBD_GRID,2,NLAY,DialogReadOnly)
C  Make Units Dialog visible
            CALL WDialogShow(-1,50,0,MODAL)
C  Get and store values if "OK" was pushed
            IF(WInfoDialog(ExitButton).EQ.IDOK) THEN
               CALL WGridGetMenu(LAYCBD_GRID,2,LAYSET,NLAY)
               DO 60 K=1,NLAY
               LAYCBD(K)=LAYSET(K)-1
60             CONTINUE
            END IF
            CALL WDialogUnload(DIS_LAYCBD_DIALOG)
C
         ELSE IF(MESSAGE%VALUE1.EQ.DIS_TOP_BUT) THEN
C  TOP PUSHBUTTON
            CALL U2DIN('System Top Elevation','TOP',NCOL,NROW,INDIS,1,0)
C
         ELSE IF(MESSAGE%VALUE1.EQ.DIS_BOT_BUT) THEN
C  BOTM PUSHBUTTON
C  Make a list of array labels.
            NBOTM=0
            DO 70 K=1,NLAY
            NBOTM=NBOTM+1
            WRITE(CLAY(NBOTM),68) K
68          FORMAT('Bottom Elevation for Layer',I4)
            ARRNAM(NBOTM)='BOT'
            LAYER(NBOTM)=K
            IF(LAYCBD(K).NE.0) THEN
               NBOTM=NBOTM+1
               WRITE(CLAY(NBOTM),69) K
69             FORMAT('El. of Conf. bed bottom below Layer',I4)
               ARRNAM(NBOTM)='CBDBOT'
               LAYER(NBOTM)=K
            END IF
70          CONTINUE
            CALL UGARRIN(NBOTM,CLAY,ARRNAM,LAYER,INDIS,
     1          'Bottom Elevation Dialog')
C
         ELSE IF(MESSAGE%VALUE1.EQ.DIS_PERIODS_BUT) THEN
C  PERIODS PUSHBUTTON
            CALL PERED
            ISS=1
            DO 102 N=1,NPER
            IF(ISSFLG(N).EQ.0) ISS=0
102         CONTINUE
C
         ELSE IF(MESSAGE%VALUE1.EQ.DIS_COMMENT_BUT) THEN
C  COMMENT PUSHBUTTON
            CALL COMNTIN(IULOC)
C
         ELSE IF(MESSAGE%VALUE1.EQ.IDCLOSE) THEN
C  CLOSE PUSHBUTTON -- done with DIS dialog
            CALL DISSV(IUNDEF,1)
            CALL WDialogUnload(DIS_DIALOG)
            RETURN
         END IF
         CALL WDialogSelect(DIS_DIALOG)
      END IF
      GO TO 5
C
      END
      SUBROUTINE UGARRIN(NUMARR,LABARR,ARRNAM,LAYER,IUPACK,LABEL)
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C     ******************************************************************
C     Prompt user for a group of arrays
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
C
      CHARACTER*(*) LABEL
      DIMENSION LAYER(NUMARR)
      CHARACTER*(*) LABARR(NUMARR),ARRNAM(NUMARR)
      CHARACTER*67 FNAME
      CHARACTER*20 FMT
C     ------------------------------------------------------------------
C
C  Load the 3D-array dialog
      CALL WDialogLoad(GARRIN_DIALOG)
      CALL WDialogTitle(LABEL)
      CALL WMessageEnable(FieldChanged,Enabled)
C
C  Initialize values
      NB=1
      CALL WDialogPutMenu(ARRAY_LAYER,LABARR,NUMARR,NB)
C  
C  Find array -- create if it doesn't already exist
25    CALL VALGET(ARRNAM(NB),LAYER(NB),0,NAR,V)
      IF(NAR.LE.0) THEN
         CALL ARRMAK(ARRNAM(NB),LAYER(NB),0,NCOL,NROW)
         NAR=NARRAY
      END IF
C  Define defaults
      IATYPE=1
      CON1=0.
      CON2=1.
      CON3=1.
      FMT='(10F8.0)'
      FNAME=' '
      IFTYP=1   ! 1=File Name, 2=OPEN/CLOSE
      IPRN=0
      LOCAT=IARRDA(1,NAR)
      IF(LOCAT.EQ.0) THEN
         IF(ARRCON(NAR) .NE. RMISS) CON1=ARRCON(NAR)
         CON2=1.0
         CON3=CON2
      ELSE IF(LOCAT.EQ.-1) THEN
         IATYPE=2
         CON2=ARRCON(NAR)
         CON1=CON2
         CON3=CON2
      ELSE IF(LOCAT.GT.0) THEN
         IATYPE=3
         CON3=ARRCON(NAR)
         CON1=CON3
         CON2=CON3
         FMT=ARRFMT(NAR)
         FNAME=FILNAM(LOCAT)
         IPRN=IARRDA(5,NAR)
         IF(FILTYP(LOCAT)(1:10).EQ.'OPEN/CLOSE') IFTYP=2
      END IF
C
C  Set current values for array
30    IF(IATYPE.EQ.1) THEN
         CALL WDialogPutRadioButton(ARRAY_TYPE_CONSTANT)
         CALL WDialogFieldState(ARRAY_CONSTANT,Enabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER,Disabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER2,Disabled)
         CALL WDialogFieldState(ARRAY_IPRN,Disabled)
         CALL WDialogFieldState(ARRAY_FORMAT,Disabled)
         CALL WDialogFieldState(ARRAY_FILE,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(ARRAY_FILE_TYPE,Disabled)
         CALL WDialogFieldState(ARRAY_SPREADSHEET,Disabled)
         CALL WDialogFieldState(ARRAY_GRID,Disabled)
      ELSE IF(IATYPE.EQ.2) THEN
         CALL WDialogPutRadioButton(ARRAY_TYPE_PACKAGE)
         CALL WDialogFieldState(ARRAY_CONSTANT,Disabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER,Enabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER2,Disabled)
         CALL WDialogFieldState(ARRAY_IPRN,Disabled)
         CALL WDialogFieldState(ARRAY_FORMAT,Disabled)
         CALL WDialogFieldState(ARRAY_FILE,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(ARRAY_FILE_TYPE,Disabled)
         CALL WDialogFieldState(ARRAY_SPREADSHEET,Enabled)
         IF(NCOL.GT.100 .OR. NROW.GT.100) THEN
            CALL WDialogFieldState(ARRAY_GRID,Disabled)
         ELSE
            CALL WDialogFieldState(ARRAY_GRID,Enabled)
         END IF
      ELSE
         CALL WDialogPutRadioButton(ARRAY_TYPE_SEPARATE)
         CALL WDialogFieldState(ARRAY_CONSTANT,Disabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER,Disabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER2,Enabled)
         CALL WDialogFieldState(ARRAY_IPRN,Enabled)
         CALL WDialogFieldState(ARRAY_FORMAT,Enabled)
         CALL WDialogFieldState(ARRAY_FILE,Enabled)
         CALL WDialogFieldState(FILE_BROWSE,Enabled)
         CALL WDialogFieldState(ARRAY_FILE_TYPE,Enabled)
         CALL WDialogFieldState(ARRAY_SPREADSHEET,Disabled)
         CALL WDialogFieldState(ARRAY_GRID,Disabled)
      END IF
      CALL WDialogPutInteger(ARRAY_IPRN,IPRN)
      CALL WDialogPutReal(ARRAY_CONSTANT,CON1,'(1PG13.6)')
      CALL WDialogPutReal(ARRAY_MULTIPLIER,CON2,'(1PG13.6)')
      CALL WDialogPutReal(ARRAY_MULTIPLIER2,CON3,'(1PG13.6)')
      CALL WDialogPutString(ARRAY_FORMAT,FMT)
      CALL WDialogPutString(ARRAY_FILE,FNAME)
      CALL WDialogPutOption(ARRAY_FILE_TYPE,IFTYP)
C
C  Make Array Dialog visible
      CALL WDialogShow(-1,50,0,SemiModeless)
50    CALL WMessage(ITYPE,MESSAGE)
C
C  Act upon field changes
      IF(ITYPE.EQ.FieldChanged) THEN
C
C  Check for array change
         CALL WDialogGetMenu(ARRAY_LAYER,NBNEW)
         IF(NBNEW.NE.NB) THEN
            CALL U3DINGET(NAR,IUPACK,IERR)
            CALL WDialogSelect(GARRIN_DIALOG)
            IF(IERR.NE.0) GO TO 25
            NB=NBNEW
            GO TO 25
         END IF
C
C  Check for array type change
         CALL WDialogGetRadioButton(ARRAY_TYPE_CONSTANT,IATNEW)
         IF(IATNEW.NE.IATYPE) THEN
            IATYPE=IATNEW
            IF(IATYPE.EQ.2 .AND. IARRDA(2,NAR).EQ.0) THEN
               CALL ARRALO(IARRDA(2,NAR),IARRDA(3,NAR),IARRDA(4,NAR))
               LOC=IARRDA(2,NAR)
               CALL ZIPR(NCOL*NROW,0.,X(LOC))
C               CALL SS2DR(X(LOC),NCOL,NROW,ARRNAM(NB),GARRIN_DIALOG)
               CALL WMessageEnable(FieldChanged,Enabled)
               CALL WDialogSelect(GARRIN_DIALOG)
            END IF
            GO TO 30
         END IF
C
C  Check for push buttons
      ELSE IF(ITYPE.EQ.PushButton) THEN
C
C  Check for ARRAY_SPREADSHEET
         IF(MESSAGE%VALUE1.EQ.ARRAY_SPREADSHEET) THEN
            LOC=IARRDA(2,NAR)
            CALL SS2DR(X(LOC),NCOL,NROW,ARRNAM(NB),GARRIN_DIALOG)
            CALL WDialogSelect(GARRIN_DIALOG)
            CALL WMessageEnable(FieldChanged,Enabled)
C
C  Check for ARRAY_GRID
         ELSE IF(MESSAGE%VALUE1.EQ.ARRAY_GRID) THEN
            IF(NCOL.LE.100 .AND. NROW.LE.100) THEN
              LOC=IARRDA(2,NAR)
              CALL SS2DRG(X(LOC),NCOL,NROW,ARRNAM(NB),GARRIN_DIALOG)
              CALL WDialogSelect(GARRIN_DIALOG)
              CALL WMessageEnable(FieldChanged,Enabled)
            END IF
C
C  Check for BROWSE
         ELSE IF(MESSAGE%VALUE1.EQ.FILE_BROWSE) THEN
            CALL BROWSE(FNAME)
            CALL WDialogSelect(GARRIN_DIALOG)
            GO TO 30
C
C  Check for OK
         ELSE IF(MESSAGE%VALUE1.EQ.ARRAY_DIALOG_IDOK) THEN
            CALL U3DINGET(NAR,IUPACK,IERR)
            CALL WDialogSelect(GARRIN_DIALOG)
            IF(IERR.NE.0) GO TO 50
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(GARRIN_DIALOG)
            RETURN
C
C  Check for CANCEL
         ELSE IF(MESSAGE%VALUE1.EQ.IDCANCEL) THEN
C  Exit without storing values
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(GARRIN_DIALOG)
            RETURN
         END IF
C
C  Ignore all other types of message
      END IF
      GO TO 50
C
      END
      SUBROUTINE MULTED()
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C     ******************************************************************
C     Prompt user for multiplier arrays
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
C
      CHARACTER*67 FNAME
      CHARACTER*20 FMT
      CHARACTER*10 ARRNAM,CTMP1
      CHARACTER*80 STRING
      CHARACTER*10 CNONE(1)
      DATA CNONE/'(None)'/
C     ------------------------------------------------------------------
      IULOC=32
      IUPACK=IUNIT(IULOC)
      IF(IUPACK.LE.0) THEN
         CALL FINDUN(42,IUPACK,'MULT','MLT')
         IUNIT(IULOC)=IUPACK
      END IF
      NB=1
C
C  Load the Multiplier dialog
      CALL WDialogLoad(MULT_DIALOG)
      CALL WDialogTitle('Define Multiplier Arrays')
      CALL WMessageEnable(FieldChanged,Enabled)
C
C  Initialize values
C  Make a list of multiplier names.
10    NML=0
      DO 20 K=1,MXMLT
      IF(MLTNAM(K).NE.' ') THEN
         NML=NML+1
      ELSE
         GO TO 21
      END IF
20    CONTINUE
21    IF(NML.GT.0) THEN
         CALL WDialogPutMenu(MULT_NAME,MLTNAM,NML,NB)
      ELSE
         CALL WDialogPutMenu(MULT_NAME,CNONE,1,NB)
      END IF
C  
C  Find array -- create if it doesn't already exist
25    IF(NML.GT.0) THEN
         ARRNAM=MLTNAM(NB)
         CALL UPCASE(ARRNAM)
         CALL VALGET(ARRNAM,-2,-2,NAR,V)
         IF(NAR.LE.0) THEN
            CALL ARRMAK(ARRNAM,-2,-2,NCOL,NROW)
            NAR=NARRAY
         END IF
      END IF
C  Define defaults
      IATYPE=1
      CON1=0.
      CON2=1.
      CON3=1.
      FMT='(10F8.0)'
      FNAME=' '
      IFTYP=1   ! 1=File Name, 2=OPEN/CLOSE
      IPRN=0
      IF(NML.GT.0) THEN
         LOCAT=IARRDA(1,NAR)
         IF(LOCAT.EQ.0) THEN
            IF(ARRCON(NAR) .NE. RMISS) CON1=ARRCON(NAR)
            CON2=1.0
            CON3=CON2
         ELSE IF(LOCAT.EQ.-1) THEN
            IATYPE=2
            CON2=ARRCON(NAR)
            CON1=CON2
            CON3=CON2
         ELSE IF(LOCAT.GT.0) THEN
            IATYPE=3
            CON3=ARRCON(NAR)
            CON1=CON3
            CON2=CON3
            FMT=ARRFMT(NAR)
            FNAME=FILNAM(LOCAT)
            IPRN=IARRDA(5,NAR)
            IF(FILTYP(LOCAT)(1:10).EQ.'OPEN/CLOSE') IFTYP=2
         END IF
      END IF
C
C  Set current values for array
30    IF(IATYPE.EQ.1) THEN
         CALL WDialogPutRadioButton(ARRAY_TYPE_CONSTANT)
         CALL WDialogFieldState(ARRAY_CONSTANT,Enabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER,Disabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER2,Disabled)
         CALL WDialogFieldState(ARRAY_IPRN,Disabled)
         CALL WDialogFieldState(ARRAY_FORMAT,Disabled)
         CALL WDialogFieldState(ARRAY_FILE,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(ARRAY_FILE_TYPE,Disabled)
         CALL WDialogFieldState(ARRAY_SPREADSHEET,Disabled)
         CALL WDialogFieldState(ARRAY_GRID,Disabled)
      ELSE IF(IATYPE.EQ.2) THEN
         CALL WDialogPutRadioButton(ARRAY_TYPE_PACKAGE)
         CALL WDialogFieldState(ARRAY_CONSTANT,Disabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER,Enabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER2,Disabled)
         CALL WDialogFieldState(ARRAY_IPRN,Disabled)
         CALL WDialogFieldState(ARRAY_FORMAT,Disabled)
         CALL WDialogFieldState(ARRAY_FILE,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(ARRAY_FILE_TYPE,Disabled)
         CALL WDialogFieldState(ARRAY_SPREADSHEET,Enabled)
         IF(NCOL.GT.100 .OR. NROW.GT.100) THEN
            CALL WDialogFieldState(ARRAY_GRID,Disabled)
         ELSE
            CALL WDialogFieldState(ARRAY_GRID,Enabled)
         END IF
      ELSE
         CALL WDialogPutRadioButton(ARRAY_TYPE_SEPARATE)
         CALL WDialogFieldState(ARRAY_CONSTANT,Disabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER,Disabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER2,Enabled)
         CALL WDialogFieldState(ARRAY_IPRN,Enabled)
         CALL WDialogFieldState(ARRAY_FORMAT,Enabled)
         CALL WDialogFieldState(ARRAY_FILE,Enabled)
         CALL WDialogFieldState(FILE_BROWSE,Enabled)
         CALL WDialogFieldState(ARRAY_FILE_TYPE,Enabled)
         CALL WDialogFieldState(ARRAY_SPREADSHEET,Disabled)
         CALL WDialogFieldState(ARRAY_GRID,Disabled)
      END IF
      IF(NML.GT.0) THEN
         CALL WDialogFieldState(MULT_DELETE,Enabled)
         CALL WDialogFieldState(ARRAY_TYPE_PACKAGE,Enabled)
         CALL WDialogFieldState(ARRAY_TYPE_SEPARATE,Enabled)
      ELSE
         CALL WDialogFieldState(MULT_DELETE,Disabled)
         CALL WDialogFieldState(ARRAY_TYPE_PACKAGE,Disabled)
         CALL WDialogFieldState(ARRAY_TYPE_SEPARATE,Disabled)
      END IF
      CALL WDialogPutInteger(ARRAY_IPRN,IPRN)
      CALL WDialogPutReal(ARRAY_CONSTANT,CON1,'(1PG13.6)')
      CALL WDialogPutReal(ARRAY_MULTIPLIER,CON2,'(1PG13.6)')
      CALL WDialogPutReal(ARRAY_MULTIPLIER2,CON3,'(1PG13.6)')
      CALL WDialogPutString(ARRAY_FORMAT,FMT)
      CALL WDialogPutString(ARRAY_FILE,FNAME)
      CALL WDialogPutOption(ARRAY_FILE_TYPE,IFTYP)
C
C  Make Array Dialog visible
      CALL WDialogShow(-1,50,0,SemiModeless)
50    CALL WMessage(ITYPE,MESSAGE)
C
C  Act upon field changes
      IF(ITYPE.EQ.FieldChanged) THEN
C
C  Check for array change
         CALL WDialogGetMenu(MULT_NAME,NBNEW)
         IF(NBNEW.NE.NB) THEN
            CALL U3DINGET(NAR,IUPACK,IERR)
            CALL WDialogSelect(MULT_DIALOG)
            IF(IERR.NE.0) GO TO 25
            NB=NBNEW
            GO TO 25
         END IF
C
C  Check for array type change
         CALL WDialogGetRadioButton(ARRAY_TYPE_CONSTANT,IATNEW)
         IF(IATNEW.NE.IATYPE) THEN
            IATYPE=IATNEW
            IF(IATYPE.EQ.2 .AND. IARRDA(2,NAR).EQ.0) THEN
               CALL ARRALO(IARRDA(2,NAR),IARRDA(3,NAR),IARRDA(4,NAR))
               LOC=IARRDA(2,NAR)
               CALL ZIPR(NCOL*NROW,0.,X(LOC))
C               CALL SS2DR(X(LOC),NCOL,NROW,ARRNAM,MULT_DIALOG)
               CALL WDialogSelect(MULT_DIALOG)
               CALL WMessageEnable(FieldChanged,Enabled)
            END IF
            GO TO 30
         END IF
C
C  Check for push buttons
      ELSE IF(ITYPE.EQ.PushButton) THEN
C
C  Check for ARRAY_SPREADSHEET
         IF(MESSAGE%VALUE1.EQ.ARRAY_SPREADSHEET) THEN
            LOC=IARRDA(2,NAR)
            CALL SS2DR(X(LOC),NCOL,NROW,ARRNAM,MULT_DIALOG)
            CALL WDialogSelect(MULT_DIALOG)
            CALL WMessageEnable(FieldChanged,Enabled)
C
C  Check for ARRAY_GRID
         ELSE IF(MESSAGE%VALUE1.EQ.ARRAY_GRID) THEN
            IF(NCOL.LE.100 .AND. NROW.LE.100) THEN
              LOC=IARRDA(2,NAR)
              CALL SS2DRG(X(LOC),NCOL,NROW,ARRNAM,MULT_DIALOG)
              CALL WDialogSelect(MULT_DIALOG)
            END IF
C
C  COMMENT PUSHBUTTON
         ELSE IF(MESSAGE%VALUE1.EQ.MULT_COMMENT) THEN
            CALL COMNTIN(IULOC)
            CALL WDialogSelect(MULT_DIALOG)
            CALL WMessageEnable(FieldChanged,Enabled)
C
C  Check for ADD
         ELSE IF(MESSAGE%VALUE1.EQ.MULT_ADD) THEN
            IF(NML.GT.0) THEN
               CALL U3DINGET(NAR,IUPACK,IERR)
               CALL WDialogSelect(MULT_DIALOG)
               IF(IERR.NE.0) GO TO 50
            END IF
            CALL WMessageEnable(FieldChanged,Disabled)
68          CALL GETSTRING('Enter name of new multiplier array',
     1            STRING,IERR,NCSTR)
            CALL WDialogSelect(MULT_DIALOG)
            CALL WMessageEnable(FieldChanged,Enabled)
            IF(IERR.EQ.0) THEN
               ARRNAM=STRING(1:NCSTR)
               CALL UPCASE(ARRNAM)
               LLOC=1
               DO 70 I=1,NML
               CTMP1=MLTNAM(I)
               CALL UPCASE(CTMP1)
               IF(CTMP1.EQ.ARRNAM) THEN
                  CALL WMessageBox(OKOnly,ExclamationIcon,CommonOK,
     1            ' Duplicate name',' ')
                  GO TO 68
               END IF
70             CONTINUE
               NML=NML+1
               MLTNAM(NML)=STRING(1:NCSTR)
               NB=NML
               GO TO 10
            END IF
C
C  Check for DELETE multiplier
         ELSE IF(MESSAGE%VALUE1.EQ.MULT_DELETE) THEN
            CALL U3DINGET(NAR,IUPACK,IERR)
            CALL WDialogSelect(MULT_DIALOG)
            IF(IERR.NE.0) GO TO 50
            IF(NB.NE.NML) THEN
               DO 80 I=NB,NML-1
               MLTNAM(I)=MLTNAM(I+1)
80             CONTINUE
            END IF
            MLTNAM(NML)=' '
            NML=NML-1
            NB=NB-1
            IF(NB.LT.1) NB=1
            GO TO 10
C
C  Check for CANCEL
         ELSE IF(MESSAGE%VALUE1.EQ.IDCANCEL) THEN
C  Exit without storing values
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(MULT_DIALOG)
            CALL MULTSV(IUNDEF,1)
            RETURN
C
C  Check for Browse
         ELSE IF(MESSAGE%VALUE1.EQ.FILE_BROWSE) THEN
            CALL BROWSE(FNAME)
            CALL WDialogSelect(MULT_DIALOG)
            GO TO 30
C
C  Check for OK
         ELSE IF(MESSAGE%VALUE1.EQ.MULT_DIALOG_IDOK) THEN
            IF(NML.GT.0) THEN
               CALL U3DINGET(NAR,IUPACK,IERR)
               CALL WDialogSelect(MULT_DIALOG)
               IF(IERR.NE.0) GO TO 50
            END IF
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(MULT_DIALOG)
            CALL MULTSV(IUNDEF,1)
            RETURN
C
         END IF
      END IF
C
C  Ignore all other types of message
      GO TO 50
C
      END
      SUBROUTINE ZONEED()
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C     ******************************************************************
C     Prompt user for multiplier arrays
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
C
      CHARACTER*67 FNAME
      CHARACTER*20 FMT
      CHARACTER*10 ARRNAM,CTMP1
      CHARACTER*80 STRING
      CHARACTER*10 CNONE(1)
      DATA CNONE/'(None)'/
C     ------------------------------------------------------------------
      IULOC=31
      IUPACK=IUNIT(IULOC)
      IF(IUPACK.LE.0) THEN
         CALL FINDUN(42,IUPACK,'ZONE','ZON')
         IUNIT(IULOC)=IUPACK
      END IF
      NB=1
C
C  Load the Multiplier dialog (used for zones)
      CALL WDialogLoad(MULT_DIALOG)
      CALL WDialogTitle('Define Zone Arrays')
      CALL WDialogPutString(ARRAY_LABEL,'Select Zone Array')
      CALL WMessageEnable(FieldChanged,Enabled)
C
C  Initialize values
C  Make a list of zone array names.
10    NZN=0
      DO 20 K=1,MXZON
      IF(ZONNAM(K).NE.' ') THEN
         NZN=NZN+1
      ELSE
         GO TO 21
      END IF
20    CONTINUE
21    IF(NZN.GT.0) THEN
         CALL WDialogPutMenu(MULT_NAME,ZONNAM,NZN,NB)
      ELSE
         CALL WDialogPutMenu(MULT_NAME,CNONE,1,NB)
      END IF
C  
C  Find array -- create if it doesn't already exist
25    IF(NZN.GT.0) THEN
         ARRNAM=ZONNAM(NB)
         CALL UPCASE(ARRNAM)
         CALL IVLGET(ARRNAM,-1,-1,NAR,IV)
         IF(NAR.LE.0) THEN
            CALL ARRMAK(ARRNAM,-1,-1,NCOL,NROW)
            NAR=NARRAY
         END IF
      END IF
C  Define defaults
      IATYPE=1
      CON1=0.
      CON2=1.
      CON3=1.
      FMT='(20I4)'
      FNAME=' '
      IFTYP=1   ! 1=File Name, 2=OPEN/CLOSE
      IPRN=0
      IF(NZN.GT.0) THEN
         LOCAT=IARRDA(1,NAR)
         IF(LOCAT.EQ.0) THEN
            ITMP=ARRCON(NAR)
            IF(ITMP .NE. IMISS) CON1=ARRCON(NAR)
            CON2=1.0
            CON3=CON2
         ELSE IF(LOCAT.EQ.-1) THEN
            IATYPE=2
            CON2=ARRCON(NAR)
            CON1=CON2
            CON3=CON2
         ELSE IF(LOCAT.GT.0) THEN
            IATYPE=3
            CON3=ARRCON(NAR)
            CON1=CON3
            CON2=CON3
            FMT=ARRFMT(NAR)
            FNAME=FILNAM(LOCAT)
            IPRN=IARRDA(5,NAR)
            IF(FILTYP(LOCAT)(1:10).EQ.'OPEN/CLOSE') IFTYP=2
         END IF
      END IF
C
C  Set current values for array
30    IF(IATYPE.EQ.1) THEN
         CALL WDialogPutRadioButton(ARRAY_TYPE_CONSTANT)
         CALL WDialogFieldState(ARRAY_CONSTANT,Enabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER,Disabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER2,Disabled)
         CALL WDialogFieldState(ARRAY_IPRN,Disabled)
         CALL WDialogFieldState(ARRAY_FORMAT,Disabled)
         CALL WDialogFieldState(ARRAY_FILE,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(ARRAY_FILE_TYPE,Disabled)
         CALL WDialogFieldState(ARRAY_SPREADSHEET,Disabled)
         CALL WDialogFieldState(ARRAY_GRID,Disabled)
      ELSE IF(IATYPE.EQ.2) THEN
         CALL WDialogPutRadioButton(ARRAY_TYPE_PACKAGE)
         CALL WDialogFieldState(ARRAY_CONSTANT,Disabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER,Enabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER2,Disabled)
         CALL WDialogFieldState(ARRAY_IPRN,Disabled)
         CALL WDialogFieldState(ARRAY_FORMAT,Disabled)
         CALL WDialogFieldState(ARRAY_FILE,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(ARRAY_FILE_TYPE,Disabled)
         CALL WDialogFieldState(ARRAY_SPREADSHEET,Enabled)
         IF(NCOL.GT.100 .OR. NROW.GT.100) THEN
            CALL WDialogFieldState(ARRAY_GRID,Disabled)
         ELSE
            CALL WDialogFieldState(ARRAY_GRID,Enabled)
         END IF
      ELSE
         CALL WDialogPutRadioButton(ARRAY_TYPE_SEPARATE)
         CALL WDialogFieldState(ARRAY_CONSTANT,Disabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER,Disabled)
         CALL WDialogFieldState(ARRAY_MULTIPLIER2,Enabled)
         CALL WDialogFieldState(ARRAY_IPRN,Enabled)
         CALL WDialogFieldState(ARRAY_FORMAT,Enabled)
         CALL WDialogFieldState(ARRAY_FILE,Enabled)
         CALL WDialogFieldState(FILE_BROWSE,Enabled)
         CALL WDialogFieldState(ARRAY_FILE_TYPE,Enabled)
         CALL WDialogFieldState(ARRAY_SPREADSHEET,Disabled)
         CALL WDialogFieldState(ARRAY_GRID,Disabled)
      END IF
      IF(NZN.GT.0) THEN
         CALL WDialogFieldState(MULT_DELETE,Enabled)
         CALL WDialogFieldState(ARRAY_TYPE_PACKAGE,Enabled)
         CALL WDialogFieldState(ARRAY_TYPE_SEPARATE,Enabled)
      ELSE
         CALL WDialogFieldState(MULT_DELETE,Disabled)
         CALL WDialogFieldState(ARRAY_TYPE_PACKAGE,Disabled)
         CALL WDialogFieldState(ARRAY_TYPE_SEPARATE,Disabled)
      END IF
      CALL WDialogPutInteger(ARRAY_IPRN,IPRN)
      CALL WDialogPutReal(ARRAY_CONSTANT,CON1,'(1PG13.6)')
      CALL WDialogPutReal(ARRAY_MULTIPLIER,CON2,'(1PG13.6)')
      CALL WDialogPutReal(ARRAY_MULTIPLIER2,CON3,'(1PG13.6)')
      CALL WDialogPutString(ARRAY_FORMAT,FMT)
      CALL WDialogPutString(ARRAY_FILE,FNAME)
      CALL WDialogPutOption(ARRAY_FILE_TYPE,IFTYP)
C
C  Make Array Dialog visible
      CALL WDialogShow(-1,50,0,SemiModeless)
50    CALL WMessage(ITYPE,MESSAGE)
C
C  Act upon field changes
      IF(ITYPE.EQ.FieldChanged) THEN
C
C  Check for array change
         CALL WDialogGetMenu(MULT_NAME,NBNEW)
         IF(NBNEW.NE.NB) THEN
            CALL U3DINGET(NAR,IUPACK,IERR)
            CALL WDialogSelect(MULT_DIALOG)
            IF(IERR.NE.0) GO TO 25
            NB=NBNEW
            GO TO 25
         END IF
C
C  Check for array type change
         CALL WDialogGetRadioButton(ARRAY_TYPE_CONSTANT,IATNEW)
         IF(IATNEW.NE.IATYPE) THEN
            IATYPE=IATNEW
            IF(IATYPE.EQ.2 .AND. IARRDA(2,NAR).EQ.0) THEN
               CALL ARRALO(IARRDA(2,NAR),IARRDA(3,NAR),IARRDA(4,NAR))
               LOC=IARRDA(2,NAR)
               CALL ZIPI(NCOL*NROW,0,IX(LOC))
C               CALL SS2DI(IX(LOC),NCOL,NROW,ARRNAM,MULT_DIALOG)
               CALL WDialogSelect(MULT_DIALOG)
               CALL WMessageEnable(FieldChanged,Enabled)
            END IF
            GO TO 30
         END IF
C
C  Check for push buttons
      ELSE IF(ITYPE.EQ.PushButton) THEN
C
C  Check for ARRAY_SPREADSHEET
         IF(MESSAGE%VALUE1.EQ.ARRAY_SPREADSHEET) THEN
            LOC=IARRDA(2,NAR)
            CALL SS2DI(IX(LOC),NCOL,NROW,ARRNAM,MULT_DIALOG)
            CALL WDialogSelect(MULT_DIALOG)
            CALL WMessageEnable(FieldChanged,Enabled)
C
C  Check for ARRAY_GRID
         ELSE IF(MESSAGE%VALUE1.EQ.ARRAY_GRID) THEN
            IF(NCOL.LE.100 .AND. NROW.LE.100) THEN
              LOC=IARRDA(2,NAR)
              CALL SS2DIG(IX(LOC),NCOL,NROW,ARRNAM,MULT_DIALOG)
              CALL WDialogSelect(MULT_DIALOG)
              CALL WMessageEnable(FieldChanged,Enabled)
            END IF
C
C  COMMENT PUSHBUTTON
         ELSE IF(MESSAGE%VALUE1.EQ.MULT_COMMENT) THEN
            CALL COMNTIN(IULOC)
            CALL WDialogSelect(MULT_DIALOG)
            CALL WMessageEnable(FieldChanged,Enabled)
C
C  Check for ADD
         ELSE IF(MESSAGE%VALUE1.EQ.MULT_ADD) THEN
            IF(NZN.GT.0) THEN
               CALL U3DINGET(NAR,IUPACK,IERR)
               CALL WDialogSelect(MULT_DIALOG)
               IF(IERR.NE.0) GO TO 50
            END IF
            CALL WMessageEnable(FieldChanged,Disabled)
68          CALL GETSTRING('Enter name of new zone array',
     1            STRING,IERR,NCSTR)
            CALL WDialogSelect(MULT_DIALOG)
            CALL WMessageEnable(FieldChanged,Enabled)
            IF(IERR.EQ.0) THEN
               ARRNAM=STRING(1:NCSTR)
               CALL UPCASE(ARRNAM)
               LLOC=1
               DO 70 I=1,NZN
               CTMP1=ZONNAM(I)
               CALL UPCASE(CTMP1)
               IF(CTMP1.EQ.ARRNAM) THEN
                  CALL WMessageBox(OKOnly,ExclamationIcon,CommonOK,
     1            ' Duplicate name',' ')
                  GO TO 68
               END IF
70             CONTINUE
               NZN=NZN+1
               ZONNAM(NZN)=STRING(1:NCSTR)
               NB=NZN
               GO TO 10
            END IF
C
C  Check for DELETE zone array
         ELSE IF(MESSAGE%VALUE1.EQ.MULT_DELETE) THEN
            CALL U3DINGET(NAR,IUPACK,IERR)
            CALL WDialogSelect(MULT_DIALOG)
            IF(IERR.NE.0) GO TO 50
            IF(NB.NE.NZN) THEN
               DO 80 I=NB,NZN-1
               ZONNAM(I)=ZONNAM(I+1)
80             CONTINUE
            END IF
            ZONNAM(NZN)=' '
            NZN=NZN-1
            NB=NB-1
            IF(NB.LT.1) NB=1
            GO TO 10
C
C  Check for CANCEL
         ELSE IF(MESSAGE%VALUE1.EQ.IDCANCEL) THEN
C  Exit without storing values
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(MULT_DIALOG)
            CALL ZONESV(IUNDEF,1)
            RETURN
C
C  Check for Browse
         ELSE IF(MESSAGE%VALUE1.EQ.FILE_BROWSE) THEN
            CALL BROWSE(FNAME)
            CALL WDialogSelect(MULT_DIALOG)
            GO TO 30
C
C  Check for OK
         ELSE IF(MESSAGE%VALUE1.EQ.MULT_DIALOG_IDOK) THEN
            IF(NZN.GT.0) THEN
               CALL U3DINGET(NAR,IUPACK,IERR)
               CALL WDialogSelect(MULT_DIALOG)
               IF(IERR.NE.0) GO TO 50
            END IF
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(MULT_DIALOG)
            CALL ZONESV(IUNDEF,1)
            RETURN
C
         END IF
      END IF
C
C  Ignore all other types of message
      GO TO 50
C
      END
      SUBROUTINE U2DPARPERIN(LABEL,ARRNAM,IARN,NCC,NR,IUPACK,NOPT,
     1     COPVAR,PT,IULOC)
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
C     ******************************************************************
C     Prompt user for an array that varies according to stress period
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      TYPE(WIN_MESSAGE)   :: MESSAGE
      INCLUDE 'mfi2k.inc'
      INCLUDE 'mfi2kpar.inc'
      CHARACTER*(*) LABEL,ARRNAM(IARN),COPVAR,PT
      CHARACTER*10 ARRNAM2(7)
      CHARACTER*78 CLINE
      CHARACTER*67 FNAME
      CHARACTER*20 FMT
      CHARACTER*10 CN(MXPAR),PN,MN(200),ZN(200)
      DIMENSION IZN(200,10),LAY(200)
      CHARACTER*20 ARRPARNAM(200)
      CHARACTER*4 CPER(MXPER),CPTTMP(1)
      CHARACTER*20 OPTION(3)
      DATA OPTION/'Top Layer','Specified Layers','Automatic Selection'/
C     ------------------------------------------------------------------
      NC=NCC
      IF(NCC.LT.0) NC=-NCC
C
C  Make a list of stress period numbers.
      DO 20 K=1,NPER
      WRITE(CPER(K),'(I4)') K
20    CONTINUE
C
C  Determine initial value of the option for where stress is applied
      CALL IVLGET(COPVAR,0,0,ITYPE,IOPT)
      IF(ITYPE.NE.0) IOPT=1
C
C  Define array defaults
      CON1=0.
      CON2=1.
      CON3=1.
      FNAME=' '
      IFTYP=1   ! 1=File Name, 2=OPEN/CLOSE
C
C  Load the array stress parameters dialog
      CALL WDialogLoad(ARRAY_STRESS_PARAMETERS_DIALOG)
      CALL WMessageEnable(FieldChanged,Enabled)
C
C  Initialize values
C  Label the package being edited.
      CLINE='Defining values for '//LABEL
      CALL WDialogPutString(ARRAY_PERIODS_TITLE,CLINE)
      CLINE='Defined '//PT//' Parameters'
      CALL WDialogPutString(PARAMETER_LABEL,CLINE)
      K=1
      CALL WDialogPutMenu(ARRAY_PERIODS_NUMBER,CPER,NPER,K)
      IAR=1
      IPSEL=1
C
C  Display the options for specifying where stress is applied
      CALL WDialogPutMenu(ARRAY_PERIODS_OPTION,OPTION,NOPT,IOPT)
C
C
C  Count the number of parameters of the specified type, and show them.
10    NP=0
      IF(IPSUM.GT.0) THEN
         DO 12 I=1,IPSUM
         IF(PARTYP(I).EQ.PT) THEN
            NP=NP+1
            ARRPARNAM(NP)=PARNAM(I)//CHAR(9)//'NO'
            DO 11 J=1,MXPERPAR
            IF(PERPARNAM(J).EQ.PARNAM(I).AND.
     1       IPERPARPER(J).EQ.K)
     2          ARRPARNAM(NP)(11:20)=CHAR(9)//'YES'
11          CONTINUE
         END IF
12       CONTINUE
      END IF
      NPDSP=NP
      IF(NP.EQ.0) THEN
         ARRPARNAM(1)='(None)'
         NPDSP=1
         IPSEL=0
      END IF
      CALL WDialogPutMenu(ARRAY_PARAMETERS,ARRPARNAM,NPDSP,IPSEL)
C
      CALL WDialogFieldState(PARAMETER_ADD,Enabled)
      IF(NP.GT.0) THEN
         CALL WDialogFieldState(ARRAY_PARAMETERS,Enabled)
         CALL WDialogFieldState(PARAMETER_ACTIVATE,Enabled)
         CALL WDialogFieldState(PARAMETER_DEACTIVATE,Enabled)
         CALL WDialogFieldState(PARAMETER_MODIFY,Enabled)
         CALL WDialogFieldState(PARAMETER_DELETE,Enabled)
      ELSE
         CALL WDialogFieldState(ARRAY_PARAMETERS,Disabled)
         CALL WDialogFieldState(PARAMETER_ACTIVATE,Disabled)
         CALL WDialogFieldState(PARAMETER_DEACTIVATE,Disabled)
         CALL WDialogFieldState(PARAMETER_MODIFY,Disabled)
         CALL WDialogFieldState(PARAMETER_DELETE,Disabled)
      END IF
C
C  Find how many arrays are used for the selected option, and
C  display them
23    NARTOT=0
      NN=IARN
      IF(IOPT.NE.2) NN=IARN-1
      DO 24 I=1,NN
      IF(NP.GT.0 .AND. I.EQ.1) GO TO 24
      NARTOT=NARTOT+1
      ARRNAM2(NARTOT)=ARRNAM(I)
24    CONTINUE
      NDSP=NARTOT
      IF(NARTOT.LE.0) THEN
         NDSP=1
         ARRNAM2(1)='(None)'
      END IF
      IF(IAR.GT.NARTOT) IAR=1
      CALL WDialogPutMenu(ARRAY_PER_NAME,ARRNAM2,NDSP,IAR)
C  
C  Find current array -- create if it doesn't already exist
25    IREAL=1
      FMT='(10F8.0)'
      IPRN=0
      IAMETH=2
      IF(NARTOT.GT.0) THEN
         IF(ARRNAM2(IAR)(1:1).EQ.'I') IREAL=0
         CALL VALGET(ARRNAM2(IAR),0,K,NAR,V)
         IF(NAR.LE.0) THEN
            CALL ARRMAK(ARRNAM2(IAR),0,K,NC,NR)
            NAR=NARRAY
            IF(IREAL.EQ.0) IARRDA(5,NAR)=4
         END IF
         FMT='(10F8.0)'
         IF(IREAL.EQ.0) FMT='(20I4)'
         IF(IREAL.EQ.0) IPRN=4
         LOCAT=IARRDA(1,NAR)
         IF(LOCAT.EQ.0) THEN
            IAMETH=2  ! Constant array
            IF(IREAL.EQ.0) THEN
               ITMP=ARRCON(NAR)
               IF(ITMP.NE.IMISS) CON1=ARRCON(NAR)
            ELSE
               IF(ARRCON(NAR) .NE. RMISS) CON1=ARRCON(NAR)
            END IF
            CON2=1.0
            CON3=CON2
         ELSE IF(LOCAT.EQ.-1) THEN
            IAMETH=3   !  package array
            CON2=ARRCON(NAR)
            CON1=CON2
            CON3=CON2
         ELSE IF(LOCAT.GT.0) THEN
            IAMETH=4   ! Separate array
            CON3=ARRCON(NAR)
            CON1=CON3
            CON2=CON3
            FMT=ARRFMT(NAR)
            FNAME=FILNAM(LOCAT)
            IPRN=IARRDA(5,NAR)
            IF(FILTYP(LOCAT)(1:10).EQ.'OPEN/CLOSE') IFTYP=2
         ELSE IF(LOCAT.EQ.-3) THEN
            IAMETH=1  !  Previous array
            IF(K.EQ.1) IAMETH=2
         END IF
      END IF
C
C  Set current values for array
30    IF(NARTOT.GT.0) THEN
         IF(K.EQ.1) THEN
            CALL WDialogFieldState(ARRAY_PERIODS_PREVIOUS,Disabled)
         ELSE
            CALL WDialogFieldState(ARRAY_PERIODS_PREVIOUS,Enabled)
         END IF
         IF(IAMETH.EQ.2) THEN
            CALL WDialogPutRadioButton(ARRAY_PERIODS_RADIO_CONSTANT)
            CALL WDialogFieldState(ARRAY_PERIODS_CONSTANT,Enabled)
            CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER2,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_IPRN,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_FORMAT,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_FILE,Disabled)
            CALL WDialogFieldState(FILE_BROWSE,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_FILE_TYPE,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_SPREADSHEET,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_GRID,Disabled)
         ELSE IF(IAMETH.EQ.3) THEN
            CALL WDialogPutRadioButton(ARRAY_PERIODS_PACKAGE)
            CALL WDialogFieldState(ARRAY_PERIODS_CONSTANT,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER,Enabled)
            CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER2,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_IPRN,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_FORMAT,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_FILE,Disabled)
            CALL WDialogFieldState(FILE_BROWSE,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_FILE_TYPE,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_SPREADSHEET,Enabled)
            IF(NC.GT.100 .OR. NR.GT.100) THEN
               CALL WDialogFieldState(ARRAY_PERIODS_GRID,Disabled)
            ELSE
               CALL WDialogFieldState(ARRAY_PERIODS_GRID,Enabled)
            END IF
         ELSE IF(IAMETH.EQ.4) THEN
            CALL WDialogPutRadioButton(ARRAY_PERIODS_SEPARATE)
            CALL WDialogFieldState(ARRAY_PERIODS_CONSTANT,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER2,Enabled)
            CALL WDialogFieldState(ARRAY_PERIODS_IPRN,Enabled)
            CALL WDialogFieldState(ARRAY_PERIODS_FORMAT,Enabled)
            CALL WDialogFieldState(ARRAY_PERIODS_FILE,Enabled)
            CALL WDialogFieldState(FILE_BROWSE,Enabled)
            CALL WDialogFieldState(ARRAY_PERIODS_FILE_TYPE,Enabled)
            CALL WDialogFieldState(ARRAY_PERIODS_SPREADSHEET,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_GRID,Disabled)
         ELSE
            CALL WDialogPutRadioButton(ARRAY_PERIODS_PREVIOUS)
            CALL WDialogFieldState(ARRAY_PERIODS_CONSTANT,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER2,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_IPRN,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_FORMAT,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_FILE,Disabled)
            CALL WDialogFieldState(FILE_BROWSE,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_FILE_TYPE,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_SPREADSHEET,Disabled)
            CALL WDialogFieldState(ARRAY_PERIODS_GRID,Disabled)
         END IF
      ELSE
         CALL WDialogPutRadioButton(ARRAY_PERIODS_RADIO_CONSTANT)
         CALL WDialogFieldState(ARRAY_PERIODS_CONSTANT,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_MULTIPLIER2,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_IPRN,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FORMAT,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FILE,Disabled)
         CALL WDialogFieldState(FILE_BROWSE,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_FILE_TYPE,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_SPREADSHEET,Disabled)
         CALL WDialogFieldState(ARRAY_PERIODS_GRID,Disabled)
      END IF
      CALL WDialogPutInteger(ARRAY_PERIODS_IPRN,IPRN)
      CALL WDialogPutReal(ARRAY_PERIODS_CONSTANT,CON1,'(1PG13.6)')
      CALL WDialogPutReal(ARRAY_PERIODS_MULTIPLIER,CON2,'(1PG13.6)')
      CALL WDialogPutReal(ARRAY_PERIODS_MULTIPLIER2,CON3,'(1PG13.6)')
      CALL WDialogPutString(ARRAY_PERIODS_FORMAT,FMT)
      CALL WDialogPutString(ARRAY_PERIODS_FILE,FNAME)
      CALL WDialogPutOption(ARRAY_PERIODS_FILE_TYPE,IFTYP)
C
C  Make Array Dialog visible
      CALL WDialogShow(-1,50,0,SemiModeless)
50    CALL WMessage(ITYPE,MESSAGE)
C
C  Act upon field changes
      IF(ITYPE.EQ.FieldChanged) THEN
C
C  Check for IOPT change (Layer specification)
         CALL WDialogGetMenu(ARRAY_PERIODS_OPTION,IOPTNEW)
         IF(IOPTNEW.NE.IOPT) THEN
            IOPT=IOPTNEW
            CALL IVLSAV(COPVAR,0,0,IOPT)
            GO TO 23
         END IF
C
C  Check for change of array name
         CALL WDialogGetMenu(ARRAY_PER_NAME,IARNEW)
         IF(IARNEW.NE.IAR) THEN
            IF(NARTOT.GT.0) THEN
               CALL U2DPERINGET(NAR,IUPACK,IOPT,COPVAR,IERR)
               CALL WDialogSelect(ARRAY_STRESS_PARAMETERS_DIALOG)
               IF(IERR.NE.0) GO TO 25
            END IF
            IAR=IARNEW
            GO TO 25
         END IF
C
C  Check for period change
         CALL WDialogGetMenu(ARRAY_PERIODS_NUMBER,KNEW)
         IF(KNEW.NE.K) THEN
            IF(NARTOT.GT.0) THEN
               CALL U2DPERINGET(NAR,IUPACK,IOPT,COPVAR,IERR)
               CALL WDialogSelect(ARRAY_STRESS_PARAMETERS_DIALOG)
               IF(IERR.NE.0) GO TO 25
            END IF
            K=KNEW
            GO TO 10
         END IF
C
C  Check for array Method change
         CALL WDialogGetRadioButton(ARRAY_PERIODS_RADIO_CONSTANT,IAMNEW)
         IF(IAMNEW.NE.IAMETH) THEN
            IF(NARTOT.GT.0) THEN
               IAMETH=IAMNEW
            ELSE
               GO TO 50
            END IF
            IF(IARRDA(2,NAR).EQ.0 .AND. IAMETH.EQ.3) THEN
              CALL ARRALO(IARRDA(2,NAR),IARRDA(3,NAR),IARRDA(4,NAR))
              LOC=IARRDA(2,NAR)
              IF(IREAL.NE.0) THEN
                 CALL ZIPR(NC*NR,0.,X(LOC))
C                 IF(NCC.GT.0) CALL SS2DR(X(LOC),NC,NR,ARRNAM2(IAR),
C     1                ARRAY_STRESS_PARAMETERS_DIALOG)
                 CALL WDialogSelect(ARRAY_STRESS_PARAMETERS_DIALOG)
                 CALL WMessageEnable(FieldChanged,Enabled)
              ELSE
                 CALL ZIPI(NC*NR,1,IX(LOC))
C                 IF(NCC.GT.0) CALL SS2DI(IX(LOC),NC,NR,ARRNAM2(IAR),
C     1                ARRAY_STRESS_PARAMETERS_DIALOG)
                 CALL WDialogSelect(ARRAY_STRESS_PARAMETERS_DIALOG)
                 CALL WMessageEnable(FieldChanged,Enabled)
              END IF
            END IF
            GO TO 30
         END IF
C
C  Check for push buttons
      ELSE IF(ITYPE.EQ.PushButton) THEN
C
C  Check for ARRAY_PERIODS_SPREADSHEET
        IF(MESSAGE%VALUE1.EQ.ARRAY_PERIODS_SPREADSHEET) THEN
          IF(NCC.GT.0) THEN
            LOC=IARRDA(2,NAR)
            I=1
            IF(IREAL.NE.0) CALL SS2DR(X(LOC),NC,NR,ARRNAM2(IAR),
     1                 ARRAY_STRESS_PARAMETERS_DIALOG)
            IF(IREAL.EQ.0) CALL SS2DI(IX(LOC),NC,NR,ARRNAM2(IAR),
     1                 ARRAY_STRESS_PARAMETERS_DIALOG)
            CALL WDialogSelect(ARRAY_STRESS_PARAMETERS_DIALOG)
            CALL WMessageEnable(FieldChanged,Enabled)
          END IF
C
C  Check for ARRAY_PERIODS_GRID
        ELSE IF(MESSAGE%VALUE1.EQ.ARRAY_PERIODS_GRID) THEN
          IF(NCC.GT.0 .AND. NC.LE.100 .AND. NR.LE.100) THEN
            LOC=IARRDA(2,NAR)
            I=1
            IF(IREAL.NE.0) CALL SS2DRG(X(LOC),NC,NR,ARRNAM2(IAR),
     1                 ARRAY_STRESS_PARAMETERS_DIALOG)
            IF(IREAL.EQ.0) CALL SS2DIG(IX(LOC),NC,NR,ARRNAM2(IAR),
     1                 ARRAY_STRESS_PARAMETERS_DIALOG)
            CALL WDialogSelect(ARRAY_STRESS_PARAMETERS_DIALOG)
            CALL WMessageEnable(FieldChanged,Enabled)
          END IF
C
C  COMMENT PUSHBUTTON
         ELSE IF(MESSAGE%VALUE1.EQ.ARRAY_PERIODS_COMMENT) THEN
            IF(IULOC.GT.0) THEN
               CALL COMNTIN(IULOC)
               CALL WDialogSelect(ARRAY_STRESS_PARAMETERS_DIALOG)
               CALL WMessageEnable(FieldChanged,Enabled)
            END IF
C
C  Check for PARAMETER_ADD
         ELSE IF(MESSAGE%VALUE1.EQ.PARAMETER_ADD) THEN
            PN=' '
            PV=0.0
            DO 59 I=1,200
            MN(I)='NONE'
            ZN(I)=' '
            LAY(I)=0
            DO 59 J=1,10
            IZN(I,J)=0
59          CONTINUE
            NPT=1
            CPTTMP(1)=PT
60          CALL ARRPARGET(PN,CPTTMP,1,NPT,PV,MN,ZN,LAY,IZN,0,
     1                 IERR,0)
            IF(IERR.GT.0) THEN
               GO TO 60
            ELSE IF(IERR.EQ.0) THEN
               ISF=0
               ISE=0
               LNS=0
               B2S=PV
               BLS=0.
               BUS=0.
               BSS=0.
               CALL ARRPARADD(PN,PT,PV,MN,ZN,LAY,IZN,IERR,0,
     1             ISF,ISE,LNS,B2S,BLS,BUS,BSS)
               IF(IERR.NE.0) GO TO 60
            END IF
            CALL WMessageEnable(FieldChanged,Enabled)
            CALL WDialogSelect(ARRAY_STRESS_PARAMETERS_DIALOG)
            IPSEL=1
            GO TO 10
C
C  Check for MODIFY
         ELSE IF(MESSAGE%VALUE1.EQ.PARAMETER_MODIFY) THEN
            IF(NP.GT.0) THEN
C get the current values of the parameter
               CALL WDialogGetMenu(ARRAY_PARAMETERS,ISEL)
               PN=ARRPARNAM(ISEL)(1:10)
               DO 61 I=1,IPSUM
               IF(PARNAM(I).EQ.PN) IPNUM=I
61             CONTINUE
               PV=B(IPNUM)
               ISF=ISFILE(IPNUM)
               ISE=ISENS(IPNUM)
               LNS=LN(IPNUM)
               B2S=B2(IPNUM)
               BLS=BL(IPNUM)
               BUS=BU(IPNUM)
               BSS=BSCAL(IPNUM)
               DO 62 I=1,200
               MN(I)='NONE'
               ZN(I)=' '
               LAY(I)=0
               DO 62 J=1,10
               IZN(I,J)=0
62             CONTINUE
               I=0
               DO 78 II=IPLOC(1,IPNUM),IPLOC(2,IPNUM)
               I=I+1
               MN(I)=CPCLST(1,II)
               ZN(I)=CPCLST(2,II)
               LAY(I)=IPCLST(1,II)
               IF(IPCLST(2,II).GT.2) THEN
                  DO 77 J=3,IPCLST(2,II)
                  IZN(I,J-2)=IPCLST(J,II)
77                CONTINUE
               END IF
78             CONTINUE
               NPT=1
               CPTTMP(1)=PT
C  Get modifications to the parameter
63             CALL ARRPARGET(PN,CPTTMP,1,NPT,PV,MN,ZN,LAY,IZN,0,
     1                 IERR,1)
               IF(IERR.EQ.0) THEN
C  Delete the current parameter and add the modified parameter back
                  CALL ARRPARDEL(PN)
                  CALL ARRPARADD(PN,PT,PV,MN,ZN,LAY,IZN,IERR,0,
     1             ISF,ISE,LNS,B2S,BLS,BUS,BSS)
                  IF(IERR.NE.0) GO TO 63
               END IF
               CALL WMessageEnable(FieldChanged,Enabled)
               CALL WDialogSelect(ARRAY_STRESS_PARAMETERS_DIALOG)
               GO TO 10
            END IF
C
C  Check for DELETE
         ELSE IF(MESSAGE%VALUE1.EQ.PARAMETER_DELETE) THEN
            IF(NP.GT.0) THEN
               CALL WDialogGetMenu(ARRAY_PARAMETERS,ISEL)
               PN=ARRPARNAM(ISEL)(1:10)
               CALL ARRPARDEL(PN)
               DO 64 J=1,MXPERPAR
               IF(PERPARNAM(J).EQ.PN) THEN
                  PERPARNAM(J)=' '
                  PERPARTYP(J)=' '
               END IF
64             CONTINUE
               NP=NP-1
               IF(IPSEL.GT.NP) IPSEL=NP
               GO TO 10
            END IF
C
C  Check for PARAMETER_ACTIVATE
         ELSE IF(MESSAGE%VALUE1.EQ.PARAMETER_ACTIVATE) THEN
            IF(NP.GT.0) THEN
               CALL WDialogGetMenu(ARRAY_PARAMETERS,IPSEL)
               PN=ARRPARNAM(IPSEL)(1:10)
               DO 65 I=1,MXPERPAR
               IF(PERPARNAM(I).EQ.PN .AND. IPERPARPER(I).EQ.K) GO TO 50
65             CONTINUE
            END IF
            DO 70 I=1,MXPERPAR
            IF(PERPARNAM(I).EQ.' ') THEN
               PERPARNAM(I)=PN
               IPERPARPER(I)=K
               PERPARTYP(I)=PT
               GO TO 10
            END IF
70          CONTINUE
            WRITE(IOUT,*) ' MXPERPAR has been exceeded in U2DPARPERIN'
            CALL MFISTP
C
C  Check for PARAMETER_DEACTIVATE
         ELSE IF(MESSAGE%VALUE1.EQ.PARAMETER_DEACTIVATE) THEN
            IF(NP.GT.0) THEN
               CALL WDialogGetMenu(ARRAY_PARAMETERS,IPSEL)
               PN=ARRPARNAM(IPSEL)(1:10)
               DO 80 I=1,MXPERPAR
               IF(PERPARNAM(I).EQ.PN .AND.
     1                IPERPARPER(I).EQ.K) THEN
                  PERPARNAM(I)=' '
                  IPERPARPER(I)=0
                  PERPARTYP(I)=' '
                  GO TO 10
               END IF
80             CONTINUE
            END IF
C
C  Check for Browse
         ELSE IF(MESSAGE%VALUE1.EQ.FILE_BROWSE) THEN
            CALL BROWSE(FNAME)
            CALL WDialogSelect(ARRAY_STRESS_DIALOG)
            GO TO 30
C
C  Check for OK
         ELSE IF(MESSAGE%VALUE1.EQ.ARRAY_PERIODS_IDOK) THEN
            IF(NARTOT.GT.0) THEN
               CALL U2DPERINGET(NAR,IUPACK,IOPT,
     1                   COPVAR,IERR)
               CALL WDialogSelect(ARRAY_STRESS_PARAMETERS_DIALOG)
               IF(IERR.NE.0) GO TO 50
            END IF
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(ARRAY_STRESS_PARAMETERS_DIALOG)
            RETURN
C
C  Check for CANCEL
         ELSE IF(MESSAGE%VALUE1.EQ.IDCANCEL) THEN
C  Exit without storing values
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(ARRAY_STRESS_PARAMETERS_DIALOG)
            RETURN
         END IF
C
C  Ignore all other types of message
      END IF
      GO TO 50
C
      END
      SUBROUTINE STRESSED
C     ******************************************************************
C     Input STRESS Data
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      CHARACTER*80 LINE(1)
C     ------------------------------------------------------------------
      IULOC=24
C
      CALL WDialogLoad(STRESS_DIALOG)
      CALL WDialogShow(-1,50,0,SemiModeless)
C
5     CALL WMessage(ITYPE,MESSAGE)
C
C  Check for push buttons
      IF(ITYPE.EQ.PushButton) THEN
         IF(MESSAGE%VALUE1.EQ.STRESS_CHECK_BUT) THEN
            NMISS=0
            IF(IUNIT(2).GT.0) CALL WELSV(IUNDEF,-1)
            IF(IUNIT(3).GT.0) CALL DRNSV(IUNDEF,-1)
            IF(IUNIT(4).GT.0) CALL RIVSV(IUNDEF,-1)
            IF(IUNIT(7).GT.0) CALL GHBSV(IUNDEF,-1)
            IF(IUNIT(8).GT.0) CALL RCHSV(IUNDEF,-1)
            IF(IUNIT(5).GT.0) CALL EVTSV(IUNDEF,-1)
            IF(NMISS.GT.0) THEN
               CALL TXTLOG(CTEXT,NMISS)
            ELSE
               LINE(1)='There are no active stress packages'
               CALL TXTLOG(LINE(1),1)
            END IF
C
         ELSE IF(MESSAGE%VALUE1.EQ.STRESS_RIV_BUT) THEN
C  RIV BUTTON
            CALL RIVED()
C
         ELSE IF(MESSAGE%VALUE1.EQ.STRESS_WEL_BUT) THEN
C  WEL PUSHBUTTON
            CALL WELED()
C
         ELSE IF(MESSAGE%VALUE1.EQ.STRESS_RCH_BUT) THEN
C  RCH PUSHBUTTON
            CALL RCHED()
C
         ELSE IF(MESSAGE%VALUE1.EQ.STRESS_DRN_BUT) THEN
C  DRN PUSHBUTTON
            CALL DRNED()
C
         ELSE IF(MESSAGE%VALUE1.EQ.STRESS_GHB_BUT) THEN
C  GHB PUSHBUTTON
            CALL GHBED()
C
         ELSE IF(MESSAGE%VALUE1.EQ.STRESS_EVT_BUT) THEN
C  EVT PUSHBUTTON
            CALL EVTED()
C
         ELSE IF(MESSAGE%VALUE1.EQ.IDCLOSE) THEN
C  CLOSE PUSHBUTTON -- done with STRESS dialog
            CALL WDialogUnload(STRESS_DIALOG)
            RETURN
         END IF
         CALL WDialogSelect(STRESS_DIALOG)
      END IF
      GO TO 5
C
      END
