      SUBROUTINE OCED
C     ******************************************************************
C     Input OC data
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      INCLUDE 'mfi2k.inc'
C  Common block for Output Control
      COMMON /OCCOM/IBDOPT,LBHDSV,LBDDSV,LBBOSV,IBOUSV,
     1     IHEDFM,IDDNFM,IHEDPR,IDDNPR,IHEDSV,IDDNSV,IBUDPR,IBUDSV,
     2     IHDPR(17,MXSCRN),IDDPR(17,MXSCRN),IHDSV(17,MXSCRN),
     3     IDDSV(17,MXSCRN),IBDPR(17,MXSCRN),IBDSV(17,MXSCRN),
     4     IBOSV(17,MXSCRN)
C     ------------------------------------------------------------------
C
      IF(IUNIT(12).EQ.0) THEN
         CALL FINDUN(22,IU,'OC','OC')
         IUNIT(12)=IU
         CHEDFM='(BINARY)'
         CDDNFM='(BINARY)'
         CBOUFM='(20I4)'
         IHEDPR=3
         IDDNPR=1
         IHEDSV=1
         IDDNSV=1
         IBOUSV=1
         IBUDPR=3
         IBUDSV=1
      END IF
C
      CALL WDialogLoad(OUTPUT_DIALOG)
      CALL WDialogShow(-1,50,0,SemiModeless)
C  Don't allow output times to be selected unless output files are defined
50    IF(IHEDUN.GT.0) THEN
         CALL WDialogFieldState(OUTPUT_SVHD,Enabled)
      ELSE
         CALL WDialogFieldState(OUTPUT_SVHD,Disabled)
      END IF
      IF(IDDNUN.GT.0) THEN
         CALL WDialogFieldState(OUTPUT_SVDD,Enabled)
      ELSE
         CALL WDialogFieldState(OUTPUT_SVDD,Disabled)
      END IF
      IF(IBOUUN.GT.0) THEN
         CALL WDialogFieldState(OUTPUT_SVBO,Enabled)
      ELSE
         CALL WDialogFieldState(OUTPUT_SVBO,Disabled)
      END IF
      IF(IBUDUN.GT.0) THEN
         CALL WDialogFieldState(OUTPUT_SVBD,Enabled)
      ELSE
         DO 60 I=1,39
         IF(IUNIT2(I).NE.0) THEN
            CALL WDialogFieldState(OUTPUT_SVBD,Enabled)
            GO TO 65
         END IF
60       CONTINUE
         CALL WDialogFieldState(OUTPUT_SVBD,Disabled)
      END IF
C
65    CALL WMessage(ITYPE,MESSAGE)
C
C  Check for push buttons (CLOSE terminates)
      IF(ITYPE.EQ.PushButton) THEN
         IF(MESSAGE%VALUE1.EQ.OUTPUT_FILES) THEN
            CALL EDFIL
         ELSE IF(MESSAGE%VALUE1.EQ.OUTPUT_PRHD) THEN
            CALL EDTIM(IHEDPR,IHDPR,1,'Times for Printing Head',0)
         ELSE IF(MESSAGE%VALUE1.EQ.OUTPUT_SVHD) THEN
            CALL EDTIM(IHEDSV,IHDSV,1,'Times for Saving Head',0)
         ELSE IF(MESSAGE%VALUE1.EQ.OUTPUT_PRDD) THEN
            CALL EDTIM(IDDNPR,IDDPR,1,'Times for Printing Drawdown',0)
         ELSE IF(MESSAGE%VALUE1.EQ.OUTPUT_SVDD) THEN
            CALL EDTIM(IDDNSV,IDDSV,1,'Times for Saving Drawdown',0)
         ELSE IF(MESSAGE%VALUE1.EQ.OUTPUT_SVBO) THEN
            CALL EDTIM(IBOUSV,IBOSV,1,'Times for Saving IBOUND',0)
         ELSE IF(MESSAGE%VALUE1.EQ.OUTPUT_PRBD) THEN
            CALL EDTIM(IBUDPR,IBDPR,0,'Times for Printing Budget',1)
         ELSE IF(MESSAGE%VALUE1.EQ.OUTPUT_SVBD) THEN
            CALL EDTIM(IBUDSV,IBDSV,0,'Times for Saving Budget',0)
         ELSE IF(MESSAGE%VALUE1.EQ.OUTPUT_COMMENT) THEN
            CALL COMNTIN(12)
         ELSE IF(MESSAGE%VALUE1.EQ.IDCLOSE) THEN
            CALL WDialogUnload(OUTPUT_DIALOG)
            RETURN
         END IF
      END IF
      CALL WDialogSelect(OUTPUT_DIALOG)
      GO TO 50
C
      END
      SUBROUTINE EDFIL
C     ******************************************************************
C     Edit information about output files
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      TYPE(WIN_MESSAGE)   :: MESSAGE
      INCLUDE 'mfi2k.inc'
C  Common block for Output Control
      COMMON /OCCOM/IBDOPT,LBHDSV,LBDDSV,LBBOSV,IBOUSV,
     1     IHEDFM,IDDNFM,IHEDPR,IDDNPR,IHEDSV,IDDNSV,IBUDPR,IBUDSV,
     2     IHDPR(17,MXSCRN),IDDPR(17,MXSCRN),IHDSV(17,MXSCRN),
     3     IDDSV(17,MXSCRN),IBDPR(17,MXSCRN),IBDSV(17,MXSCRN),
     4     IBOSV(17,MXSCRN)
      CHARACTER*78 HEDFIL,DDNFIL,BOUFIL
      CHARACTER*18 FTYP
      DIMENSION IBUF(1000)
      CHARACTER*78 BUDFIL,CTMP
      CHARACTER*3 CFTYP(40)
      CHARACTER*70 CVAL(40)
C     ------------------------------------------------------------------
C
C  Initialize file names
      IF(IHEDUN.LE.0) THEN
         IF(IUCASE.NE.0) THEN
            HEDFIL=DSNAME(1:NDSNAM)//'.HED'
         ELSE
            HEDFIL=DSNAME(1:NDSNAM)//'.hed'
         END IF
      ELSE
         HEDFIL=FILNAM(IHEDUN)
      END IF
C
      IF(IDDNUN.LE.0) THEN
         IF(IUCASE.NE.0) THEN
            DDNFIL=DSNAME(1:NDSNAM)//'.DDN'
         ELSE
            DDNFIL=DSNAME(1:NDSNAM)//'.ddn'
         END IF
      ELSE
         DDNFIL=FILNAM(IDDNUN)
      END IF
C
      IF(IBOUUN.LE.0) THEN
         IF(IUCASE.NE.0) THEN
            BOUFIL=DSNAME(1:NDSNAM)//'.BOU'
         ELSE
            BOUFIL=DSNAME(1:NDSNAM)//'.bou'
         END IF
      ELSE
         BOUFIL=FILNAM(IBOUUN)
      END IF
C
      IF(IUCASE.NE.0) BUDFIL=DSNAME(1:NDSNAM)//'.BUD'
      IF(IUCASE.EQ.0) BUDFIL=DSNAME(1:NDSNAM)//'.bud'
      IBDCHO=2
      IF(IBUDUN.GT.0) THEN
         IBDCHO=1
         BUDFIL=FILNAM(IBUDUN)
      END IF
C
      NBDOPT=0
C  Determine initial choices for the budget file for each option
      DO 26 I=1,39
      IF(IUNIT(I).LE.0 .OR.
     1               (I.NE.1  .AND. I.NE.2  .AND. I.NE.3  .AND.
     2                I.NE.4  .AND. I.NE.5  .AND. I.NE.7  .AND.
     3                I.NE.8  .AND. I.NE.16 .AND. I.NE.18 .AND.
     4                I.NE.20 .AND. I.NE.23)) GO TO 26
      NBDOPT=NBDOPT+1
      CFTYP(NBDOPT)=FILTYP(IUNIT(I))
      IF(IUNIT2(I).EQ.-1) THEN
         CVAL(NBDOPT)='PRINT'
      ELSE IF(IUNIT2(I).GT.0) THEN
         CVAL(NBDOPT)=FILNAM(IUNIT2(I))
      ELSE
         CVAL(NBDOPT)=' '
      END IF
26    CONTINUE
C
C  Load the dialog
      CALL WDialogLoad(OUTPUT_FILES_DIALOG)
      CALL WMessageEnable(FieldChanged,Enabled)
C
C  Set initial values
      CALL WDialogPutInteger(OUTPUT_FILES_IHEDFM,IHEDFM)
      CALL WDialogPutInteger(OUTPUT_FILES_IDDNFM,IDDNFM)
      CALL WDialogPutString(OUTPUT_FILES_HDFILE,HEDFIL)
      CALL WDialogPutString(OUTPUT_FILES_DDFILE,DDNFIL)
      CALL WDialogPutString(OUTPUT_FILES_BOFILE,BOUFIL)
      CALL WDialogPutString(OUTPUT_FILES_CBOUFM,CBOUFM)
      IF(LBHDSV.EQ.0) THEN
         CALL WDialogPutRadioButton(HED_BUT_UNLABELED)
      ELSE
         CALL WDialogPutRadioButton(HED_BUT_LABELED)
      END IF
      IF(LBDDSV.EQ.0) THEN
         CALL WDialogPutRadioButton(DDN_BUT_UNLABELED)
      ELSE
         CALL WDialogPutRadioButton(DDN_BUT_LABELED)
      END IF
      IF(LBBOSV.EQ.0) THEN
         CALL WDialogPutRadioButton(BOU_BUT_UNLABELED)
      ELSE
         CALL WDialogPutRadioButton(BOU_BUT_LABELED)
      END IF
      IF(CHEDFM.EQ.'(BINARY)') THEN
         IHDBNAS=1
         CALL WDialogPutString(OUTPUT_FILES_CHEDFM,' ')
         CALL WDialogPutRadioButton(OUTPUT_FILES_HDBINARY)
      ELSE
         IHDBNAS=2
         CALL WDialogPutString(OUTPUT_FILES_CHEDFM,CHEDFM)
         CALL WDialogPutRadioButton(OUTPUT_FILES_HDASCII)
      END IF
      IF(CDDNFM.EQ.'(BINARY)') THEN
         IDDBNAS=1
         CALL WDialogPutString(OUTPUT_FILES_CDDNFM,' ')
         CALL WDialogPutRadioButton(OUTPUT_FILES_DDBINARY)
      ELSE
         IDDBNAS=2
         CALL WDialogPutString(OUTPUT_FILES_CDDNFM,CDDNFM)
         CALL WDialogPutRadioButton(OUTPUT_FILES_DDASCII)
      END IF
      CALL WDialogPutString(OUTPUT_FILES_CBCFILE,BUDFIL)
      CALL WGridRows(OUTPUT_FILES_CBCNAME_GRID,NBDOPT)
      IF(NBDOPT.GT.0) THEN
         CALL WGridPutString(OUTPUT_FILES_CBCNAME_GRID,1,CFTYP,NBDOPT)
         CALL WGridPutString(OUTPUT_FILES_CBCNAME_GRID,2,CVAL,NBDOPT)
      END IF
      IF(IBUDUN.GT.0) THEN
         IBDALCH=1
         CALL WDialogPutRadioButton(OUTPUT_FILES_ALLTOONE)
      ELSE
         IBDALCH=2
         CALL WDialogPutRadioButton(OUTPUT_FILES_CHOOSE)
      END IF
      IF(IBDOPT.EQ.1) THEN
         CALL WDialogPutRadioButton(OUTPUT_FILES_ORIGINAL)
      ELSE
         CALL WDialogPutRadioButton(OUTPUT_FILES_COMPACT)
      END IF
C
C  Disable some fields if MODFLOW-88
C  Aways save using word output control
C      IF(MODOUT.EQ.0) THEN
C         CALL WDialogFieldState(OUTPUT_FILES_CHEDFM,Disabled)
C         CALL WDialogFieldState(OUTPUT_FILES_HDBINARY,Disabled)
C         CALL WDialogFieldState(OUTPUT_FILES_HDASCII,Disabled)
C         CALL WDialogFieldState(OUTPUT_FILES_CDDNFM,Disabled)
C         CALL WDialogFieldState(OUTPUT_FILES_DDBINARY,Disabled)
C         CALL WDialogFieldState(OUTPUT_FILES_DDASCII,Disabled)
C         CALL WDialogFieldState(OUTPUT_FILES_COMPACT,Disabled)
C         CALL WDialogFieldState(OUTPUT_FILES_ORIGINAL,Disabled)
C      END IF

      CALL WDialogShow(-1,50,0,SemiModeless)
C
C  Beginning of message loop -- disable/enable fields as appropriate
50    IF(IHDBNAS.EQ.1) THEN
         CALL WDialogFieldState(OUTPUT_FILES_CHEDFM,Disabled)
         CALL WDialogFieldState(HED_BUT_UNLABELED,Disabled)
         CALL WDialogFieldState(HED_BUT_LABELED,Disabled)
      ELSE
         CALL WDialogFieldState(OUTPUT_FILES_CHEDFM,Enabled)
         CALL WDialogFieldState(HED_BUT_UNLABELED,Enabled)
         CALL WDialogFieldState(HED_BUT_LABELED,Enabled)
      END IF
      IF(IDDBNAS.EQ.1) THEN
         CALL WDialogFieldState(OUTPUT_FILES_CDDNFM,Disabled)
         CALL WDialogFieldState(DDN_BUT_UNLABELED,Disabled)
         CALL WDialogFieldState(DDN_BUT_LABELED,Disabled)
      ELSE
         CALL WDialogFieldState(OUTPUT_FILES_CDDNFM,Enabled)
         CALL WDialogFieldState(DDN_BUT_UNLABELED,Enabled)
         CALL WDialogFieldState(DDN_BUT_LABELED,Enabled)
      END IF
      IF(IBDALCH.EQ.1) THEN
         CALL WDialogFieldState(OUTPUT_FILES_CBCFILE,Enabled)
         CALL WDialogFieldState(OUTPUT_FILES_CBCNAME_GRID,Disabled)
      ELSE
         CALL WDialogFieldState(OUTPUT_FILES_CBCNAME_GRID,Enabled)
         CALL WDialogFieldState(OUTPUT_FILES_CBCFILE,Disabled)
      END IF
      CALL WMessage(ITYPE,MESSAGE)
C
C  Act upon field changes
      IF(ITYPE.EQ.FieldChanged) THEN
         CALL WDialogGetRadioButton(OUTPUT_FILES_HDBINARY,IHDBNAS)
         CALL WDialogGetRadioButton(OUTPUT_FILES_DDBINARY,IDDBNAS)
         CALL WDialogGetRadioButton(OUTPUT_FILES_ALLTOONE,IBDALCH)
C
C  Act upon pushbutton (OK is only one)
      ELSE IF(ITYPE.EQ.PushButton) THEN
C
C  Check for OK
         IF(MESSAGE%VALUE1.EQ.IDOK) THEN
C  Get print formats
            CALL WDialogGetInteger(OUTPUT_FILES_IHEDFM,IHEDFM)
            CALL WDialogGetInteger(OUTPUT_FILES_IDDNFM,IDDNFM)
C  Get head file
            CALL WDialogGetString(OUTPUT_FILES_HDFILE,HEDFIL)
            CALL USTLFT(HEDFIL,78)
            IF(IUCASE.NE.0) CALL USTRUC(HEDFIL,78)
            IF(HEDFIL.EQ.' ') THEN
               IF(IUCASE.NE.0) HEDFIL=DSNAME(1:NDSNAM)//'.HED'
               IF(IUCASE.EQ.0) HEDFIL=DSNAME(1:NDSNAM)//'.hed'
            END IF
C  Get Drawdown file
            CALL WDialogGetString(OUTPUT_FILES_DDFILE,DDNFIL)
            CALL USTLFT(DDNFIL,78)
            IF(IUCASE.NE.0) CALL USTRUC(DDNFIL,78)
            IF(DDNFIL.EQ.' ') THEN
               IF(IUCASE.NE.0) DDNFIL=DSNAME(1:NDSNAM)//'.DDN'
               IF(IUCASE.EQ.0) DDNFIL=DSNAME(1:NDSNAM)//'.ddn'
            END IF
C  Get IBOUND file
            CALL WDialogGetString(OUTPUT_FILES_BOFILE,BOUFIL)
            CALL USTLFT(BOUFIL,78)
            IF(IUCASE.NE.0) CALL USTRUC(BOUFIL,78)
            IF(BOUFIL.EQ.' ') THEN
               IF(IUCASE.NE.0) BOUFIL=DSNAME(1:NDSNAM)//'.BOU'
               IF(IUCASE.EQ.0) BOUFIL=DSNAME(1:NDSNAM)//'.bou'
            END IF
C  Get head save format
            IF(IHDBNAS.EQ.1) THEN
               CHEDFM='(BINARY)'
            ELSE
               CALL WDialogGetRadioButton(HED_BUT_UNLABELED,LBHDSV)
               LBHDSV=LBHDSV-1
               CALL WDialogGetString(OUTPUT_FILES_CHEDFM,CHEDFM)
               CALL FMTCHK(CHEDFM,IERR)
               IF(IERR.NE.0) THEN
                  CALL WDialogSelect(OUTPUT_FILES_DIALOG)
                  GO TO 50
               END IF
            END IF
C  Get drawdown save format
            IF(IDDBNAS.EQ.1) THEN
               CDDNFM='(BINARY)'
            ELSE
               CALL WDialogGetRadioButton(DDN_BUT_UNLABELED,LBDDSV)
               LBDDSV=LBDDSV-1
               CALL WDialogGetString(OUTPUT_FILES_CDDNFM,CDDNFM)
               CALL FMTCHK(CDDNFM,IERR)
               IF(IERR.NE.0) THEN
                  CALL WDialogSelect(OUTPUT_FILES_DIALOG)
                  GO TO 50
               END IF
            END IF
C Get IBOUND save format
            CALL WDialogGetRadioButton(BOU_BUT_UNLABELED,LBBOSV)
            LBBOSV=LBBOSV-1
            CALL WDialogGetString(OUTPUT_FILES_CBOUFM,CBOUFM)
            CALL FMTCHK(CBOUFM,IERR)
            IF(IERR.NE.0) THEN
               CALL WDialogSelect(OUTPUT_FILES_DIALOG)
               GO TO 50
            END IF
C  Check for valid head and drawdown and IBOUND files
            FTYP='DATA'
            IF(CHEDFM.EQ.'(BINARY)') FTYP='DATA(BINARY)'
            CALL FNMSV3(HEDFIL,IUTMP,FTYP,IUNIT(12),0)
            IF(IUTMP.LE.0) THEN
               CALL WDialogSelect(OUTPUT_FILES_DIALOG)
               GO TO 50
            END IF
            IHEDUN=IUTMP
            FTYP='DATA'
            IF(CDDNFM.EQ.'(BINARY)') FTYP='DATA(BINARY)'
            CALL FNMSV3(DDNFIL,IUTMP,FTYP,IUNIT(12),0)
            IF(IUTMP.LE.0) THEN
               CALL WDialogSelect(OUTPUT_FILES_DIALOG)
               GO TO 50
            END IF
            IDDNUN=IUTMP
            FTYP='DATA'
            CALL FNMSV3(BOUFIL,IUTMP,FTYP,IUNIT(12),0)
            IF(IUTMP.LE.0) THEN
               CALL WDialogSelect(OUTPUT_FILES_DIALOG)
               GO TO 50
            END IF
            IBOUUN=IUTMP
C  Get BUDFIL
            CALL WDialogGetString(OUTPUT_FILES_CBCFILE,BUDFIL)
            CALL USTLFT(BUDFIL,78)
            IF(IUCASE.NE.0) CALL USTRUC(BUDFIL,78)
            IF(IBDALCH.EQ.1) THEN
C  CBC "ONE-TO-ALL" option
               CALL FNMSV3(BUDFIL,IUTMP,'DATA(BINARY)',IUNIT(12),1)
               IF(IUTMP.LE.0) THEN
                  CALL WDialogSelect(OUTPUT_FILES_DIALOG)
                  GO TO 50
               END IF
               IBUDUN=IUTMP
            ELSE
C  CBC "CHOOSE" option
               IBUDUN=0
               IF(NBDOPT.GT.0) THEN
C  Get the budget file name for each package
                  CALL WGridGetString(OUTPUT_FILES_CBCNAME_GRID,2,
     1                  CVAL,NBDOPT)
                  N=0
                  DO 28 I=1,39
                  IF(IUNIT(I).LE.0 .OR.
     1               (I.NE.1  .AND. I.NE.2  .AND. I.NE.3  .AND.
     2                I.NE.4  .AND. I.NE.5  .AND. I.NE.7  .AND.
     3                I.NE.8  .AND. I.NE.16 .AND. I.NE.18 .AND.
     4                I.NE.20 .AND. I.NE.23)) GO TO 28
                  N=N+1
                  CTMP=CVAL(N)
                  CALL USTLFT(CTMP,78)
                  IF(IUCASE.NE.0) CALL USTRUC(CTMP,78)
                  IF(CTMP.EQ.'PRINT' .OR. CTMP.EQ.'print') THEN
                     IUNIT2(I)=-1
                  ELSE IF(CTMP.EQ.' ') THEN
                     IUNIT2(I)=0
                  ELSE
                     CALL FNMSV3(CTMP,IUTMP,'DATA(BINARY)',IUNIT(12),1)
                     IF(IUTMP.LE.0) THEN
                        CALL WDialogSelect(OUTPUT_FILES_DIALOG)
                        GO TO 50
                     END IF
                     IUNIT2(I)=IUTMP
                  END IF
28                CONTINUE
               END IF
            END IF
            CALL WDialogGetRadioButton(OUTPUT_FILES_COMPACT,IOPT)
            IF(IOPT.EQ.1) THEN
               IBDOPT=2
            ELSE
               IBDOPT=1
            END IF
C  Unload the files dialog
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(OUTPUT_FILES_DIALOG)
            RETURN
         END IF
      END IF
      GO TO 50
C
      END
      SUBROUTINE EDTIM(IMETH,ILIST,LAYOCF,TITLE,ILIM)
C     ******************************************************************
C     Get times at which output will occur
C     ******************************************************************
      USE WINTERACTER
      INCLUDE 'mfi2kwnt.inc'
      INCLUDE 'mfi2k.inc'
      CHARACTER*(*) TITLE
      TYPE(WIN_MESSAGE)   :: MESSAGE
      COMMON /PERCOM/PERLEN(MXPER),NSTP(MXPER),TSMULT(MXPER),
     1               ISSFLG(MXPER)
      DIMENSION ILIST(17,MXSCRN)
      CHARACTER*10 CPER(MXSCRN),CSTEP(MXSCRN),CM,CL
      CHARACTER*60 CBUF(MXSCRN)
      CHARACTER*80 LINE
      CHARACTER*50 CTXT(1)
C     ------------------------------------------------------------------
C
C  Initialize screen
26    CALL WDialogLoad(OUTPUT_TIMES_DIALOG)
      IF(ILIM.NE.0) THEN
         CALL WDialogFieldState(OUTPUT_TIMES_NONE,Disabled)
         CALL WDialogFieldState(OUTPUT_TIMES_END,Disabled)
      END IF
      CALL WMessageEnable(FieldChanged,Enabled)
      CALL WDialogPutString(OUTPUT_TIMES_TITLE,TITLE)
      CALL WGridRows(OUTPUT_TIME_LIST,MXSCRN)
C
C  Set initial values
      IF(IMETH.EQ.1) THEN
         CALL WDialogPutRadioButton(OUTPUT_TIMES_NONE)
      ELSE IF(IMETH.EQ.2) THEN
         CALL WDialogPutRadioButton(OUTPUT_TIMES_END)
      ELSE IF(IMETH.EQ.3) THEN
         CALL WDialogPutRadioButton(OUTPUT_TIMES_SP)
      ELSE IF(IMETH.EQ.4) THEN
         CALL WDialogPutRadioButton(OUTPUT_TIMES_ALL)
      ELSE IF(IMETH.EQ.5) THEN
         CALL WDialogPutRadioButton(OUTPUT_TIMES_LIST)
      END IF
C
C  Define initial values for List of Times
      N=0
      DO 20 NLIST=1,MXSCRN
      M=ILIST(1,NLIST)
      L=ILIST(2,NLIST)
      IF(M.LT.1 .OR. M.GT.NPER .OR. L.LT.1 .OR. L.GT.NSTP(M)) GO TO 20
      N=N+1
      WRITE(CM,*) M
      WRITE(CL,*) L
      CPER(N)=CM
      CSTEP(N)=CL
      IF(LAYOCF.GT.0) THEN
         CALL CHRLAY(ILIST,NLIST,LINE)
         CBUF(N)=LINE
      ELSE
         CBUF(N)=' '
      END IF
20    CONTINUE
      IF(N.LT.MXSCRN) THEN
         DO 25 L=N+1,MXSCRN
         CPER(L)=' '
         CSTEP(L)=' '
         CBUF(L)=' '
25       CONTINUE
      END IF
      CALL WGridPutString(OUTPUT_TIME_LIST,1,CPER,MXSCRN)
      CALL WGridPutString(OUTPUT_TIME_LIST,2,CSTEP,MXSCRN)
      CALL WGridPutString(OUTPUT_TIME_LIST,3,CBUF,MXSCRN)
      IF(LAYOCF.LE.0) CALL WGridState(OUTPUT_TIME_LIST,3,DialogReadOnly)
C
C  Activate screen
      CALL WDialogShow(-1,50,0,SemiModeless)
50    IF(IMETH.NE.5) THEN
         CALL WDialogFieldState(OUTPUT_TIME_LIST,Disabled)
      ELSE
         CALL WDialogFieldState(OUTPUT_TIME_LIST,Enabled)
      END IF
      CALL WMessage(ITYPE,MESSAGE)
C
C  Act upon field changes
      IF(ITYPE.EQ.FieldChanged) THEN
         CALL WDialogGetRadioButton(OUTPUT_TIMES_NONE,IMNEW)
         IF(IMNEW.NE.IMETH) THEN
            IMETH=IMNEW
         END IF
C
C  Act upon pushbutton (OK is only one)
      ELSE IF(ITYPE.EQ.PushButton) THEN
C
C  Check for OK
         IF(MESSAGE%VALUE1.EQ.IDOK) THEN
C
C  Process values if LIST is selected
            IF(IMETH.EQ.5) THEN
               NNN=MXSCRN
               CALL WGridGetString(OUTPUT_TIME_LIST,1,CPER,NNN)
               CALL WGridGetString(OUTPUT_TIME_LIST,2,CSTEP,NNN)
               IF(LAYOCF.GT.0)
     1      CALL WGridGetString(OUTPUT_TIME_LIST,3,CBUF,NNN)
               N=0
               IREJEC=0
               DO 30 L=1,MXSCRN
               READ(CPER(L),'(I10)',ERR=51) KPER
               GO TO 52
51             KPER=0
52             IF(KPER.GT.0 .AND. KPER.LE.NPER) THEN
                  READ(CSTEP(L),'(I10)',ERR=53) KSTP
                  GO TO 54
53                KSTP=0
54                IF(KSTP.GT.0 .AND. KSTP.LE.NSTP(KPER)) THEN
                     N=N+1
                     ILIST(1,N)=KPER
                     ILIST(2,N)=KSTP
                     IF(LAYOCF.GT.0) THEN
                        LINE=CBUF(L)
                        CALL INTLAY(LINE,N,ILIST)
                     END IF
                  ELSE
                     IREJEC=IREJEC+1
                  END IF
               ELSE
                  IF(KPER.GT.0) IREJEC=IREJEC+1
               END IF
30             CONTINUE
C  Tell user if some of the times were rejected because they were outside
C  the range of stress periods and time steps.
               IF(IREJEC.GT.0) THEN
                 CTXT(1)='One or more invalid output times were ignored'
                  CALL TXTLOG(CTXT,1)
               END IF
C  Fill in unused values in the list
               CALL WDialogSelect(OUTPUT_TIMES_DIALOG)
               IF(N.LT.MXSCRN) THEN
                  DO 35 M=N+1,MXSCRN
                  ILIST(1,M)=0
                  ILIST(2,M)=0
35                CONTINUE
               END IF
               CALL LSTSRT(ILIST,MXSCRN,N)
            END IF
            CALL WMessageEnable(FieldChanged,Disabled)
            CALL WDialogUnload(OUTPUT_TIMES_DIALOG)
            RETURN
         END IF
      END IF
      GO TO 50
C
C
      END
